on error resume next
Set WSHShell = WScript.CreateObject( "WScript.Shell" )
Set fso = CreateObject("Scripting.FileSystemObject")
Set WshSysEnv = WshShell.Environment("PROCESS")
Dim Scriptpath: Scriptpath = fso.GetParentFolderName(WScript.ScriptFullName)
'Arguments:Logfolder/Logfile, Comment:
'Reports: Displaydrivers and Version
'Exports: Displaydrivers and Version
'Returns: Number of graphiccards
' =====================================================================================
' Arguments
' =====================================================================================
If WScript.Arguments.Count >= 1   Then
Dim objArgs : set objArgs = Wscript.Arguments
Dim Logfolder

For iParam = 0 To WScript.Arguments.Count -1
 Select Case ucase(objArgs(iParam))
      Case "/SILENT", "SILENT", "/S"
            SilentMode = True
      Case "/SUPERSILENT", "SUPERSILENT", "/QB-"
            SuperSilentMode = True
            SilentMode = True
      Case "/SHOW"
      			SuperSilentMode = False
      Case "UAC"
      		AdminMode = True
      Case Else

		IF fso.folderexists(objArgs(iParam)) then
			LogFolder =  objArgs(iParam)
			SuperSilentMode = True
		elseIF fso.fileexists(objArgs(iParam)) then
			Logfile =  objArgs(iParam)
			SuperSilentMode = True
		ELSE

			if left(objArgs(iParam),8) = "COMMENT:" then strExportComment= mid(objArgs(iParam),9)
		end if
 End Select
 cmdarg = cmdarg & " " & chr(34) & objArgs(iParam) & chr(34)
Next
End if

' =====================================================================================
' Setting logfile if not set
' =====================================================================================

If Not fso.folderexists(logfolder) Then logfolder = WshSysEnv("Public") & "\Documents\Cadcraft_SystemLogs"
If Not fso.folderexists(logfolder) Then fso.createfolder(logfolder)
if LogFile = "" then Logfile = logfolder & "\" & WScript.ScriptName & "[" & Replace(Replace(date & " "  & time, ":", "."),"/","-") & "]_Log.htm"

' =====================================================================================
' =====================================================================================
' Logfunction:
' =====================================================================================
' =====================================================================================



'============================================================================
'DisplayDriver
'============================================================================

'on error resume next
DisplayDriverTag = ""
strComputer = "."
Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")

dim  winmgt, SNSet, Name, Description, Size_Speed, VideoProcessor, VideoModeDescription
winmgt = "winmgmts:{impersonationLevel=impersonate}!//"
Set SNSet = GetObject(winmgt).InstancesOf("Win32_VideoController")

for each objItem in SNSet
	NumberOfCards = NumberOfCards + 1
	Name = objItem.Name
	Description = objItem.Description
	Size_Speed = Int( ( objItem.AdapterRAM + 524288 ) / 1048576 ) & " Mb"
	VideoProcessor = objItem.VideoProcessor
	VideoModeDescription = objItem.VideoModeDescription
'	oIE_Document_write"<br><B>Name: </B>" & Name
'	oIE_Document_write"<br><B>Description: </B>" & Description
'	oIE_Document_write"<br><B>Size_Speed: </B>" & Size_Speed
'	oIE_Document_write"<br><B>VideoProcessor: </B>" & VideoProcessor
'	oIE_Document_write"<br><B>VideoModeDescription: </B>" & VideoModeDescription
'	oIE_Document_write"<br><B>Driverversion: </B>" & objItem.Driverversion
	DisplayName = objItem.Name
	ParantPos=instr(DisplayName, "(")
	if ParantPos > 0 then
		DisplayName = mid(DisplayName,1,ParantPos -1)
	else
		DisplayName = mid(DisplayName,1,30)

	End if

	DisplayDriverTag = DisplayDriverTag & "/" & DisplayName & "[" & objItem.Driverversion & "]"


Next
DisplayDriverTag =  mid(DisplayDriverTag,2)
oIE_Document_write "<br>" & DisplayDriverTag
Dim SqlArray(2)


SqlArray(1) = "Win32_VideoController"
SqlArray(2) = "Win32_VideoConfiguration"


Dim counter, DisplayWMI
Counter = 1
if DisplayWMI = True then

For Counter = 1 to ubound(SqlArray)
Dim objClass, objProperty, strHTML, objItemValue

   oIE_Document_write  "<TABLE border=1><TR><TD colspan=2>" & counter & ": " & SqlArray(counter) & "</TD></TR>"
   Set colSettings = objWMIService.ExecQuery(SqlArray(counter))

   Set objWMIService = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")
   Set objClass = objWMIService.Get(SqlArray(counter))

	Set colItems = objWMIService.ExecQuery("Select * from " & SqlArray(counter),,48)
	For Each objItem in colItems

	   For Each objProperty in objClass.properties_

	    ExecuteGlobal "objItemValue ="   &   "objItem." & objProperty.name

	      if objItemValue <> "" then oIE_Document_write  "<TR><TD>" & objProperty.name &   "</TD><TD>" & objItemValue &  "</TD></TR>"
           Next



	Next
	oIE_Document_write"</TABLE>"



Next

End if

ExitCode = NumberOfCards

' =====================================================================================
' Creates a Excel Export file
' =====================================================================================
ExportVBS = fso.GetParentFolderName(fso.GetParentFolderName(WScript.ScriptFullName)) & "\Export_Log_result.vbs"


if fso.fileexists(ExportVBS) then


	strField = "DisplayDriver"
	strValue = DisplayDriverTag
	wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true


End if



' =====================================================================================
' Open logfile when finish unless running in SuperSilentMode
' =====================================================================================
if fso.fileexists(Logfile) and SuperSilentMode=False then wshshell.run chr(34) & Logfile & chr(34),1,false


' =====================================================================================
' Exit with error code
' =====================================================================================

if Exitcode <> "" then
  if SuperSilentMode = false then msgbox exitcode
  wscript.quit(exitcode)

elseIf Err.Number <> 0 Then

  oIE_Document_write "Error in " & WScript.ScriptName & ":"  & Err.Description
  Err.Clear
  wscript.quit(-1 * err.number)
 else
  wscript.quit
End If




' =====================================================================================
' =====================================================================================
' =====================================================================================
' Function Definitions
' =====================================================================================
' =====================================================================================
' =====================================================================================

' =====================================================================================
' Save2HTMLFile
' =====================================================================================

Function oIE_Document_write (strInput2)
on error resume next
	 Set oSaveToFile = FSO.OpenTextFile(Logfile, 8, true)
	 oSaveToFile.WriteLine(strInput2)
	 oSaveToFile.Close
End function