on error resume next
Set WSHShell = WScript.CreateObject( "WScript.Shell" )
Set fso = CreateObject("Scripting.FileSystemObject")
Set WshSysEnv = WshShell.Environment("PROCESS")
Dim Scriptpath: Scriptpath = fso.GetParentFolderName(WScript.ScriptFullName)
'Arguments:Logfolder/Logfile, Comment:
'Reports: Reg_Access_HKCR, Reg_Access_HKLM, Reg_Access_SYSTEM
'Exports: Reg_Access: Reg_Access_HKCR / Reg_Access_HKLM / Reg_Access_SYSTEM
'Returns: 0
' =====================================================================================
' Arguments
' =====================================================================================
If WScript.Arguments.Count >= 1   Then
Dim objArgs : set objArgs = Wscript.Arguments
Dim Logfolder

For iParam = 0 To WScript.Arguments.Count -1
 Select Case ucase(objArgs(iParam))
      Case "/SILENT", "SILENT", "/S"
            SilentMode = True
      Case "/SUPERSILENT", "SUPERSILENT", "/QB-"
            SuperSilentMode = True
            SilentMode = True
      Case "/SHOW"
      			SuperSilentMode = False
      Case "UAC"
      		AdminMode = True
      Case Else

		IF fso.folderexists(objArgs(iParam)) then
			LogFolder =  objArgs(iParam)
			SuperSilentMode = True
		elseIF fso.fileexists(objArgs(iParam)) then
			Logfile =  objArgs(iParam)
			SuperSilentMode = True
		ELSE

			if left(objArgs(iParam),8) = "COMMENT:" then strExportComment= mid(objArgs(iParam),9)
		end if
 End Select
 cmdarg = cmdarg & " " & chr(34) & objArgs(iParam) & chr(34)
Next
End if

' =====================================================================================
' Setting logfile if not set
' =====================================================================================

If Not fso.folderexists(logfolder) Then logfolder = WshSysEnv("Public") & "\Documents\Cadcraft_SystemLogs"
If Not fso.folderexists(logfolder) Then fso.createfolder(logfolder)
if LogFile = "" then Logfile = logfolder & "\" & WScript.ScriptName & "[" & Replace(Replace(date & " "  & time, ":", "."),"/","-") & "]_Log.htm"

' =====================================================================================
' =====================================================================================
' Programcode
' =====================================================================================
' =====================================================================================

' =====================================================================================
' Registry Access
' =====================================================================================
oIE_Document_write "<B>Checking Registry Access - HKCR -  </B>"
	CheckRegAccess_HKCR_Status = CheckRegAccess_HKCR
	if CheckRegAccess_HKCR_Status  = False then
		oIE_Document_write "<FONT color='red' FACE='verdana,arial,helvetica' >Error:</Font> User have not full access to the registry<br>"
		exitcode = exitcode + 1

		ErrorFound = True
	else
		oIE_Document_write "<FONT color='green'>Registry Access = OK<br></font>"

	end if
oIE_Document_write "<B>Checking Registry Access - HKLM -  </B>"
CheckRegAccess_HKLM_Status = CheckRegAccess_HKLM
	if CheckRegAccess_HKLM_Status = False then
		oIE_Document_write "<FONT color='red' FACE='verdana,arial,helvetica' >Error:</Font> User have not full access to the registry<br>"
		ErrorFound = True
		exitcode = exitcode + 2
	else
		oIE_Document_write "<FONT color='green'>Registry Access = OK<br></font>"
	end if
oIE_Document_write "<B>Checking Registry Access - SYSTEM - </B>"
	CheckRegAccess_SYSTEM_Status = CheckRegAccess_SYSTEM
	if CheckRegAccess_SYSTEM_Status = False then
		oIE_Document_write "<FONT color='red' FACE='verdana,arial,helvetica' >Error:</Font> User have not full access to the registry<br>"
		ErrorFound = True
		exitcode = exitcode + 4
	else
		oIE_Document_write "<FONT color='green'>Registry Access = OK<br></font>"
	end if

' =====================================================================================
' Creates a Excel Export file
' =====================================================================================
ExportVBS = fso.GetParentFolderName(fso.GetParentFolderName(WScript.ScriptFullName)) & "\Export_Log_result.vbs"


if fso.fileexists(ExportVBS) then

	strField = "Reg_Access"
	strValue = "HKCR:" & cstr(CheckRegAccess_HKCR_Status) & " / " & "HKLM:" & cstr(CheckRegAccess_HKLM_Status) & " / " & "HKCR:" & cstr(CheckRegAccessSYSTEM_Status)
	wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true

'	strField = "Reg_Access_HKCR"
'	strValue = cstr(CheckRegAccess_HKCR_Status)
'	wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true
'
'	strField = "Reg_Access_SYSTEM"
'	strValue = cstr(CheckRegAccess_SYSTEM_Status)
'	wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true
'
'	strField = "Reg_Access_HKLM"
'	strValue = cstr(CheckRegAccess_HKLM_Status)
'	wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true

End if


' =====================================================================================
' Open logfile when finish unless running in SuperSilentMode
' =====================================================================================
if fso.fileexists(Logfile) and SuperSilentMode=False then wshshell.run chr(34) & Logfile & chr(34),1,false


' =====================================================================================
' Exit with error code
' =====================================================================================

if Exitcode <> "" then
  if SuperSilentMode = false then msgbox exitcode
  wscript.quit(exitcode)

elseIf Err.Number <> 0 Then

  oIE_Document_write "Error in " & WScript.ScriptName & ":"  & Err.Description
  Err.Clear
  wscript.quit(-1 * err.number)
 else
  wscript.quit
End If




' =====================================================================================
' =====================================================================================
' =====================================================================================
' Function Definitions
' =====================================================================================
' =====================================================================================
' =====================================================================================

Function CheckRegAccess_SYSTEM ()
' Create constants for access rights and registry hive
const KEY_QUERY_VALUE = &H0001
const KEY_SET_VALUE = &H0002
const KEY_CREATE = &H0032
const KEY_CREATE_SUB_KEY = &H0004
const KEY_DELETE = &H00010000
const HKEY_LOCAL_MACHINE = &H80000002
Const DELETE = &H00010000

Dim strComputer, objReg, strKeyPath, bHasAccessRight
strComputer = "."

Set objReg=GetObject("winmgmts:"_
   & "{impersonationLevel=impersonate}!\\" &_
   strComputer & "\root\default:StdRegProv")
strKeyPath = "SYSTEM\CurrentControlSet"

bHasAccessRight = False

' Does the account under which the script runs have the
'    right to query the SYSTEM\CurrentControlSet key
objReg.CheckAccess HKEY_LOCAL_MACHINE, strKeyPath,DELETE, bHasAccessRight
If bHasAccessRight = True Then
   'oIE_Document_write  "User is  RegAdmin"
   CheckRegAccess_SYSTEM = True
Else
   'oIE_Document_write "<FONT color='red' FACE='verdana,arial,helvetica' >Warning:</Font> User have not full access to the registry"
   CheckRegAccess_SYSTEM = False
End If

End function
Function CheckRegAccess_HKCR()
' Create constants for access rights and registry hive
const KEY_QUERY_VALUE = &H0001
const KEY_SET_VALUE = &H0002
const KEY_CREATE = &H0032
const KEY_CREATE_SUB_KEY = &H0004
const KEY_DELETE = &H00010000
Const HKEY_CLASSES_ROOT = &H80000000
Const HKEY_CURRENT_USER = &H80000001
Const HKEY_LOCAL_MACHINE = &H80000002
Const HKEY_USERS = &H80000003
Const DELETE = &H00010000

Dim strComputer, objReg, strKeyPath, bHasAccessRight
strComputer = "."

Set objReg=GetObject("winmgmts:"_
   & "{impersonationLevel=impersonate}!\\" &_
   strComputer & "\root\default:StdRegProv")
strKeyPath = "folder"

bHasAccessRight = False

' Does the account under which the script runs have the
'    right to query the SYSTEM\CurrentControlSet key
objReg.CheckAccess HKEY_CLASSES_ROOT, strKeyPath,DELETE, bHasAccessRight
If bHasAccessRight = True Then
   'oIE_Document_write  "User is  RegAdmin"
   CheckRegAccess_HKCR = True
Else
   'oIE_Document_write "<FONT color='red' FACE='verdana,arial,helvetica' >Warning:</Font> User have not full access to the registry"
   CheckRegAccess_HKCR = False
End If

End function

Function CheckRegAccess_HKLM ()
' Create constants for access rights and registry hive
const KEY_QUERY_VALUE = &H0001
const KEY_SET_VALUE = &H0002
const KEY_CREATE = &H0032
const KEY_CREATE_SUB_KEY = &H0004
const KEY_DELETE = &H00010000
const HKEY_LOCAL_MACHINE = &H80000002
Const DELETE = &H00010000

Dim strComputer, objReg, strKeyPath, bHasAccessRight
strComputer = "."

Set objReg=GetObject("winmgmts:"_
   & "{impersonationLevel=impersonate}!\\" &_
   strComputer & "\root\default:StdRegProv")
strKeyPath = "Software"

bHasAccessRight = False

' Does the account under which the script runs have the
'    right to query the SYSTEM\CurrentControlSet key
objReg.CheckAccess HKEY_LOCAL_MACHINE, strKeyPath,DELETE, bHasAccessRight
If bHasAccessRight = True Then
   'oIE_Document_write  "User is  RegAdmin"
   CheckRegAccess_HKLM = True
Else
   'oIE_Document_write "<FONT color='red' FACE='verdana,arial,helvetica' >Warning:</Font> User have not full access to the registry"
   CheckRegAccess_HKLM = False
End If

End function

Function oIE_Document_write (strInput2)
on error resume next
	 Set oSaveToFile = FSO.OpenTextFile(Logfile, 8, true)
	 oSaveToFile.WriteLine(strInput2)
	 oSaveToFile.Close
End function

