on error resume next
Set WSHShell = WScript.CreateObject( "WScript.Shell" )
Set fso = CreateObject("Scripting.FileSystemObject")
Set WshSysEnv = WshShell.Environment("PROCESS")
Dim Scriptpath: Scriptpath = fso.GetParentFolderName(WScript.ScriptFullName)
'Arguments:Logfolder/Logfile, Comment:
'Reports: UAC Not Active on Win7 - UAC ADMIN - UAC Elevated
'Exports: UAC ELEVATION
'Returns: UAC  Active on Win7 = 1 - User not UAC ADMIN = 2, Power User Not Admin =4 - UAC Not Elevated =8
' =====================================================================================
' Arguments
' =====================================================================================
If WScript.Arguments.Count >= 1   Then
Dim objArgs : set objArgs = Wscript.Arguments
Dim Logfolder

For iParam = 0 To WScript.Arguments.Count -1
 Select Case ucase(objArgs(iParam))
      Case "/SILENT", "SILENT", "/S"
            SilentMode = True
      Case "/SUPERSILENT", "SUPERSILENT", "/QB-"
            SuperSilentMode = True
            SilentMode = True
      Case "/SHOW"
      			SuperSilentMode = False
      Case "UAC"
      		AdminMode = True
      Case Else

		IF fso.folderexists(objArgs(iParam)) then
			LogFolder =  objArgs(iParam)
			SuperSilentMode = True
		elseIF fso.fileexists(objArgs(iParam)) then
			Logfile =  objArgs(iParam)
			SuperSilentMode = True
		ELSE

			if left(objArgs(iParam),8) = "COMMENT:" then strExportComment= mid(objArgs(iParam),9)
		end if
 End Select
 cmdarg = cmdarg & " " & chr(34) & objArgs(iParam) & chr(34)
Next
End if

' =====================================================================================
' Setting logfile if not set
' =====================================================================================

If Not fso.folderexists(logfolder) Then logfolder = WshSysEnv("Public") & "\Documents\Cadcraft_SystemLogs"
If Not fso.folderexists(logfolder) Then fso.createfolder(logfolder)
if LogFile = "" then Logfile = logfolder & "\" & WScript.ScriptName & "[" & Replace(Replace(date & " "  & time, ":", "."),"/","-") & "]_Log.htm"

' =====================================================================================
' =====================================================================================
' Programcode
' =====================================================================================
' =====================================================================================

' =====================================================================================
' UAC Access
' =====================================================================================

oIE_Document_write "<B>Checking UAC Settings -  </B>"
	CheckUACReply = CheckUAC
	if CheckUACReply <> ""  then
		'oIE_Document_write "<FONT color='red' FACE='verdana,arial,helvetica' >Error:</Font>  Computer have the UAC (User Account Control) Enabled: " & CheckUACReply & "<br>"
		 oIE_Document_write "<FONT color='ORANGE' FACE='verdana,arial,helvetica' >Warning: UAC Active :</Font> Current UAC (User Account Control) Settings: " & CheckUACReply & "<br>"
		'ErrorFound = True
		UserLevelTag = UserLevelTag & CheckUACReply
		exitcode = exitcode + 1
	else
		oIE_Document_write "<FONT color='green'>UAC Settings = OK<br></font>"
		UserLevelTag = UserLevelTag & CheckUACReply
	end if
'          if getUACStatus = 1 then   oIE_Document_write "<FONT color='red' FACE='verdana,arial,helvetica' >Error:</Font> You have the UAC (User Account Control) Enabled<br>"

oIE_Document_write "<B>Checking UAC Admin rights -  </B>"
	if not hasPermission("S-1-5-32-544") then
		if not hasPermission("S-1-5-32-547") then
			oIE_Document_write "<FONT color='RED' FACE='verdana,arial,helvetica' >Error: UAC Admin</Font>- User do not have Admin rights :" & "<br>"
			UserLevelTag = UserLevelTag & "[Not UAC Admin]"
			exitcode = exitcode + 2
		else
			oIE_Document_write "<FONT color='ORANGE' FACE='verdana,arial,helvetica' >Warning: UAC Admin</Font>-- User do not have Admin rights Only PowerUser:" & "<br>"
		UserLevelTag = UserLevelTag & "[Power user - Not UAC Admin ]"
		exitcode = exitcode + 4
		end if

	else
		oIE_Document_write "<FONT color='green'>UAC Admin Settings = OK<br></font>"
	end if

'Checks if the script is running elevated (UAC)
oIE_Document_write "<B>Checking UAC Elevation -  </B>"
	if not hasPermission("S-1-16-12288") then
		oIE_Document_write "<FONT color='ORANGE' FACE='verdana,arial,helvetica' >Warning: UAC Elevation</Font>- Process not elevated to admin level</Font>" & "<br>"
		UserLevelTag = UserLevelTag & "[Not Elevated]"
		exitcode = exitcode + 8
	else
		UserLevelTag = UserLevelTag & "[Elevated]"
		oIE_Document_write "<FONT color='green'>UAC Admin Elevation = OK<br></font>"

	end if



' =====================================================================================
' Creates a Excel Export file
' =====================================================================================
ExportVBS = fso.GetParentFolderName(fso.GetParentFolderName(WScript.ScriptFullName)) & "\Export_Log_result.vbs"


if fso.fileexists(ExportVBS) then

	strField = "UAC"
	strValue = UserLevelTag
	strGroup = fso.GetParentFolderName(WScript.ScriptFullName)
	wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true


End if

' =====================================================================================
' Open logfile when finish unless running in SuperSilentMode
' =====================================================================================
if fso.fileexists(Logfile) and SuperSilentMode=False then wshshell.run chr(34) & Logfile & chr(34),1,false


' =====================================================================================
' Exit with error code
' =====================================================================================

if Exitcode <> "" then
  if SuperSilentMode = false then msgbox exitcode
  wscript.quit(exitcode)

elseIf Err.Number <> 0 Then

  oIE_Document_write "Error in " & WScript.ScriptName & ":"  & Err.Description
  Err.Clear
  wscript.quit(-1 * err.number)
 else
  wscript.quit
End If




' =====================================================================================
' =====================================================================================
' =====================================================================================
' Function Definitions
' =====================================================================================
' =====================================================================================
' =====================================================================================

' =====================================================================================
' CheckUAC Access in registry
' =====================================================================================
Function CheckUAC()
on error resume next
 Dim objWMI, objItem, colItems
   Dim OSVersion, OSName, ProductType

    'Get the WMI object and query results
    Set objWMI = GetObject("winmgmts:\\.\root\cimv2")
    Set colItems = objWMI.ExecQuery("Select * from Win32_OperatingSystem",,48)

    'Get the OS version number (first two) and OS product type (server or desktop)
    For Each objItem in colItems
        OSVersion = Left(objItem.Version,3)
        ProductType = objItem.ProductType
    Next

    'Time to convert numbers into names
if OSVersion >= "6.0" then
      'msgbox "OS Vista or higher"
      UAC_Mode = wshshell.regread("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Policies\System\EnableLUA")
      UAC_Level_Admin = wshshell.regread("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Policies\System\ConsentPromptBehaviorAdmin")
      UAC_Level_User = wshshell.regread("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Policies\System\ConsentPromptBehaviorUser")
   	if  UAC_MODE = "0" then
          ADMINMODE=True


 	else
 	     CheckUAC =  "UAC=ON" & "[A" & UAC_Level_Admin & "/U" & UAC_Level_User & "]"

 	End if
End if'


End function
' =====================================================================================
' CheckUAC Access in Usergroups
' =====================================================================================

function hasPermission(permission)
	dim objShell, objWhoAmI, objWhoAmIOutput, strWhoAmIOutput
	Set objShell = CreateObject("WScript.Shell")
	Set objWhoAmI = objShell.Exec("whoami /groups")
	Set objWhoAmIOutput = objWhoAmI.StdOut
	strWhoAmIOutput = objWhoAmIOutput.ReadAll
	hasPermission = InStr(1, strWhoAmIOutput, permission, vbTextCompare) > 0
	Set objWhoAmIOutput = Nothing
	Set objWhoAmI = Nothing
	Set objShell = Nothing
end function

Function oIE_Document_write (strInput2)
on error resume next
	 Set oSaveToFile = FSO.OpenTextFile(Logfile, 8, true)
	 oSaveToFile.WriteLine(strInput2)
	 oSaveToFile.Close
End function

