on error resume next
Set WSHShell = WScript.CreateObject( "WScript.Shell" )
Set fso = CreateObject("Scripting.FileSystemObject")
Set WshSysEnv = WshShell.Environment("PROCESS")
Dim Scriptpath: Scriptpath = fso.GetParentFolderName(WScript.ScriptFullName)
'Arguments:Logfolder/Logfile, Comment:
'Reports: OS Type, CPU Typ, Execute Mode
'Exports:  OS Type, CPU Typ, Execute Mode
'Returns:  32-bit OSType =  1 +  32 bit CPU Typ = 2 +  32 Execute Mode = 4 (should alwas be 0)
' =====================================================================================
' Arguments
' =====================================================================================
If WScript.Arguments.Count >= 1   Then
Dim objArgs : set objArgs = Wscript.Arguments
Dim Logfolder

For iParam = 0 To WScript.Arguments.Count -1
 Select Case ucase(objArgs(iParam))
      Case "/SILENT", "SILENT", "/S"
            SilentMode = True
      Case "/SUPERSILENT", "SUPERSILENT", "/QB-"
            SuperSilentMode = True
            SilentMode = True
      Case "/SHOW"
      			SuperSilentMode = False
      Case "UAC"
      		AdminMode = True
      Case Else

		IF fso.folderexists(objArgs(iParam)) then
			LogFolder =  objArgs(iParam)
			SuperSilentMode = True
		elseIF fso.fileexists(objArgs(iParam)) then
			Logfile =  objArgs(iParam)
			SuperSilentMode = True
		ELSE

			if left(objArgs(iParam),8) = "COMMENT:" then strExportComment= mid(objArgs(iParam),9)
		end if
 End Select
 cmdarg = cmdarg & " " & chr(34) & objArgs(iParam) & chr(34)
Next
End if

' =====================================================================================
' Setting logfile if not set
' =====================================================================================

If Not fso.folderexists(logfolder) Then logfolder = WshSysEnv("Public") & "\Documents\Cadcraft_SystemLogs"
If Not fso.folderexists(logfolder) Then fso.createfolder(logfolder)
if LogFile = "" then Logfile = logfolder & "\" & WScript.ScriptName & "[" & Replace(Replace(date & " "  & time, ":", "."),"/","-") & "]_Log.htm"

' =====================================================================================
' =====================================================================================
' Programcode
' =====================================================================================
' =====================================================================================

CPUType = wshshell.regread("HKEY_LOCAL_MACHINE\HARDWARE\DESCRIPTION\System\CentralProcessor\0\Identifier")
if instr(1, CPUType, "64",vbtextcompare) = 0 then
	exitcode = exitcode + 1
	oIE_Document_write "<B>CPU Type: </B><FONT color='red' FACE='verdana,arial,helvetica' >" & CPUType & "</FONT><BR>"
else
	oIE_Document_write "<B>CPU Type: </B>" & CPUType& "<BR>"
End if

Dim strBit : strBit = "32":If Fso.FolderExists( FSO.GetSpecialFolder(0) & "\SysWOW64") Then strBit = "64"
if strBit = 32 then
	oIE_Document_write "<B>OS Type: </B>" & wshshell.regread("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion\ProductName")  & " <FONT color='red' FACE='verdana,arial,helvetica' >" & strBit & "-bit</FONT> <BR>"
	exitcode = exitcode + 2
else
	oIE_Document_write "<B>OS Type: </B>" & wshshell.regread("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion\ProductName")  & " " & strBit & "-bit <BR>"

end if
ExeMode = WshSysEnv("PROCESSOR_ARCHITECTURE")
if  ExeMode = "x86" then
	oIE_Document_write "<B>Execute mode: </B><FONT color='red' FACE='verdana,arial,helvetica' >" & WshSysEnv("PROCESSOR_ARCHITECTURE") & "</FONT><BR>"
	exitcode = exitcode + 4
else
	oIE_Document_write "<B>Execute mode: </B>" & WshSysEnv("PROCESSOR_ARCHITECTURE") & "<BR>"
		'oIE_Document_write "<FONT color='red' FACE='verdana,arial,helvetica' >Error:</Font>  Computer have the UAC (User Account Control) Enabled: " & CheckUACReply & "<br>"

end if
oIE_Document_write  "</CENTER>"



' =====================================================================================
' Creates a Excel Export file
' =====================================================================================
ExportVBS = fso.GetParentFolderName(fso.GetParentFolderName(WScript.ScriptFullName)) & "\Export_Log_result.vbs"


if fso.fileexists(ExportVBS) then

	strField = "OS Type"
	strValue = wshshell.regread("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion\ProductName") & strBit & "-bit"
	wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true

	strField = "CPU Type"
	strValue = wshshell.regread("HKEY_LOCAL_MACHINE\HARDWARE\DESCRIPTION\System\CentralProcessor\0\Identifier")
	wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true

	strField = "Execute Mode"
	strValue = WshSysEnv("PROCESSOR_ARCHITECTURE")
	wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true


End if
' =====================================================================================
' Open logfile when finish unless running in SuperSilentMode
' =====================================================================================
if fso.fileexists(Logfile) and SuperSilentMode=False then wshshell.run chr(34) & Logfile & chr(34),1,false


' =====================================================================================
' Exit with error code
' =====================================================================================

if Exitcode <> "" then
  if SuperSilentMode = false then msgbox exitcode
  wscript.quit(exitcode)

elseIf Err.Number <> 0 Then

  oIE_Document_write "Error in " & WScript.ScriptName & ":"  & Err.Description
  Err.Clear
  wscript.quit(-1 * err.number)
 else
  wscript.quit
End If



' =====================================================================================
' =====================================================================================
' =====================================================================================
' Function Definitions
' =====================================================================================
' =====================================================================================
' =====================================================================================


' =====================================================================================
' Saves data to log-file
' =====================================================================================

Function oIE_Document_write (strInput2)
on error resume next
	 Set oSaveToFile = FSO.OpenTextFile(Logfile, 8, true)
	 oSaveToFile.WriteLine(strInput2)
	 oSaveToFile.Close
End function
