on error resume next
Set WSHShell = WScript.CreateObject( "WScript.Shell" )
Set fso = CreateObject("Scripting.FileSystemObject")
Set WshSysEnv = WshShell.Environment("PROCESS")
Dim Scriptpath: Scriptpath = fso.GetParentFolderName(WScript.ScriptFullName)
'Arguments:Logfolder/Logfile, Comment:
'Reports:Computername, Computer Model
'Exports: Computername, Computer Model
'Returns: 0
' =====================================================================================
' Arguments
' =====================================================================================
If WScript.Arguments.Count >= 1   Then
Dim objArgs : set objArgs = Wscript.Arguments
Dim Logfolder

For iParam = 0 To WScript.Arguments.Count -1
 Select Case ucase(objArgs(iParam))
      Case "/SILENT", "SILENT", "/S"
            SilentMode = True
      Case "/SUPERSILENT", "SUPERSILENT", "/QB-"
            SuperSilentMode = True
            SilentMode = True
      Case "/SHOW"
      			SuperSilentMode = False
      Case "UAC"
      		AdminMode = True
      Case Else

		IF fso.folderexists(objArgs(iParam)) then
			LogFolder =  objArgs(iParam)
			SuperSilentMode = True
		elseIF fso.fileexists(objArgs(iParam)) then
			Logfile =  objArgs(iParam)
			SuperSilentMode = True
		ELSE

			if left(objArgs(iParam),8) = "COMMENT:" then strExportComment= mid(objArgs(iParam),9)
		end if
 End Select
 cmdarg = cmdarg & " " & chr(34) & objArgs(iParam) & chr(34)
Next
End if

' =====================================================================================
' Setting logfile if not set
' =====================================================================================

If Not fso.folderexists(logfolder) Then logfolder = WshSysEnv("Public") & "\Documents\Cadcraft_SystemLogs"
If Not fso.folderexists(logfolder) Then fso.createfolder(logfolder)
if LogFile = "" then Logfile = logfolder & "\" & WScript.ScriptName & "[" & Replace(Replace(date & " "  & time, ":", "."),"/","-") & "]_Log.htm"

' =====================================================================================
' =====================================================================================
' Programcode
' =====================================================================================
' =====================================================================================

Dim args, objWMIService_AV, colItems, objAntiVirusProduct,strcompanyName,strdisplayName,strVersionNumber,strproductState,colItems2,PathToSignedProductExe
Dim colFiles,itemFile,strRunType, strFinalMessage


'WriteIE "  AV - Security Center Settings...if FILESTREAM hangs the machine and there are AV entries then we should consider"
'WriteIE "  disabling AV or setting master.dbo.PCMXOPTIONS NOFILESTREAMSUPPORT to 'TRUE'"
Set objWMIService_AV = GetObject("winmgmts:\\.\root\SecurityCenter")
if err.number <> 0 Then
    WriteIE "      No AV registered to \root\SecurityCenter"
Else
    Set colItems = objWMIService_AV.ExecQuery("Select * from AntiVirusProduct")

    For Each objAntiVirusProduct In colItems
       ' WriteIE "AV products registered to \root\SecurityCenter"
        strcompanyName = (objAntiVirusProduct.companyName)
        strdisplayName = (objAntiVirusProduct.displayName)
        strVersionNumber = (objAntiVirusProduct.versionNumber)
        strproductState = (objAntiVirusProduct.onAccessScanningEnabled)

        'WriteIE "      companyName:    " & strcompanyName
        'WriteIE "      displayName:    " & strdisplayName
        'WriteIE "      versionNumber:  " & strVersionNumber
        'WriteIE "      onAccessScanningEnabled:    " & strproductState
	WriteIE "(1)  " & strcompanyName & " " & strdisplayName & " " & strVersionNumber    & " [State:" & strproductState & "]"

    Next

    Set objWMIService_AV = Nothing

End If

Err.Clear


Set objWMIService_AV = GetObject("winmgmts:\\.\root\SecurityCenter2")
If err.number <> 0 Then
    WriteIE "     No AV registered to \root\SecurityCenter2"
Else
    Set colItems2 = objWMIService_AV.ExecQuery("Select * from AntiVirusProduct")

    For Each objAntiVirusProduct In colItems2
        PathToSignedProductExe = Replace(objAntiVirusProduct.PathToSignedProductExe,"\","\\")
        WriteIE ("      Path " & PathToSignedProductExe)
        Set colFiles = objWMIService.ExecQuery ("Select * from CIM_Datafile Where name = '" & PathToSignedProductExe & "'",,48)
        For Each itemFile In colFiles
        	iAntiVCount = iAntiVCount +1
            strcompanyName  = (itemFile.Manufacturer)
            strVersionNumber = (itemFile.Version)
            strdisplayName = (objAntiVirusProduct.displayName)
            if (objAntiVirusProduct.ProductState = "266240" OR objAntiVirusProduct.ProductState = "266256") then
                strproductState = "Scanning Enabled"
            Elseif (objAntiVirusProduct.ProductState = "262144") Then
                strproductState = "Scanning Not Enabled"
            Else
                strproductState = "Unknown State"
            End If

           ' WriteIE "      WARNING:  AV products registered to \root\SecurityCenter2"
           ' WriteIE "      strcompanyName: " & strcompanyName
           ' WriteIE "      strdisplayName: " & strdisplayName
           ' WriteIE "      strVersionNumber:   " & strVersionNumber
           ' WriteIE "      strproductState:    " & strproductState
            WriteIE "(2)  " & strcompanyName & " " & strdisplayName & " " & strVersionNumber    & " [State:" & strproductState & "]"
			TotalAntivirusList = TotalAntivirusList  & strdisplayName & "[" & strproductState & "] / "

        Next
    Next
End If


ExitCode = iAntiVCount




' =====================================================================================
' Creates a Excel Export file
' =====================================================================================
ExportVBS = fso.GetParentFolderName(fso.GetParentFolderName(WScript.ScriptFullName)) & "\Export_Log_result.vbs"


if fso.fileexists(ExportVBS) then

	strField = "Registerd Antivirus"
	strValue = TotalAntivirusList
	wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true

End if
' =====================================================================================
' Open logfile when finish unless running in SuperSilentMode
' =====================================================================================
if fso.fileexists(Logfile) and SuperSilentMode=False then wshshell.run chr(34) & Logfile & chr(34),1,false


' =====================================================================================
' Exit with error code
' =====================================================================================

if Exitcode <> "" then
  if SuperSilentMode = false then msgbox exitcode
  wscript.quit(exitcode)

elseIf Err.Number <> 0 Then

  oIE_Document_write "Error in " & WScript.ScriptName & ":"  & Err.Description
  Err.Clear
  wscript.quit(-1 * err.number)
 else
  wscript.quit
End If




' =====================================================================================
' =====================================================================================
' =====================================================================================
' Function Definitions
' =====================================================================================
' =====================================================================================
' =====================================================================================

' =====================================================================================
' Saves data to log-file
' =====================================================================================

Function oIE_Document_write (strInput2)
on error resume next
	 Set oSaveToFile = FSO.OpenTextFile(Logfile, 8, true)
	 oSaveToFile.WriteLine(strInput2)
	 oSaveToFile.Close
End function
' =====================================================================================
Function WriteIE (strInput2)
	oIE_Document_write strInput2 & "<br>"

End function