on error resume next
Set WSHShell = WScript.CreateObject( "WScript.Shell" )
Set fso = CreateObject("Scripting.FileSystemObject")
Set WshSysEnv = WshShell.Environment("PROCESS")
Dim Scriptpath: Scriptpath = fso.GetParentFolderName(WScript.ScriptFullName)
'Arguments:Logfolder/Logfile, Comment:
'Reports:Network Adaptors
'Exports: Connected Network Adapters
'Returns: Number of Connected Adapters
' =====================================================================================
' Arguments
' =====================================================================================
If WScript.Arguments.Count >= 1   Then
Dim objArgs : set objArgs = Wscript.Arguments
Dim Logfolder

For iParam = 0 To WScript.Arguments.Count -1
 Select Case ucase(objArgs(iParam))
      Case "/SILENT", "SILENT", "/S"
            SilentMode = True
      Case "/SUPERSILENT", "SUPERSILENT", "/QB-"
            SuperSilentMode = True
            SilentMode = True
      Case "/SHOW"
      			SuperSilentMode = False
      Case "UAC"
      		AdminMode = True
      Case Else

		IF fso.folderexists(objArgs(iParam)) then
			LogFolder =  objArgs(iParam)
			SuperSilentMode = True
		elseIF fso.fileexists(objArgs(iParam)) then
			Logfile =  objArgs(iParam)
			SuperSilentMode = True
		ELSE

			if left(objArgs(iParam),8) = "COMMENT:" then strExportComment= mid(objArgs(iParam),9)
		end if
 End Select
 cmdarg = cmdarg & " " & chr(34) & objArgs(iParam) & chr(34)
Next
End if

' =====================================================================================
' Setting logfile if not set
' =====================================================================================

If Not fso.folderexists(logfolder) Then logfolder = WshSysEnv("Public") & "\Documents\Cadcraft_SystemLogs"
If Not fso.folderexists(logfolder) Then fso.createfolder(logfolder)
if LogFile = "" then Logfile = logfolder & "\" & WScript.ScriptName & "[" & Replace(Replace(date & " "  & time, ":", "."),"/","-") & "]_Log.htm"

' =====================================================================================
' =====================================================================================
' Programcode
' =====================================================================================
' =====================================================================================


'-----------------------------------------------------------------------------------------------------------------------
'Starting IE Window
'-----------------------------------------------------------------------------------------------------------------------
strDosCommand = "netsh interface show interface"



'-----------------------------------------------------------------------------------------------------------------------
'Starting dos command and capture output
'-----------------------------------------------------------------------------------------------------------------------



'return = WshShell.Run(chr(34) & strDosCommand  & chr(34) &  " > " & chr(34) & strTempFile & chr(34), 0, true)
'
'Set fso  = CreateObject("Scripting.FileSystemObject")
'if fso.fileexists(strTempFile) then
''	Set file = fso.OpenTextFile(strTempFile, 1)
'	text = file.ReadLine
'	Do While Not file.AtEndOfStream
'	   WriteIE strText
'	    strText = file.ReadLine()
''	Loop
'	file.Close
'else
' msgbox "missing"
''
'End if

'wscript.quit
'-----------------------------------------------------------------------------------------------------------------------
'Starting dos command and capture output
'-----------------------------------------------------------------------------------------------------------------------

Dim objArguments
Set objShell = WScript.CreateObject("WScript.Shell")
Set objArguments = Wscript.Arguments
Set objShell = WScript.CreateObject("WScript.Shell")
Set objExecObject = objShell.Exec(strDosCommand)
Do While Not objExecObject.StdOut.AtEndOfStream
    strText = objExecObject.StdOut.ReadLine()
' Test or display strText

   oIE_Document_write strText & "<br>"

Loop

'-----------------------------------------------------------------------------------------------------------------------
'listing network card properties
'-----------------------------------------------------------------------------------------------------------------------


On Error Resume Next

strComputer = "."
Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")

Set colItems = objWMIService.ExecQuery("Select * from Win32_NetworkAdapter")
oIE_Document_write "<TABLE>"
    oIE_Document_write "<TD nowrap>" & "Net Connection ID: " & "</TD>"
    oIE_Document_write "<TD nowrap>" & "Net Connection Status: " & "</TD>"
    oIE_Document_write "<TD nowrap>" & "Description: " & "</TD>"
    oIE_Document_write "<TD nowrap>" & "Speed: " & "</TD>"
    oIE_Document_write "<TD nowrap> " & "Adapter Type: " & "</TD>"
    oIE_Document_write "<TD nowrap>" & "Adapter Type Id: " & "</TD>"
    oIE_Document_write "<TD nowrap>" & "AutoSense: " & "</TD>"
    oIE_Document_write "<TD nowrap>" & "Device ID: " & "</TD>"
    oIE_Document_write "<TD nowrap>" & "Index: " & "</TD>"
    oIE_Document_write "<TD nowrap>" & "MAC Address: " & "</TD>"
    oIE_Document_write "<TD nowrap>" & "Manufacturer: " & "</TD>"
    oIE_Document_write "<TD nowrap>" & "Maximum Number Controlled: " & "</TD>"
    oIE_Document_write "<TD nowrap>" & "Maximum Speed: " & "</TD>"
    oIE_Document_write "<TD nowrap>" & "Name: " & "</TD>"
    oIE_Document_write "<TD nowrap> "& "NetworkAddress: " & "</TD>"
    oIE_Document_write "<TD nowrap>" & "Permanent Address: " & "</TD>"
    oIE_Document_write "<TD nowrap>" & "PNP Device ID: " & "</TD>"
    oIE_Document_write "<TD nowrap>" & "Product Name: " & "</TD>"
    oIE_Document_write "<TD nowrap>" & "Service Name: " & "</TD>"
    oIE_Document_write "</TR>"

For Each objItem in colItems
if objItem.NetConnectionStatus > 0 then
oIE_Document_write "<TR>"
	if objItem.NetConnectionStatus = 2 then
		NumberOfConnectedCards = objItem.NetConnectionStatus + 1
		strConnectedCards = strConnectedCards & objItem.Description & " / "
	End if
    oIE_Document_write "<TD nowrap>" & objItem.NetConnectionID & "</TD>"
    oIE_Document_write "<TD nowrap>" & objItem.NetConnectionStatus & "</TD>"
    oIE_Document_write "<TD nowrap>" & objItem.Description & "</TD>"
    oIE_Document_write "<TD nowrap>" & objItem.Speed & "</TD>"
    oIE_Document_write "<TD nowrap> " & objItem.AdapterType & "</TD>"

    Select Case objItem.AdapterTypeID
        Case 0 strAdapterType = "Ethernet 802.3"
        Case 1 strAdapterType = "Token Ring 802.5"
        Case 2 strAdapterType = "Fiber Distributed Data Interface (FDDI)"
        Case 3 strAdapterType = "Wide Area Network (WAN)"
        Case 4 strAdapterType = "LocalTalk"
        Case 5 strAdapterType = "Ethernet using DIX header format"
        Case 6 strAdapterType = "ARCNET"
        Case 7 strAdapterType = "ARCNET (878.2)"
        Case 8 strAdapterType = "ATM"
        Case 9 strAdapterType = "Wireless"
        Case 10 strAdapterType = "Infrared Wireless"
        Case 11 strAdapterType = "Bpc"
        Case 12 strAdapterType = "CoWan"
        Case 13 strAdapterType = "1394"
    End Select

    oIE_Document_write "<TD nowrap>" & strAdapterType & "</TD>"
    oIE_Document_write "<TD nowrap>" & objItem.AutoSense & "</TD>"
    oIE_Document_write "<TD nowrap>" & objItem.DeviceID & "</TD>"
    oIE_Document_write "<TD nowrap>" & objItem.Index & "</TD>"
    oIE_Document_write "<TD nowrap>" & objItem.MACAddress & "</TD>"
    oIE_Document_write "<TD nowrap>" & objItem.Manufacturer & "</TD>"
    oIE_Document_write "<TD nowrap>" & objItem.MaxNumberControlled & "</TD>"
    oIE_Document_write "<TD nowrap>" & objItem.MaxSpeed & "</TD>"
    oIE_Document_write "<TD nowrap>" & objItem.Name & "</TD>"
    oIE_Document_write "<TD nowrap>"
    For Each strNetworkAddress in objItem.NetworkAddresses
        oIE_Document_write strNetworkAddress & "<br>"
    Next
    oIE_Document_write "</TD>"
    oIE_Document_write "<TD nowrap>" & objItem.PermanentAddress & "</TD>"
    oIE_Document_write "<TD nowrap>" & objItem.PNPDeviceID & "</TD>"
    oIE_Document_write "<TD nowrap>" & objItem.ProductName & "</TD>"
    oIE_Document_write "<TD nowrap>" & objItem.ServiceName & "</TD>"
    oIE_Document_write "</TR>"
end if
Next
oIE_Document_write "</TABLE>"



ExitCode = NumberOfConnectedCards
' =====================================================================================
' Creates a Excel Export file
' =====================================================================================
ExportVBS = fso.GetParentFolderName(fso.GetParentFolderName(WScript.ScriptFullName)) & "\Export_Log_result.vbs"


if fso.fileexists(ExportVBS) then

	strField = "NetWork_Adapters"
	strValue = strConnectedCards
	wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true

End if
' =====================================================================================
' Open logfile when finish unless running in SuperSilentMode
' =====================================================================================
if fso.fileexists(Logfile) and SuperSilentMode=False then wshshell.run chr(34) & Logfile & chr(34),1,false


' =====================================================================================
' Exit with error code
' =====================================================================================

if Exitcode <> "" then
  if SuperSilentMode = false then msgbox exitcode
  wscript.quit(exitcode)

elseIf Err.Number <> 0 Then

  oIE_Document_write "Error in " & WScript.ScriptName & ":"  & Err.Description
  Err.Clear
  wscript.quit(-1 * err.number)
 else
  wscript.quit
End If




' =====================================================================================
' =====================================================================================
' =====================================================================================
' Function Definitions
' =====================================================================================
' =====================================================================================
' =====================================================================================

' =====================================================================================
' Saves data to log-file
' =====================================================================================

Function oIE_Document_write (strInput2)
on error resume next
	 Set oSaveToFile = FSO.OpenTextFile(Logfile, 8, true)
	 oSaveToFile.WriteLine(strInput2)
	 oSaveToFile.Close
End function
