on error resume next
Set WSHShell = WScript.CreateObject( "WScript.Shell" )
Set fso = CreateObject("Scripting.FileSystemObject")
Set WshSysEnv = WshShell.Environment("PROCESS")
Dim Scriptpath: Scriptpath = fso.GetParentFolderName(WScript.ScriptFullName)
'Arguments:Logfolder/Logfile, Comment:
'Reports: Summary + full information of Machine Group Policies
'Exports: Number of Polices
'Returns: Number of Polices
' =====================================================================================
' Arguments
' =====================================================================================
If WScript.Arguments.Count >= 1   Then
Dim objArgs : set objArgs = Wscript.Arguments
Dim Logfolder

For iParam = 0 To WScript.Arguments.Count -1
 Select Case ucase(objArgs(iParam))
      Case "/SILENT", "SILENT", "/S"
            SilentMode = True
      Case "/SUPERSILENT", "SUPERSILENT", "/QB-"
            SuperSilentMode = True
            SilentMode = True
      Case "/SHOW"
      			SuperSilentMode = False
      Case "UAC"
      		AdminMode = True
      Case Else

		IF fso.folderexists(objArgs(iParam)) then
			LogFolder =  objArgs(iParam)
			SuperSilentMode = True
		elseIF fso.fileexists(objArgs(iParam)) then
			Logfile =  objArgs(iParam)
			SuperSilentMode = True
		ELSE

			if left(objArgs(iParam),8) = "COMMENT:" then strExportComment= mid(objArgs(iParam),9)
		end if
 End Select
 cmdarg = cmdarg & " " & chr(34) & objArgs(iParam) & chr(34)
Next
End if

' =====================================================================================
' Setting logfile if not set
' =====================================================================================

If Not fso.folderexists(logfolder) Then logfolder = WshSysEnv("Public") & "\Documents\Cadcraft_SystemLogs"
If Not fso.folderexists(logfolder) Then fso.createfolder(logfolder)
if LogFile = "" then Logfile = logfolder & "\" & WScript.ScriptName & "[" & Replace(Replace(date & " "  & time, ":", "."),"/","-") & "]_Log.htm"

' =====================================================================================
' =====================================================================================
' Programcode
' =====================================================================================
' =====================================================================================
Dim ExitCode
oIE_Document_write "<HTML>"
oIE_Document_write "<HEAD>"
oIE_Document_write "<style type='text/css'>"
oIE_Document_write " .row { vertical-align: top; height:auto !important; }"
oIE_Document_write " .list {display:none; }"
oIE_Document_write " .show {display: none; }"
oIE_Document_write " .hide:target + .show {display: inline; }"
oIE_Document_write " .hide:target {display: none; }"
oIE_Document_write " .hide:target ~ .list {display:inline; }"
oIE_Document_write " @media print { .hide, .show { display: none; } }"
oIE_Document_write " </style>"

oIE_Document_write "</HEAD>"
oIE_Document_write "<BODY>"


strGPOSummaryData = CCGetCapuredGPOData("gpresult /scope computer /v")
strGPOFullData = CCGetCapuredDosValueHTML("gpresult /scope computer /v")
oIE_Document_write strGPOSummaryData
'oIE_Document_write  "<BR><BR><A HREF='#' Title='" & strGPOFullData  & "'>Full GPO Info</A>" & " <BR>"



oIE_Document_write " <div class='row'>"
oIE_Document_write "  <a href='#hide2' class='hide' id='hide2'>Show Full GPO Data</a>"
oIE_Document_write "  <a href='#show2' class='show' id='show2'>Hide Full GPO Data</a>"
oIE_Document_write "  <div class='list'>"
oIE_Document_write "  <ul>"
oIE_Document_write "  <li>"
oIE_Document_write strGPOFullData
oIE_Document_write "  </li>"
oIE_Document_write "  </ul>"
oIE_Document_write "  </div>"
oIE_Document_write " </div>"
oIE_Document_write "</BODY>"
oIE_Document_write "</HTML>"


' =====================================================================================
' Creates a Excel Export file
' =====================================================================================
ExportVBS = fso.GetParentFolderName(fso.GetParentFolderName(WScript.ScriptFullName)) & "\Export_Log_result.vbs"


if fso.fileexists(ExportVBS) then

	strField = "Group_Policies_Machine"
	strValue = cstr(iTotalPolicyCount)
	wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true

End if
' =====================================================================================
' Open logfile when finish unless running in SuperSilentMode
' =====================================================================================
if fso.fileexists(Logfile) and SuperSilentMode=False then wshshell.run chr(34) & Logfile & chr(34),1,false


' =====================================================================================
' Exit with error code
' =====================================================================================

if Exitcode <> "" then
  if SuperSilentMode = false then msgbox exitcode
  wscript.quit(exitcode)

elseIf Err.Number <> 0 Then

  oIE_Document_write "Error in " & WScript.ScriptName & ":"  & Err.Description
  Err.Clear
  wscript.quit(-1 * err.number)
 else
  wscript.quit
End If



' =====================================================================================
' =====================================================================================
' =====================================================================================
' Function Definitions
' =====================================================================================
' =====================================================================================
' =====================================================================================


'-----------------------------------------------------------------------------------------------------------------------
'Starting dos command and capture output
'-----------------------------------------------------------------------------------------------------------------------
Function CCGetCapuredGPOData (strDosCommand)
'Update_Status_Field "Executing: " & strDosCommand
Dim objArguments
Set objShell = WScript.CreateObject("WScript.Shell")
Set objArguments = Wscript.Arguments
Set objShell = WScript.CreateObject("WScript.Shell")
Set objExecObject = objShell.Exec(strDosCommand)
	iTotalPolicyCount = 0
Do While Not objExecObject.StdOut.AtEndOfStream

    strtext = replace(strtext,"          ", "  ")
    strTextRow = objExecObject.StdOut.ReadLine()
 	strText = ReplaceDOSChar(strTextRow)
    strText = ReplaceDOSHTMLChar(strText)

	iIndentCount = 1
	do
		strTmpChar = mid(strText, iIndentCount, 6)
				iIndentCount = iIndentCount + 6

	Loop While strTmpChar = "&nbsp;"


    if instr(1, strtext, "---------", vbtextcompare) > 0 then
    'inputbox strLastText,strText, strLastTextRow

	if strLastHeader <> "" then
		iTotalPolicyCount = iTotalPolicyCount  + iSubItemCount -1

		CCGetCapuredGPOData = CCGetCapuredGPOData & "<BR>"  & strLastHeader & "&nbsp;&nbsp;&nbsp;&nbsp;" & cstr(iSubItemCount-1)
	end if
	strLastHeader = strLastText
    iSubItemCount = 0

	elseif instr(1, strtext, "N/A", vbtextcompare) > 0 then
		'msgbox "N/A"

	elseif trim(strtext) <> "" and iIndentCount < 100 then
	iSubItemCount = iSubItemCount + 1

	else


	'if iIndentCount <> 7 and iIndentCount <> 103 then inputbox strLastHeader, cstr(iIndentCount), strText
    end if

' Test or display strText
   'Update_Status_Field strText

   strLastText = strText
   strLastTextRow = strTextRow
   'CCGetCapuredDosValue = CCGetCapuredDosValue & "<BR>"  & strText

Loop

	if strLastHeader <> "" then 	CCGetCapuredGPOData = CCGetCapuredGPOData & "<BR>"  & strLastHeader & "&nbsp;&nbsp;&nbsp;&nbsp;" & cstr(iSubItemCount)
	iTotalPolicyCount = iTotalPolicyCount  + iSubItemCount
	CCGetCapuredGPOData = CCGetCapuredGPOData & "<BR><BR><B>" & "Total number of policies:"   & cstr(iTotalPolicyCount) & "<BR></B>"
    ExitCode = iTotalPolicyCount

End function
'-----------------------------------------------------------------------------------------------------------------------
'Starting dos command and capture output
'-----------------------------------------------------------------------------------------------------------------------
Function CCGetCapuredDosValue (strDosCommand)
'Update_Status_Field "Executing: " & strDosCommand
Set objShell = WScript.CreateObject("WScript.Shell")
Set objExecObject = objShell.Exec(strDosCommand)
Do While Not objExecObject.StdOut.AtEndOfStream
    strtext = replace(strtext,"          ", "  ")
    strText = objExecObject.StdOut.ReadLine()
    strText = ReplaceDOSChar(strText)
    strText = ReplaceDOSHTMLChar(strText)

' Test or display strText
   'Update_Status_Field strText
   CCGetCapuredDosValue = CCGetCapuredDosValue & vbcr  & strText

Loop

End Function
'-----------------------------------------------------------------------------------------------------------------------
'Starting dos command and capture output
'-----------------------------------------------------------------------------------------------------------------------

Function CCGetCapuredDosValueHTML (strDosCommand)
'Update_Status_Field "Executing: " & strDosCommand
Set objShell = WScript.CreateObject("WScript.Shell")
Set objExecObject = objShell.Exec(strDosCommand)
Do While Not objExecObject.StdOut.AtEndOfStream
    strtext = replace(strtext,"          ", "  ")
    strText = objExecObject.StdOut.ReadLine()
    strText = ReplaceDOSChar(strText)
' Test or display strText
   'Update_Status_Field strText
   CCGetCapuredDosValueHTML = CCGetCapuredDosValueHTML & "<BR>"  & strText

Loop

End function
Function ReplaceDOSChar( strText )
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,""," ")
	ReplaceDOSChar = strText
End Function

Function ReplaceDOSHTMLChar( strText )
	strText = Replace(strText,"  ","&nbsp;&nbsp;")
	ReplaceDOSHTMLChar = strText
End Function


' =====================================================================================
' Open logfile when finish unless running in SuperSilentMode
' =====================================================================================
if fso.fileexists(Logfile) and SuperSilentMode=False then wshshell.run chr(34) & Logfile & chr(34),1,false

' =====================================================================================
' Saves data to log-file
' =====================================================================================

Function oIE_Document_write (strInput2)
on error resume next
	 Set oSaveToFile = FSO.OpenTextFile(Logfile, 8, true)
	 oSaveToFile.WriteLine(strInput2)
	 oSaveToFile.Close
End function
