on error resume next
Set WSHShell = WScript.CreateObject( "WScript.Shell" )
Set fso = CreateObject("Scripting.FileSystemObject")
Set WshSysEnv = WshShell.Environment("PROCESS")
Dim Scriptpath: Scriptpath = fso.GetParentFolderName(WScript.ScriptFullName)
'Arguments:Logfolder/Logfile, Comment:
'Reports: list of Installed Cad-software
'Exports: Number of Cad-software and total number of installed software
'Returns: Number of Cad-software
' =====================================================================================
' Arguments
' =====================================================================================
If WScript.Arguments.Count >= 1   Then
Dim objArgs : set objArgs = Wscript.Arguments
Dim Logfolder

For iParam = 0 To WScript.Arguments.Count -1
 Select Case ucase(objArgs(iParam))
      Case "/SILENT", "SILENT", "/S"
            SilentMode = True
      Case "/SUPERSILENT", "SUPERSILENT", "/QB-"
            SuperSilentMode = True
            SilentMode = True
      Case "/SHOW"
      			SuperSilentMode = False
      Case "UAC"
      		AdminMode = True
      Case Else

		IF fso.folderexists(objArgs(iParam)) then
			LogFolder =  objArgs(iParam)
			SuperSilentMode = True
		elseIF fso.fileexists(objArgs(iParam)) then
			Logfile =  objArgs(iParam)
			SuperSilentMode = True
		ELSE

			if left(objArgs(iParam),8) = "COMMENT:" then strExportComment= mid(objArgs(iParam),9)
		end if
 End Select
 cmdarg = cmdarg & " " & chr(34) & objArgs(iParam) & chr(34)
Next
End if

' =====================================================================================
' Setting logfile if not set
' =====================================================================================

If Not fso.folderexists(logfolder) Then logfolder = WshSysEnv("Public") & "\Documents\Cadcraft_SystemLogs"
If Not fso.folderexists(logfolder) Then fso.createfolder(logfolder)
if LogFile = "" then Logfile = logfolder & "\" & WScript.ScriptName & "[" & Replace(Replace(date & " "  & time, ":", "."),"/","-") & "]_Log.htm"

' =====================================================================================
' =====================================================================================
' Programcode
' =====================================================================================
' =====================================================================================

iProductCount = 0
Const HKEY_LOCAL_MACHINE = &H80000002
Const HKEY_CURRENT_USER = &H80000001 'HKEY_CURRENT_USER
strTotalSoftWareKeyWord = ";"
strComputer = WshSysEnv("Computername")
Set SoftwareSummary = CreateObject("scripting.dictionary")

Dim  strACADKey, strACADSubKey, strAcadVerKey, strACADVerSubKey, strSerialNumber,  strSerialNumberSufix, strSerialNumberPrefix, CadApplics, strPublisher, strInstalldate

On error resume next
Set objRegistry = GetObject("winmgmts:{impersonationLevel=Impersonate}!\\.\root\default:StdRegProv")

Dim strInventorLocation, strInventorBackup, objInventorBackup, objInventorHotfixFolders, objHotfixFolder
strKey = "SOFTWARE\Autodesk\Inventor"
objRegistry.EnumKey HKEY_LOCAL_MACHINE, strKey, arrSubKeys
oIE_Document_write"<TABLE border = 1><b><TR><TD>Computer</TD><TD>DisplayName</TD><TD>SerialNumber</TD><TD>DisplayVersion</TD><TD>InstallLocation</TD><TD>InstallDate</TD></TR></b>"
iAllProducts = 0
For Each strSubKey In arrSubKeys

		strDisplayName  = ""
		strSerialNumber = ""
		strDisplayVersion   = ""
		strInstallLocation   = ""
		strInstallDate   = ""
		strInventorLocation = ""
	'HKEY_CURRENT_USER\Software\Autodesk\Inventor\RegistryVersion19.0\System\Preferences\Driver'
	'[HKEY_CURRENT_USER\Software\Autodesk\AutoCAD\R20.0\ACAD-E005:409\3DGS Configuration\Certification]
	'"HardwareEnabled"=dword:00000000

	objRegistry.GetDWordValue HKEY_CURRENT_USER, strKey & "\" & strSubKey & "\System\Preferences\Driver", "Hardware Driver Type", intHardwareDriverType
	objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strKey & "\" & strSubKey, "ProductName", strDisplayName
	objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strKey & "\" & strSubKey, "ProductVersion", strDisplayVersion
objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strKey & "\" & strSubKey, "ProductName", strProductEdition
objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strKey & "\" & strSubKey, "InstallLocation", strInstallLocation
	objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strKey & "\" & strSubKey, "InventorLocation", strInventorLocation
	objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strKey & "\" & strSubKey, "UserName", strUserName
	objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strKey & "\" & strSubKey, "Organization", strCompanyName
	objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strKey & "\" & strSubKey, "SerialNumberPrefix", strSerialNumberPrefix
	objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strKey & "\" & strSubKey, "SerialNumberSuffix", strSerialNumberSufix
	strSerialNumber = strSerialNumberPrefix & "-" & strSerialNumberSufix
		if strDisplayName = "" then strDisplayName = strProductEdition
		iPos = instr(1,strDisplayName, " ",vbTextCompare)
		iPos2 = instr(iPos +2 ,strDisplayName, " ",vbTextCompare)
		iPos3 = instr(1,strDisplayName, " 20",vbTextCompare)
		if iPos2<>iPos3 then
		strShortDisplayName = mid(strDisplayName,1,1) & mid(strDisplayName,iPos+1,1) &  mid(strDisplayName,iPos2+1,1) & mid(strDisplayName,iPos3+1,4)
		else
		strShortDisplayName = mid(strDisplayName,1,1) & mid(strDisplayName,iPos+1,1)  & mid(strDisplayName,iPos3+1,4)
		End if

	if intHardwareDriverType <> "" then
		if CadGraphics <> "" then CadGraphics  = CadGraphics  & ";"

		CadGraphics =  CadGraphics  & strShortDisplayName & "[" & intHardwareDriverType & "]"

	End if
	if strDisplayName <> "" then
		IE_Document_write"<TR><TD NOWRAP>" & strComputer & "</TD><TD NOWRAP>" & strDisplayName & "</TD><TD NOWRAP>" & strSerialNumber & "</TD><TD NOWRAP>" &  strDisplayVersion & "</TD><TD NOWRAP>" & strUsername & "</TD><TD NOWRAP>" & strCompanyName & "</TD><TD NOWRAP>" & strInstallLocation & "</TD><TD NOWRAP>" & strInstallDate & "</TD><TD NOWRAP>" & intHardwareDriverType & "</TD></TR>"
		iProductCount = iProductCount + +1
		if CadApplics <> "" then CadApplics  = CadApplics  & ";"
		CadApplics =  CadApplics & strDisplayName & Mid(strDisplayVersion,1,3)
		if strInventorLocation <> "" then strInventorBackup = fso.GetParentFolderName(strInventorLocation) & "\$Backup$"

		if fso.folderexists(strInventorBackup) then
		 strProductName = strDisplayName
		  set objInventorBackup = fso.getfolder(strInventorBackup)
		  set objInventorHotfixFolders = objInventorBackup.SubFolders 'as Folders Collection
		  for each objHotfixFolder in objInventorHotfixFolders
		  	strDisplayName = strProductName & " Hotfix " & objHotfixFolder.name
			oIE_Document_write"<TR><TD NOWRAP>" & strComputer & "</TD><TD NOWRAP>" & strDisplayName & "</TD><TD NOWRAP>" & strSerialNumber & "</TD><TD NOWRAP>" &  strDisplayVersion & "</TD><TD NOWRAP>" & strInstallLocation & "</TD><TD NOWRAP>" & strInstallDate & "</TD></TR>"
					iProductCount = iProductCount + +1
		  Next
		End if






	End if
Next

Dim strProductName
strAcadKey = "SOFTWARE\Autodesk\AutoCAD"
objRegistry.EnumKey HKEY_LOCAL_MACHINE, strACADKey, arrACADSubKeys
For Each strACADSubKey In arrACADSubKeys
	strAcadVerKey = strAcadKey & "\" & strACADSubKey

	objRegistry.EnumKey HKEY_LOCAL_MACHINE, strAcadVerKey  , arrACADVerSubKeys
	For Each strACADVerSubKey In arrACADVerSubKeys

		strDisplayName  = ""
		strSerialNumber = ""
		strDisplayVersion   = ""
		strInstallLocation   = ""
		strInstallDate   = ""

		objRegistry.GetDwordValue HKEY_CURRENT_USER  , strAcadVerKey & "\" & strACADVerSubKey & "\3DGS Configuration\Certification", "HardwareEnabled", intHardwareEnabled
		objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strAcadVerKey & "\" & strACADVerSubKey, "ProductName", strDisplayName
		objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strAcadVerKey & "\" & strACADVerSubKey, "Release", strDisplayVersion
		objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strAcadVerKey & "\" & strACADVerSubKey, "Location", strInstallLocation
		objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strAcadVerKey & "\" & strACADVerSubKey, "SerialNumber", strSerialNumber
		objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strAcadVerKey & "\" & strACADVerSubKey, "AcadLocation", strInstallLocation
		iPos = instr(1,strDisplayName, " ",vbTextCompare)
		iPos2 = instr(1 ,strDisplayName, " ",vbTextCompare)
		iPos3 = instr(1,strDisplayName, " 20",vbTextCompare)
		if iPos2<>iPos3 then
		strShortDisplayName = mid(strDisplayName,1,1) & mid(strDisplayName,iPos+1,1) & mid(strDisplayName,iPos3+1,4)
		else
		strShortDisplayName = mid(strDisplayName,1,1) & mid(strDisplayName,iPos3+1,4)
		End if
		if intHardwareEnabled <> "" then
			if CadGraphics <> "" then CadGraphics  = CadGraphics  & ";"
			CadGraphics =  CadGraphics & strShortDisplayName & "[" & intHardwareEnabled & "]"

		End if

		if strProductName <> "" then strProductName =  replace(strDisplayName, "Mechanical Desktop", "MDT")



		if strDisplayName <> "" then

		if CadApplics <> "" then CadApplics  = CadApplics  & ";"
			CadApplics =  CadApplics & strProductName
					iProductCount = iProductCount + +1
			oIE_Document_write"<TR><TD NOWRAP>" & strComputer & "</TD><TD NOWRAP>" & strDisplayName & "</TD><TD NOWRAP>" & strSerialNumber & "</TD><TD NOWRAP>" &  strDisplayVersion & "</TD><TD NOWRAP>" & strInstallLocation & "</TD><TD NOWRAP>" & strInstallDate & "</TD><TD NOWRAP>" & intHardwareEnabled & "</TD></TR>"
			oIE_Document_write"<TR><TD NOWRAP>" & strComputer & "</TD><TD NOWRAP>" & strDisplayName & "</TD><TD NOWRAP>" & strSerialNumber & "</TD><TD NOWRAP>" &  strDisplayVersion & "</TD><TD NOWRAP>" & strInstallLocation & "</TD><TD NOWRAP>" & strInstallDate & "</TD></TR>"

		strInventorBackup = strInstallLocation & "\$Backup$"
		if fso.folderexists(strInventorBackup) then

		  set objInventorBackup = fso.getfolder(strInventorBackup)
		  set objInventorHotfixFolders = objInventorBackup.SubFolders 'as Folders Collection
		  for each objHotfixFolder in objInventorHotfixFolders

			strDisplayName = strProductName & " Hotfix " & objHotfixFolder.name
			oIE_Document_write"<TR><TD NOWRAP>" & strComputer & "</TD><TD NOWRAP>" & strDisplayName & "</TD><TD NOWRAP>" & strSerialNumber & "</TD><TD NOWRAP>" &  strDisplayVersion & "</TD><TD NOWRAP>" & strInstallLocation & "</TD><TD NOWRAP>" & strInstallDate & "</TD></TR>"
		iProductCount = iProductCount + +1
		  Next
		End if




	End if
	Next
Next

strAcadKey = "SOFTWARE\Autodesk\AutoCAD LT"
objRegistry.EnumKey HKEY_LOCAL_MACHINE, strACADKey, arrACADSubKeys
For Each strACADSubKey In arrACADSubKeys

	strAcadVerKey = strAcadKey & "\" & strACADSubKey
	objRegistry.EnumKey HKEY_LOCAL_MACHINE, strAcadVerKey, arrACADVerSubKeys
	For Each strACADVerSubKey In arrACADVerSubKeys

		strDisplayName  = ""
		strSerialNumber = ""
		strDisplayVersion   = ""
		strInstallLocation   = ""
		strInstallDate   = ""
		objRegistry.GetDwordValue HKEY_CURRENT_USER  , strAcadVerKey & "\" & strACADVerSubKey & "\3DGS Configuration\Certification", "HardwareEnabled", intHardwareEnabled
		objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strAcadVerKey & "\" & strACADVerSubKey, "ProductName", strDisplayName
		objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strAcadVerKey & "\" & strACADVerSubKey, "Release", strDisplayVersion
		objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strAcadVerKey & "\" & strACADVerSubKey, "Location", strInstallLocation
		objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strAcadVerKey & "\" & strACADVerSubKey, "SerialNumber", strSerialNumber

		if strDisplayName <> "" then
			oIE_Document_write"<TR><TD NOWRAP>" & strComputer & "</TD><TD NOWRAP>" & strDisplayName & "</TD><TD NOWRAP>" & strSerialNumber & "</TD><TD NOWRAP>" &  strDisplayVersion & "</TD><TD NOWRAP>" & strInstallLocation & "</TD><TD NOWRAP>" & strInstallDate & "</TD><TD NOWRAP>" & intHardwareEnabled & "</TD></TR>"
			iProductCount = iProductCount + +1
			if CadApplics <> "" then CadApplics  = CadApplics  & ";"
			CadApplics =  CadApplics & strDisplayName
		set rs = Db.execute("select * from " & strTabell & " where  Computername = '" & strComputer & "' and Application = '" & strDisplayName  & "'" )
	   End if
	Next
Next



strKey = "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall"
objRegistry.EnumKey HKEY_LOCAL_MACHINE, strKey, arrSubKeys
  For Each strSubKey In arrSubKeys
	iAllProducts  = iAllProducts  + 1
	objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strKey & "\" & strSubKey, "Publisher", strPublisher
	objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strKey & "\" & strSubKey, "DisplayName", strDisplayName
	if instr(strPublisher,"Autodesk")> 0 or _
	   instr(strPublisher,"GCS")> 0 or _
	   instr(strPublisher,"Rainbow Technologies")> 0 or _
	   instr(strPublisher,"FCC Software AB")> 0 or _
	   instr(strDisplayName,"AutoPOL")> 0 or _
	   instr(strDisplayName,"Microsoft SQL Server")> 0 or _
	   instr(strDisplayName,"Microsoft WSE")> 0 or _
	   instr(strDisplayName,"Microsoft Visual J# .NET")> 0 or _
	   instr(strDisplayName,"Internet Services")> 0 or _
	   (instr(strDisplayName,".NET Framework")> 0 and instr(strPublisher,"Microsoft")> 0) or _
	   instr(strDisplayName,"Windows Installer")> 0 or _
	   instr(strDisplayName,"XML Parser")> 0 or _
	   instr(strPublisher,"CADQ")> 0 or _
	   instr(strPublisher,"CAD-Q")> 0 or _
	   instr(strPublisher,"3Dcon")> 0 or _
	   instr(strDisplayName,"3Dcon")> 0 or _
	   instr(strPublisher,"Cadcraft")> 0 or _
	   instr(strPublisher,"cadcraft")> 0 then


	strDisplayName  = ""
	strSerialNumber = ""
	strDisplayVersion   = ""
	strInstallLocation   = ""
	strInstallDate   = ""

	objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strKey & "\" & strSubKey, "DisplayName", strDisplayName
	objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strKey & "\" & strSubKey, "DisplayVersion", strDisplayVersion
	objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strKey & "\" & strSubKey, "InstallLocation", strInstallLocation
	objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strKey & "\" & strSubKey, "InstallDate", strInstallDate
	objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strAcadVerKey & "\" & strACADVerSubKey, "SerialNumberPrefix", strSerialNumberPrefix
	objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strAcadVerKey & "\" & strACADVerSubKey, "SerialNumberSufix", strSerialNumberSufix
	strSerialNumber = strSerialNumberPrefix & "-" & strSerialNumberSufix
on error goto 0
	if strDisplayName <> "" then
		oIE_Document_write"<TR><TD NOWRAP>" & strComputer & "</TD><TD NOWRAP>" & strDisplayName & "</TD><TD NOWRAP>" & strSerialNumber & "</TD><TD NOWRAP>" &  strDisplayVersion & "</TD><TD NOWRAP>" & strInstallLocation & "</TD><TD NOWRAP>" & strInstallDate & "</TD></TR>"
				iProductCount = iProductCount + +1
'		if CadApplics <> "" then CadApplics  = CadApplics  & ";"
'		CadApplics =  CadApplics & strDisplayName
		strTabell = "installedapptbl"
	End if
    End if


	strSoftWareKeyWord = ""
	strSoftWareVersion= ""
if not isNull(strDisplayName) then


	intVersionPos = instr(strDisplayName, " 201")
	if intVersionPos  >0 then strSoftWareVersion= mid(strDisplayName, intVersionPos + 1,4)

	if instr(strDisplayName, "AutoCAD Mechanical")=1 then
	 strSoftWareKeyWord = "AM"
	elseif instr(strDisplayName, "AutoCAD Architecture")=1 then
	strSoftWareKeyWord = "AA"
	elseif instr(strDisplayName, "AutoCAD LT")=1 then
	strSoftWareKeyWord = "ALT"
	elseif instr(strDisplayName, "AutoCAD Raster Design")=1 then
	strSoftWareKeyWord = "AR"
	elseif instr(strDisplayName, "AutoCAD Electrica")=1 then
	strSoftWareKeyWord = "AE"
	elseif instr(strDisplayName, "AutoCAD")=1 then
	strSoftWareKeyWord = "A"
	elseif instr(strDisplayName, "AutoCAD")=1 then
	strSoftWareKeyWord = "A"
	elseif instr(strDisplayName, "Autodesk Inventor Professional")=1 then
	strSoftWareKeyWord = "IP"
	elseif instr(strDisplayName, "Autodesk Vault Basic")=1 then
	strSoftWareKeyWord = "VB"
	elseif instr(strDisplayName, "Autodesk Vault Workgroup")=1 then
	strSoftWareKeyWord = "VW"
	elseif instr(strDisplayName, "Autodesk Vault Collaboration")=1 then
	strSoftWareKeyWord = "VC"
	elseif instr(strDisplayName, "Autodesk Vault Professional")=1 then
	strSoftWareKeyWord = "VP"
	elseif instr(strDisplayName, "Update for PSP Pro Client CAD2015")=1 then
	strSoftWareKeyWord = "PSP2015"
	elseif instr(strDisplayName, "Update for PSP Pro Client")=1 then
	strSoftWareKeyWord = "PSP"
	End if
	if strSoftWareKeyWord <> "" then
	if not  SoftwareSummary.Exists(strSoftWareKeyWord) Then
			SoftwareSummary.Add strSoftWareKeyWord, DisplayVersion
	End if
		if instr(strTotalSoftWareKeyWord, ";" &  strSoftWareKeyWord & strSoftWareVersion & ";") =0 then
			strTotalSoftWareKeyWord = strTotalSoftWareKeyWord  & strSoftWareKeyWord & strSoftWareVersion & ";"
		End if
	End if
end if
Next


	strDisplayName  = ""
	strSerialNumber = ""
	strDisplayVersion   = ""
	strInstallLocation   = ""
	strInstallDate   = ""

strDisplayName  = "Internet Explorer"
strDisplayVersion = WshShell.RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Internet Explorer\Version")
oIE_Document_write"<TR><TD NOWRAP>" & strComputer & "</TD><TD NOWRAP>" & strDisplayName & "</TD><TD NOWRAP>" & strSerialNumber & "</TD><TD NOWRAP>" &  strDisplayVersion & "</TD><TD NOWRAP>" & strInstallLocation & "</TD><TD NOWRAP>" & strInstallDate & "</TD></TR>"
		iProductCount = iProductCount + +1

	strDisplayName  = ""
	strSerialNumber = ""
	strDisplayVersion   = ""
	strInstallLocation   = ""
	strInstallDate   = ""
strDisplayName  = "MDac"
strDisplayVersion = WshShell.RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Classes\MDACVer.Version\CurVer\")


oIE_Document_write"<TR><TD NOWRAP>" & strComputer & "</TD><TD NOWRAP>" & strDisplayName & "</TD><TD NOWRAP>" & strSerialNumber & "</TD><TD NOWRAP>" &  strDisplayVersion & "</TD><TD NOWRAP>" & strInstallLocation & "</TD><TD NOWRAP>" & strInstallDate & "</TD></TR>"
		iProductCount = iProductCount + +1
	strDisplayName  = ""
	strSerialNumber = ""
	strDisplayVersion   = ""
	strInstallLocation   = ""
	strInstallDate   = ""

oIE_Document_write"</TABLE>"
oIE_Document_write  "<H1>Inventory Done</H1>"

ExitCode = iProductCount
' =====================================================================================
' Creates a Excel Export file
' =====================================================================================
ExportVBS = fso.GetParentFolderName(fso.GetParentFolderName(WScript.ScriptFullName)) & "\Export_Log_result.vbs"


if fso.fileexists(ExportVBS) then

	strField = "Cad_Software"
	strValue = 		cstr(iProductCount) & " of " & cstr(iAllProducts)
	wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true


End if

' =====================================================================================
' Open logfile when finish unless running in SuperSilentMode
' =====================================================================================
if fso.fileexists(Logfile) and SuperSilentMode=False then wshshell.run chr(34) & Logfile & chr(34),1,false


' =====================================================================================
' Exit with error code
' =====================================================================================

if Exitcode <> "" then
  if SuperSilentMode = false then msgbox exitcode
  wscript.quit(exitcode)

elseIf Err.Number <> 0 Then

  oIE_Document_write "Error in " & WScript.ScriptName & ":"  & Err.Description
  Err.Clear
  wscript.quit(-1 * err.number)
 else
  wscript.quit
End If




' =====================================================================================
' =====================================================================================
' =====================================================================================
' Function Definitions
' =====================================================================================
' =====================================================================================
' =====================================================================================

' =====================================================================================
' Save2HTMLFile
' =====================================================================================

Function oIE_Document_write (strInput2)
on error resume next
	 Set oSaveToFile = FSO.OpenTextFile(Logfile, 8, true)
	 oSaveToFile.WriteLine(strInput2)
	 oSaveToFile.Close
End function
