on error resume next
Set WSHShell = WScript.CreateObject( "WScript.Shell" )
Set fso = CreateObject("Scripting.FileSystemObject")
Set WshSysEnv = WshShell.Environment("PROCESS")
Dim Scriptpath: Scriptpath = fso.GetParentFolderName(WScript.ScriptFullName)
'Arguments:Logfolder/Logfile, Comment:
'Reports:Computername, Computer Model
'Exports: Computername, Computer Model
'Returns: 0
' =====================================================================================
' Arguments
' =====================================================================================
If WScript.Arguments.Count >= 1   Then
Dim objArgs : set objArgs = Wscript.Arguments
Dim Logfolder

For iParam = 0 To WScript.Arguments.Count -1
 Select Case ucase(objArgs(iParam))
      Case "/SILENT", "SILENT", "/S"
            SilentMode = True
      Case "/SUPERSILENT", "SUPERSILENT", "/QB-"
            SuperSilentMode = True
            SilentMode = True
      Case "/SHOW"
      			SuperSilentMode = False
      Case "UAC"
      		AdminMode = True
      Case Else

		IF fso.folderexists(objArgs(iParam)) then
			LogFolder =  objArgs(iParam)
			SuperSilentMode = True
		elseIF fso.fileexists(objArgs(iParam)) then
			Logfile =  objArgs(iParam)
			SuperSilentMode = True
		ELSE

			if left(objArgs(iParam),8) = "COMMENT:" then strExportComment= mid(objArgs(iParam),9)
		end if
 End Select
 cmdarg = cmdarg & " " & chr(34) & objArgs(iParam) & chr(34)
Next
End if

' =====================================================================================
' Setting logfile if not set
' =====================================================================================

If Not fso.folderexists(logfolder) Then logfolder = WshSysEnv("Public") & "\Documents\Cadcraft_SystemLogs"
If Not fso.folderexists(logfolder) Then fso.createfolder(logfolder)
if LogFile = "" then Logfile = logfolder & "\" & WScript.ScriptName & "[" & Replace(Replace(date & " "  & time, ":", "."),"/","-") & "]_Log.htm"

' =====================================================================================
' =====================================================================================
' Programcode
' =====================================================================================
' =====================================================================================


'================================================================================================
' Hardware Info
'================================================================================================
		oIE_Document_write  " <B>Disk Space</B><Font Size=3 Face='Courier New', Courier, monospace>" &  ccGetDiskTable & "</FONT><BR>"




' =====================================================================================
' Creates a Excel Export file
' =====================================================================================
ExportVBS = fso.GetParentFolderName(fso.GetParentFolderName(WScript.ScriptFullName)) & "\Export_Log_result.vbs"


if fso.fileexists(ExportVBS) then

	strField = replace(wscript.scriptname, ".vbs", "")
	strValue = TemplateValue
	wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true

End if
' =====================================================================================
' Open logfile when finish unless running in SuperSilentMode
' =====================================================================================
if fso.fileexists(Logfile) and SuperSilentMode=False then wshshell.run chr(34) & Logfile & chr(34),1,false


' =====================================================================================
' Exit with error code
' =====================================================================================

if Exitcode <> "" then
  if SuperSilentMode = false then msgbox exitcode
  wscript.quit(exitcode)

elseIf Err.Number <> 0 Then

  oIE_Document_write "Error in " & WScript.ScriptName & ":"  & Err.Description
  Err.Clear
  wscript.quit(-1 * err.number)
 else
  wscript.quit
End If




' =====================================================================================
' =====================================================================================
' =====================================================================================
' Function Definitions
' =====================================================================================
' =====================================================================================
' =====================================================================================


'================================================================================================
' Get Disk info from WMI
'================================================================================================
Function ccGetDiskTable ()
ccGetDiskTable =   "<LEFT><Table border=0 width=100%>"


'DIM objWMIService, objItem, colItems
'DIM strDriveType, strDiskSize, txt
strComputer = "."
SET objWMIService = GETOBJECT("winmgmts:\\" & strComputer & "\root\cimv2")
SET colItems = objWMIService.ExecQuery("Select * from Win32_LogicalDisk WHERE DriveType=3")
ccGetDiskTable = ccGetDiskTable &   "<B><TR><FONT FACE='Courier New' size=2>"

ccGetDiskTable = ccGetDiskTable &  "<TD>Drive" & "</TD>"
ccGetDiskTable = ccGetDiskTable &   "<TD >" & vbtab & "Size" &  "</TD>"
ccGetDiskTable = ccGetDiskTable &   "<TD >" & vbtab & "Used" &  "</TD>"
ccGetDiskTable = ccGetDiskTable &   "<TD >" & vbtab & "Free" &  "</TD>"
ccGetDiskTable = ccGetDiskTable &   "<TD >" & vbtab & "Free(%)" &  "</TD>"
ccGetDiskTable = ccGetDiskTable &   "</FONT></TR></B>"

FOR EACH objItem in colItems
ccGetDiskTable = ccGetDiskTable &   "<TR><FONT FACE='Courier New' size=2>"
	DIM pctFreeSpace,strFreeSpace,strusedSpace

	if ucase(objItem.Name) = "C:" then CFreeSpace  = objItem.FreeSpace
	pctFreeSpace = INT((objItem.FreeSpace / objItem.Size) * 1000)/10
	strDiskSize = Int(objItem.Size /1073741824) & " Gb"
	strFreeSpace = Int(objItem.FreeSpace /1073741824) & " Gb"
	strUsedSpace = Int((objItem.Size-objItem.FreeSpace)/1073741824) & " Gb"
ccGetDiskTable = ccGetDiskTable &   "<TD >"& objItem.Name & "</TD>"
ccGetDiskTable = ccGetDiskTable &   "<TD >" & strDiskSize & "</TD>"
ccGetDiskTable = ccGetDiskTable &   "<TD >" & strUsedSpace & "</TD>"
ccGetDiskTable = ccGetDiskTable &   "<TD >" & strFreeSpace & "</TD>"
ccGetDiskTable = ccGetDiskTable &   "<TD >" & pctFreeSpace &"</TD>"
ccGetDiskTable = ccGetDiskTable &   "</FONT></TR>"
NEXT

ccGetDiskTable = ccGetDiskTable &   "</TABLE>"

End Function

'-----------------------------------------------------------------------------------------------------------------------
' Function that replaces Dos Characters with Windows Characters
'-----------------------------------------------------------------------------------------------------------------------
Function ReplaceDOSChar( strText )
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,""," ")
	strText = Replace(strText,"  ","&nbsp;&nbsp;")
	ReplaceDOSChar = strText
End Function

'-----------------------------------------------------------------------------------------------------------------------
'Starting dos command and capture output
'-----------------------------------------------------------------------------------------------------------------------
Function CCGetCapuredDosValue (strDosCommand)
'WriteIEBold "Executing: " & strDosCommand
Dim objArguments
Set objShell = WScript.CreateObject("WScript.Shell")
Set objArguments = Wscript.Arguments
Set objShell = WScript.CreateObject("WScript.Shell")
Set objExecObject = objShell.Exec(strDosCommand)
Do While Not objExecObject.StdOut.AtEndOfStream
    strtext = replace(strtext,"          ", "  ")
    strText = objExecObject.StdOut.ReadLine()
    strText = ReplaceDOSChar(strText)
' Test or display strText

   CCGetCapuredDosValue = CCGetCapuredDosValue & "<BR>"  & strText

Loop


End Function

' =====================================================================================
' Open logfile when finish unless running in SuperSilentMode
' =====================================================================================
if fso.fileexists(Logfile) and SuperSilentMode=False then wshshell.run chr(34) & Logfile & chr(34),1,false



' =====================================================================================
' Write data to log-file
' =====================================================================================
Function oIE_Document_write (strInput2)
on error resume next
	 Set oSaveToFile = FSO.OpenTextFile(Logfile, 8, true)
	 oSaveToFile.WriteLine(strInput2)
	 oSaveToFile.Close
End function




'================================================================================================

wscript.quit

'================================================================================================
