on error resume next
Set WSHShell = WScript.CreateObject( "WScript.Shell" )
Set fso = CreateObject("Scripting.FileSystemObject")
Set WshSysEnv = WshShell.Environment("PROCESS")
Dim Scriptpath: Scriptpath = fso.GetParentFolderName(WScript.ScriptFullName)
'Arguments:Logfolder/Logfile, Comment:
'Reports:Computername, Computer Model
'Exports: Computername, Computer Model
'Returns: 0
' =====================================================================================
' Arguments
' =====================================================================================
If WScript.Arguments.Count >= 1   Then
Dim objArgs : set objArgs = Wscript.Arguments
Dim Logfolder

For iParam = 0 To WScript.Arguments.Count -1
 Select Case ucase(objArgs(iParam))
      Case "/SILENT", "SILENT", "/S"
            SilentMode = True
      Case "/SUPERSILENT", "SUPERSILENT", "/QB-"
            SuperSilentMode = True
            SilentMode = True
      Case "/SHOW"
      			SuperSilentMode = False
      Case "UAC"
      		AdminMode = True
      Case Else

		IF fso.folderexists(objArgs(iParam)) then
			LogFolder =  objArgs(iParam)
			SuperSilentMode = True
		elseIF fso.fileexists(objArgs(iParam)) then
			Logfile =  objArgs(iParam)
			SuperSilentMode = True
		ELSE

			if left(objArgs(iParam),8) = "COMMENT:" then strExportComment= mid(objArgs(iParam),9)
		end if
 End Select
 cmdarg = cmdarg & " " & chr(34) & objArgs(iParam) & chr(34)
Next
End if

' =====================================================================================
' Setting logfile if not set
' =====================================================================================

If Not fso.folderexists(logfolder) Then logfolder = WshSysEnv("Public") & "\Documents\Cadcraft_SystemLogs"
If Not fso.folderexists(logfolder) Then fso.createfolder(logfolder)
if LogFile = "" then Logfile = logfolder & "\" & WScript.ScriptName & "[" & Replace(Replace(date & " "  & time, ":", "."),"/","-") & "]_Log.htm"

' =====================================================================================
' =====================================================================================
' Programcode
' =====================================================================================
' =====================================================================================


'================================================================================================
' Windows Experiance Info
'================================================================================================
'strComputer = Inputbox("Get Hardware Performance Ratings" &amp; vbcrlf &amp; "of a Remote computer," &amp; vbcrlf &amp; "Input the Computer Name:")
strComputer = "."

SET objWMIService = GETOBJECT("winmgmts:\\" & strComputer & "\root\cimv2")

Set colWSA = objWMIservice.ExecQuery("Select * From Win32_WinSAT")

For Each objItem in colWSA

WriteIEChar "<br><BR>"

 WriteIEChar "<TABLE Border=1 bordercolor='#000000'  align='center' cellpadding='2' cellspacing='0' width=100%>"
		Table2ColHeader " Hardware for:  " ,  CCGetDomainComputername

		Table2ColRow   "CPUScore" , objItem.CPUScore
		Table2ColRow  " D3DScore  " , objItem.D3DScore
		Table2ColRow  " GraphicsScore  " , objItem.GraphicsScore
		Table2ColRow  " DiskScore  " ,  objItem.DiskScore
		Table2ColRow  " MemoryScore  " ,  objItem.MemoryScore

		Table2ColRow  " WinSATAssessmentState" ,  objItem.WinSATAssessmentState

		Table2ColRow  " WEI Rating ",   objItem.WinSPRLevel



		'srvConfig =  CCGetCapuredDosValue("winsat prepop")
		'Table2ColRow  " WEI ",   srvConfig
		'srvConfig =  CCGetCapuredDosValue( Chr(34) & "%SystemRoot%\system32\WindowsPowerShell\v1.0\powershell.exe" & Chr(34) & " Get-WmiObject -class Win32_WinSAT")
		'if instr(1,srvConfig, ": 0") >  0 then msgbox "Noll"

		'Table2ColRow  " WEI ",   srvConfig

 WriteIEChar "</TABLE>"
Next





' =====================================================================================
' Creates a Excel Export file
' =====================================================================================
ExportVBS = fso.GetParentFolderName(fso.GetParentFolderName(WScript.ScriptFullName)) & "\Export_Log_result.vbs"


if fso.fileexists(ExportVBS) then

	strField = replace(wscript.scriptname, ".vbs", "")
	strValue = TemplateValue
	'wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true

End if
' =====================================================================================
' Open logfile when finish unless running in SuperSilentMode
' =====================================================================================
if fso.fileexists(Logfile) and SuperSilentMode=False then wshshell.run chr(34) & Logfile & chr(34),1,false


' =====================================================================================
' Exit with error code
' =====================================================================================

if Exitcode <> "" then
  if SuperSilentMode = false then msgbox exitcode
  wscript.quit(exitcode)

elseIf Err.Number <> 0 Then

  oIE_Document_write "Error in " & WScript.ScriptName & ":"  & Err.Description
  Err.Clear
  wscript.quit(-1 * err.number)
 else
  wscript.quit
End If




' =====================================================================================
' =====================================================================================
' =====================================================================================
' Function Definitions
' =====================================================================================
' =====================================================================================
' =====================================================================================


' =====================================================================================
' Write data to log-file
' =====================================================================================
Function oIE_Document_write (strInput2)
on error resume next
	 Set oSaveToFile = FSO.OpenTextFile(Logfile, 8, true)
	 oSaveToFile.WriteLine(strInput2)
	 oSaveToFile.Close
End function


'================================================================================================
' Table functions
'================================================================================================


Function Table3ColHeader (CellValue1, CellValue2, CellValue3)
	WriteIEChar "<TR bordercolor='#000000' bgcolor='#93959E' >"
		WriteIEchar "<TD nowrap>" &   CellValue1  & "</TD>"
		WriteIEchar "<TD nowrap>" & CellValue2  & "</TD>"
		WriteIEchar "<TD nowrap>" & CellValue3 & "</TD>"
	WriteIEChar "</TR>"

End Function
Function Table3ColRow(CellValue1, CellValue2, CellValue3)
	WriteIEChar "<TR bordercolor='#000000'  >"
	WriteIEchar "<TD  Width=200 bgcolor='#D5D5D7' nowrap>" & CellValue1 & "</TD>"
	WriteIEchar "<TD  nowrap><FONT FACE= 'Courier New' size=2>" & CellValue2 & "</TD>"
	WriteIEchar "<TD  nowrap><FONT FACE= 'Courier New' size=2>" & CellValue3 & "</TD>"
	WriteIEChar "</TR>"

End Function

Function Table2ColHeader (CellValue1, CellValue2)
	WriteIEChar "<TR bordercolor='#000000' bgcolor='#93959E' >"
		WriteIEchar "<TD nowrap>" &   CellValue1  & "</TD>"
		WriteIEchar "<TD nowrap>" & CellValue2  & "</TD>"
	WriteIEChar "</TR>"

End Function
Function Table2ColRow(CellValue1, CellValue2)
	WriteIEChar "<TR bordercolor='#000000' >"
	WriteIEchar "<TD  Width=200 bgcolor='#D5D5D7' nowrap>" & CellValue1 & "</TD>"
	WriteIEchar "<TD  nowrap><FONT FACE= 'Courier New' size=2>" & CellValue2 & "</TD>"
	WriteIEChar "</TR>"

End Function
Function CCGetDomainComputername()
          Set oNetwork = CreateObject("WScript.Network")
          ComputerN = oNetwork.ComputerName
          DomainN = oNetwork.UserDomain
	if ComputerN = "" then ComputerN = WshShell.ExpandEnvironmentStrings("%computername%")
	CCGetDomainComputername = DomainN & "\" & ComputerN
End function

'================================================================================================

wscript.quit

'================================================================================================



Function ccGetOS()

'******** OS ************
strComputer = "."
Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")


Set colOs = objWMIService.ExecQuery _
    ("Select * from Win32_OperatingSystem")
For Each objOs in colOs
		strOs=objOs.Name
		strSp="Sp " & objOs.ServicePackMajorVersion & "." & objOs.ServicePackMinorVersion

Next
intVar=Instr(strOs,"|")
strOs=Left(strOs,(intVar-1))
strOs=replace(strOs, "Microsoft Windows", "Windows")
strOs=replace(strOs, "Professional", "Pro")
ccGetOS = strOs & " " & strSP
End Function
Function ccGetMac()
dim WMI:  set WMI = GetObject("winmgmts:\\.\root\cimv2")
dim Nads: set Nads = WMI.ExecQuery("Select * from Win32_NetworkAdapter where physicaladapter=true and AdapterTypeID=0 and NetconnectionStatus=2")
dim nad
for each Nad in Nads
    if not isnull(Nad.MACAddress) then
    	if ccGetMac = "" then
    		'ccGetMac =  Nad.description & " " &  Nad.MACAddress
    		ccGetMac =  Nad.MACAddress
    	else
    		'ccGetMac = ccGetMac & "<br>" &  Nad.description & " " &  Nad.MACAddress
    	End if
    end if
next

End Function
Function ccGetIP()
on error resume next
dim NIC1, Nic, StrIP, CompName

Set NIC1 = GetObject("winmgmts:").InstancesOf("Win32_NetworkAdapterConfiguration")

For Each Nic in NIC1

if Nic.IPEnabled then


Set WshNetwork = WScript.CreateObject("WScript.Network")

CompName= WshNetwork.Computername

    	if ccGetIP = "" then
    		'ccGetIP = Nic.Description & " - " & Nic.IPAddress(0) & "- " &  Nic.IPAddress(1)
		ccGetIP =  Nic.IPAddress(0) & "- " &  Nic.IPAddress(1)

    	else
		'ccGetIP = ccGetIP & "<br>" & StrIP
    	End if




end if

next

End Function
Function ccGetIP2()


Dim NIC1, Nic, StrIP, CompName

Set NIC1 = GetObject("winmgmts:").InstancesOf("Win32_NetworkAdapterConfiguration")

For Each Nic in NIC1

if Nic.IPEnabled then

StrIP = Nic.IPAddress(i)

Set WshNetwork = WScript.CreateObject("WScript.Network")

CompName = WshNetwork.Computername

Dim WMI, Configs, Config, Adapters, Adapter

Set WMI = GetObject("winmgmts:{impersonationlevel=impersonate}root/cimv2")

' BEGIN CALLOUT A
Set Configs = WMI.ExecQuery("Select * From Win32_NetworkAdapterConfiguration")
' END CALLOUT A

For Each Config In Configs
' BEGIN CALLOUT B
Set Adapters = WMI.AssociatorsOf("Win32_NetworkAdapterConfiguration.Index=" & Config.Index, "Win32_NetworkAdapterSetting")
' END CALLOUT B
For Each Adapter In Adapters
'If Left(Adapter.Description, 14) = "Cisco AnyConnect VPN Virtual Miniport Adapter for Windows" Then
VPNIP = Config.IPAddress(0)
 if ccGetIP = "" then
 ccGetIP = Adapter.Description & " " & StrIP & "V/ ("& VPNIP & ")"
 else
 ccGetIP = ccGetIP  & "<br>" &  Adapter.Description & " " & StrIP & "V/ ("& VPNIP & ")"
 end if
'End If
Next
Next

'ccGetIP =  "IP Address: "&StrIP & "VPN IP Address: "&VPNIP



end if

next



End Function

function ccGetGraphicsCard()


strComputer = "."
Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")

dim  winmgt, SNSet, Name, Description, Size_Speed, VideoProcessor, VideoModeDescription
winmgt = "winmgmts:{impersonationLevel=impersonate}!//"
Set SNSet = GetObject(winmgt).InstancesOf("Win32_VideoController")

for each objItem in SNSet
	Name = objItem.Name
	Description = objItem.Description
	Size_Speed = Int( ( objItem.AdapterRAM + 524288 ) / 1048576 ) & " Mb"
	VideoProcessor = objItem.VideoProcessor
	VideoModeDescription = objItem.VideoModeDescription
	ccGetGraphicsCard = ccGetGraphicsCard & "<br><B>Name: </B>" & Name
	ccGetGraphicsCard = ccGetGraphicsCard & "<br><B>Description: </B>" & Description
	ccGetGraphicsCard = ccGetGraphicsCard & "<br><B>Size_Speed: </B>" & Size_Speed
	ccGetGraphicsCard = ccGetGraphicsCard & "<br><B>VideoProcessor: </B>" & VideoProcessor
	ccGetGraphicsCard = ccGetGraphicsCard & "<br><B>VideoModeDescription: </B>" & VideoModeDescription
	ccGetGraphicsCard = ccGetGraphicsCard & "<br><B>Driverversion: </B>" & objItem.Driverversion


Next



End function


Function ccGetMemory()

strComputer = "."

Set objWMIService = GetObject("winmgmts:" _
& "{impersonationLevel=impersonate}!\\" _
& strComputer & "\root\cimv2")
Set colComputer = objWMIService.ExecQuery _
("Select * from Win32_ComputerSystem")

For Each objComputer in colComputer
     ccGetMemory =  "Total Physical Memory: " & _
        fix(objComputer.TotalPhysicalMemory /1024/1024/1024+0.5)  & " Gb"

Next

strComputer = "."
Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")

Set colSettings = objWMIService.ExecQuery _
    ("Select * from Win32_OperatingSystem")


For Each objOperatingSystem in colSettings
    ccGetMemory = ccGetMemory &  "<br>" & "Available Physical Memory: " & _
        fix(objOperatingSystem.FreePhysicalMemory /1024/1024+0.5)  & " Gb"
    ccGetMemory = ccGetMemory & "<br>" &  "Total Virtual Memory: " & _
        fix(objOperatingSystem.TotalVirtualMemorySize /1024/1024+0.5)  & " Gb"
    ccGetMemory = ccGetMemory & "<br>" &  "Available Virtual Memory: " & _
       fix( objOperatingSystem.FreeVirtualMemory /1020/1024+0.5)  & " Gb"
    ccGetMemory = ccGetMemory & "<br>" &  "Size stored in paging files: " & _
       fix(objOperatingSystem.SizeStoredInPagingFiles /1024/1024+0.5) & " Gb"
Next

End Function

Function ccGetDiskTable ()
ccGetDiskTable =   "<LEFT><Table border=0 width=100%>"


'DIM objWMIService, objItem, colItems
'DIM strDriveType, strDiskSize, txt

SET objWMIService = GETOBJECT("winmgmts:\\" & strComputer & "\root\cimv2")
SET colItems = objWMIService.ExecQuery("Select * from Win32_LogicalDisk WHERE DriveType=3")
ccGetDiskTable = ccGetDiskTable &   "<B><TR><FONT FACE='Courier New' size=2>"

ccGetDiskTable = ccGetDiskTable &  "<TD>Drive" & "</TD>"
ccGetDiskTable = ccGetDiskTable &   "<TD >" & vbtab & "Size" &  "</TD>"
ccGetDiskTable = ccGetDiskTable &   "<TD >" & vbtab & "Used" &  "</TD>"
ccGetDiskTable = ccGetDiskTable &   "<TD >" & vbtab & "Free" &  "</TD>"
ccGetDiskTable = ccGetDiskTable &   "<TD >" & vbtab & "Free(%)" &  "</TD>"
ccGetDiskTable = ccGetDiskTable &   "</FONT></TR></B>"

FOR EACH objItem in colItems
ccGetDiskTable = ccGetDiskTable &   "<TR><FONT FACE='Courier New' size=2>"
	DIM pctFreeSpace,strFreeSpace,strusedSpace

	if ucase(objItem.Name) = "C:" then CFreeSpace  = objItem.FreeSpace
	pctFreeSpace = INT((objItem.FreeSpace / objItem.Size) * 1000)/10
	strDiskSize = Int(objItem.Size /1073741824) & " Gb"
	strFreeSpace = Int(objItem.FreeSpace /1073741824) & " Gb"
	strUsedSpace = Int((objItem.Size-objItem.FreeSpace)/1073741824) & " Gb"
ccGetDiskTable = ccGetDiskTable &   "<TD >"& objItem.Name & "</TD>"
ccGetDiskTable = ccGetDiskTable &   "<TD >" & strDiskSize & "</TD>"
ccGetDiskTable = ccGetDiskTable &   "<TD >" & strUsedSpace & "</TD>"
ccGetDiskTable = ccGetDiskTable &   "<TD >" & strFreeSpace & "</TD>"
ccGetDiskTable = ccGetDiskTable &   "<TD >" & pctFreeSpace &"</TD>"
ccGetDiskTable = ccGetDiskTable &   "</FONT></TR>"
NEXT

ccGetDiskTable = ccGetDiskTable &   "</TABLE>"

End Function
Function ccGetComputerModel ()
On Error Resume Next
strComputer = "."
Set objWMIService = GetObject("winmgmts:\\" & strComputer & "\root\cimv2")
Set colItems = objWMIService.ExecQuery("Select * from Win32_ComputerSystem",,48)

For Each objItem in colItems
strModel = objItem.Model
If strModel = "Virtual Machine" Then
MachineType =  "(Virtual Machine)"
else
MachineType = "(Physical)"
End if
Next

strComputer = "."
Set objWMIService = GetObject("winmgmts:\\" & strComputer & "\root\cimv2")
Set colItems = objWMIService.ExecQuery("Select * from Win32_ComputerSystemProduct",,48)
For Each objItem in colItems
Val1 = "Vendor: " & objItem.Vendor
Val2 = "  Model: " & objItem.Name
ComputerData = ComputerData &  val1 & Val2Next & " " &  MachineType
Next
ccGetComputerModel = ComputerData &  MachineType

End function




'-----------------------------------------------------------------------------------------------------------------------
'Starting dos command and capture output
'-----------------------------------------------------------------------------------------------------------------------


Sub CaptureDosOutputToFile (strDosCommand)
strTempFile = CreateTempFile
return = WshShell.Run(chr(34) & strDosCommand  & chr(34) &  " > " & chr(34) & strTempFile & chr(34), 0, true)
'
Set fso  = CreateObject("Scripting.FileSystemObject")
if fso.fileexists(strTempFile) then
	Set file = fso.OpenTextFile(strTempFile, 1)
	text = file.ReadLine
	Do While Not file.AtEndOfStream
	   WriteIE strText
	    strText = file.ReadLine()
	Loop
	file.Close
else
 msgbox "missing"
'
End if
End sub
'wscript.quit
'-----------------------------------------------------------------------------------------------------------------------
'Starting dos command and capture output
'-----------------------------------------------------------------------------------------------------------------------


'-----------------------------------------------------------------------------------------------------------------------
'Starting dos command and capture output
'-----------------------------------------------------------------------------------------------------------------------
Function CCGetCapuredDosValue (strDosCommand)
'WriteIEBold "Executing: " & strDosCommand
Dim objArguments
Set objShell = WScript.CreateObject("WScript.Shell")
Set objArguments = Wscript.Arguments
Set objShell = WScript.CreateObject("WScript.Shell")
Set objExecObject = objShell.Exec(strDosCommand)
Do While Not objExecObject.StdOut.AtEndOfStream
    strtext = replace(strtext,"          ", "  ")
    strText = objExecObject.StdOut.ReadLine()
    strText = ReplaceDOSChar(strText)
' Test or display strText

   CCGetCapuredDosValue = CCGetCapuredDosValue & "<BR>"  & strText

Loop


End Function

Function ccGetCapureDosValueIncludeFilter (strDosCommand, strFilter)
'WriteIEBold "Executing: " & strDosCommand & " | findstr " & strFilter
Dim objArguments
Set objShell = WScript.CreateObject("WScript.Shell")
Set objArguments = Wscript.Arguments
Set objShell = WScript.CreateObject("WScript.Shell")
Set objExecObject = objShell.Exec(strDosCommand)
Do While Not objExecObject.StdOut.AtEndOfStream
    strText = objExecObject.StdOut.ReadLine()
    strText = ReplaceDOSChar(strText)

' Test or display strText
  if instr(1,strText, strFilter, vbtextcompare) > 0 then
  	strtext = replace(strtext,"          ", "  ")

  	ccGetCapureDosValueIncludeFilter = ccGetCapureDosValueIncludeFilter & "<BR>"  & strText
  	else
  	'WriteIE strText

  end if
Loop
End Function
Function ccGetCapureDosValueIncludePrefixFilter (strDosCommand, strFilter)
on error resume next
'WriteIEBold "Executing: " & strDosCommand & " | findstr " & strFilter
Dim objArguments
Set objShell = WScript.CreateObject("WScript.Shell")
Set objArguments = Wscript.Arguments
Set objShell = WScript.CreateObject("WScript.Shell")

Set objExecObject = objShell.Exec(strDosCommand)
Do While Not objExecObject.StdOut.AtEndOfStream
    strText = objExecObject.StdOut.ReadLine()
    strText = ReplaceDOSChar(strText)

' Test or display strText
  if left(strText,len(strFilter)) = strFilter then
  	strtext = replace(strtext,"          ", "  ")

  	ccGetCapureDosValueIncludePrefixFilter = ccGetCapureDosValueIncludePrefixFilter & "<BR>"  & strText
  	else
  	'WriteIE strText

  end if
Loop
'   Update_Status_Field "Command finished"

End Function
Sub CapureDosValue (strDosCommand)
'WriteIEBold "Executing: " & strDosCommand
Dim objArguments
Set objShell = WScript.CreateObject("WScript.Shell")
Set objArguments = Wscript.Arguments
Set objShell = WScript.CreateObject("WScript.Shell")
Set objExecObject = objShell.Exec(strDosCommand)
Do While Not objExecObject.StdOut.AtEndOfStream
    strtext = replace(strtext,"          ", "  ")
    strText = objExecObject.StdOut.ReadLine()
    strText = ReplaceDOSChar(strText)
' Test or display strText

   WriteIE "<FONT FACE= 'Courier New'>" & strText & "</FONT>"

Loop
'   Update_Status_Field "Command finished"

End Sub

Sub CapureDosValueIncludeFilter (strDosCommand, strFilter)
'WriteIEBold "Executing: " & strDosCommand & " | findstr " & strFilter
Dim objArguments
Set objShell = WScript.CreateObject("WScript.Shell")
Set objArguments = Wscript.Arguments
Set objShell = WScript.CreateObject("WScript.Shell")
Set objExecObject = objShell.Exec(strDosCommand)
Do While Not objExecObject.StdOut.AtEndOfStream
    strText = objExecObject.StdOut.ReadLine()
    strText = ReplaceDOSChar(strText)

' Test or display strText
  if instr(1,strText, strFilter, vbtextcompare) > 0 then
  	strtext = replace(strtext,"          ", "  ")

  	WriteIE "<FONT FACE= 'Courier New'>" & strText & "</FONT>"
  	else
  	'WriteIE strText

  end if
Loop
'   Update_Status_Field "Command finished"

End Sub

Sub CapureDosSQL (strDosCommand, strFilter)
'WriteIEBold "Executing: " & strDosCommand & " | findstr " & strFilter
Dim objArguments
Set objShell = WScript.CreateObject("WScript.Shell")
Set objArguments = Wscript.Arguments
Set objShell = WScript.CreateObject("WScript.Shell")
Set objExecObject = objShell.Exec(strDosCommand)
Do While Not objExecObject.StdOut.AtEndOfStream
    strText = objExecObject.StdOut.ReadLine()
    strText = ReplaceDOSChar(strText)

' Test or display strText
  if instr(1,strText, strFilter, vbtextcompare) > 0 then
  	strtext = replace(strtext,"          ", "  ")


  	WriteIE "<FONT FACE= 'Courier New'>" & strText & "</FONT>"
  	else
  	'WriteIE strText

  end if
Loop
'   Update_Status_Field "Command finished"

End Sub

Function ReplaceDOSChar( strText )
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,""," ")
	strText = Replace(strText,"  ","&nbsp;&nbsp;")
	ReplaceDOSChar = strText
End Function


'-----------------------------------------------------------------------------------------------------------------------
' Function to write text to logwindow/logfile
'-----------------------------------------------------------------------------------------------------------------------


	Function WriteIE (strInput)
	 oIE_Document_write "&nbsp;&nbsp;&nbsp;&nbsp;<font face=""Arial"" size=2>" & vbTab & strInput & "</font><br>"
	End Function

	Function writeIEList(strInput)
	  oIE_Document_write "<li><font face=""Arial"" size=2>" & vbTab & strInput & "</font></li><br>"
	End Function

	Function writeIEBold(strInput)
	  oIE_Document_write "<strong><font face=""Arial"" size=2>" & strInput & "</font></strong><br>"
	End Function

	Function writeIEHeader(strInput)
	  oIE_Document_write "<br><strong><font face=""Arial"" size=3>" & strInput & "</font></strong><br>"
	End Function
	Function writeIEChar(strInput)
	  oIE_Document_write strInput
	End Function





Function VaultManager ()
' =============================================================================
WriteIE "==== Sker fram skvg till Vaultmanager" & " ===="
' =============================================================================
'"C:\Program Files\Autodesk\ADMS Workgroup 2014\ADMS Console\Connectivity.ADMSConsole.exe"
'"C:\Program Files\Autodesk\ADMS Workgroup 2014\ADMS Console\Connectivity.ADMSConsole.exe

on error goto 0
if VaultManagerEXE="" then
	strComputer = "."
	Set objWMIService = GetObject("winmgmts:" _
		& "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")

	Set colListOfServices = objWMIService.ExecQuery _
			("Select * from Win32_Service where Name = 'Autodesk Data Management Job Dispatch'") 'Connectivity.WindowsService.JobDispatch

	For Each objService in colListOfServices
		writeie objService.Name
		writeie objService.PathName
		 VaultManagerEXE =   fso.GetParentFolderName(fso.GetParentFolderName( fso.GetParentFolderName(replace(objService.PathName, chr(34),""))))
	Next

	if VaultManagerEXE="" then
		writeie  "==== Hittade inte skvg till Vaultmanager - Stt den manuellt genom att ndra i backupskriptet" & " ===="
		'wscript.quit

	else
		VaultManagerEXE = VaultManagerEXE & "\ADMS Console\Connectivity.ADMSConsole.exe"
		writeie "==== Skvg till Vaultmanager satt till " & VaultManagerEXE


	end if

else
	writeie "==== Fast skvg till Vaultmanager satt till " & VaultManagerEXE


End if


End Function


Function ccGetSQLExeCuteTable (strSQLString)
 'WriteIE "<B>SQL Data from: </B>" & strSQLString
 Dim objDB,arrRecord,strRecord,strOutput
 Dim oRS, nRec, oFld

 'Main Processing section
 'Database connection & select all from Table
 Set objDB = AutoDeskKnowledgeVaultMasterDBConnect()
 Set oRS = objDB.Execute(strSQLString)
 'Dump Records from Table
 nRec = 0
 Dim HeaderWritten
 ccGetSQLExeCuteTable =  "<TABLE width=100% Border=0>"
 HeaderWritten = False
 Do While Not oRS.EOF

    'WriteIEBold "-----"&  nRec
    nRec = nRec + 1
	if HeaderWritten = False then
		ccGetSQLExeCuteTable = ccGetSQLExeCuteTable &  "<TR>"
		For Each oFld In oRS.Fields
			ccGetSQLExeCuteTable = ccGetSQLExeCuteTable &  "<TD><FONT FACE='Courier New' size=2>" & oFld.Name  & "</FONT></TD>"
		Next
		ccGetSQLExeCuteTable = ccGetSQLExeCuteTable &  "</TR>"
		HeaderWritten = True

	End if
	ccGetSQLExeCuteTable = ccGetSQLExeCuteTable &  "<TR>"
	For Each oFld In oRS.Fields
		ccGetSQLExeCuteTable = ccGetSQLExeCuteTable &  "<TD nowrap><FONT FACE='Courier New' size=2>" & oFld.Value  & "</FONT></TD>"
	Next
	ccGetSQLExeCuteTable = ccGetSQLExeCuteTable &  "</TR>"
       ' WriteIE oFld.Name & " = " & oFld.Value
    oRS.MoveNext
 Loop


 ccGetSQLExeCuteTable = ccGetSQLExeCuteTable &  "</TABLE>"

End Function



Function ccGetSQLExeCuteValue (strSQLString)
 'WriteIE "<B>SQL Data from: </B>" & strSQLString
 Dim objDB,arrRecord,strRecord,strOutput
 Dim oRS, nRec, oFld

 'Main Processing section
 'Database connection & select all from Table
 Set objDB = AutoDeskKnowledgeVaultMasterDBConnect()
 Set oRS = objDB.Execute(strSQLString)
 'Dump Records from Table
 nRec = 0
 Dim HeaderWritten
 HeaderWritten = False
 Do While Not oRS.EOF

    'WriteIEBold "-----"&  nRec
    nRec = nRec + 1
	For Each oFld In oRS.Fields
		if ccGetSQLExeCuteValue = "" then
			ccGetSQLExeCuteValue =  oFld.Value
		else
			ccGetSQLExeCuteValue = ccGetSQLExeCuteValue & ";" & oFld.Value
		End if
	Next

    oRS.MoveNext
 Loop


End Function


Sub SQLExeCute (strSQLString)
 WriteIE "<B>SQL Data from: </B>" & strSQLString

 Dim objDB,arrRecord,strRecord,strOutput
 Dim oRS, nRec, oFld

 'Main Processing section
 'Database connection & select all from Table
 Set objDB = AutoDeskKnowledgeVaultMasterDBConnect()
 Set oRS = objDB.Execute(strSQLString)
 'Dump Records from Table
 nRec = 0
 Dim HeaderWritten
 WriteIEChar "<TABLE Border=1>"
 HeaderWritten = False
 Do While Not oRS.EOF

    'WriteIEBold "-----"&  nRec
    nRec = nRec + 1
	if HeaderWritten = False then
		WriteIEChar "<TR>"
		For Each oFld In oRS.Fields
			WriteIEchar "<TD>" & oFld.Name  & "</TD>"
		Next
		WriteIEChar "</TR>"
		HeaderWritten = True

	End if
	WriteIEChar "<TR>"
	For Each oFld In oRS.Fields
		WriteIEchar "<TD nowrap>" & oFld.Value  & "</TD>"
	Next
	WriteIEChar "</TR>"
       ' WriteIE oFld.Name & " = " & oFld.Value
    oRS.MoveNext
 Loop


 WriteIEChar "</TABLE>"
End Sub
 'Procedures section
 'This function sets up DB Connection using specified DSN
Function AutoDeskVaultDBConnect()

		Set objDB = CreateObject("ADODB.Connection")
		objDB.Open "DRIVER={SQL Server};Database=" & scriptpath & "\InstallManagerDB.sqlite;"

	'Set objDB = CreateObject("ADODB.Connection")
   ' objDB.Open "portal"
	    Set DBConnect = objDB
dim dbconn, connect
connect = "Driver={SQL Server};Server=XXX;database=XXX;uid=XXX;pwd=XXX"
Set dbconn = CreateObject("ADODB.Connection")
dbconn.Open connect
dbconn.Execute(SQL)

End Function
Function MySQLDBConnect()

		Set objDB = CreateObject("ADODB.Connection")
		objDB.Open "DRIVER=SQLite3 ODBC Driver;Database=" & scriptpath & "\InstallManagerDB.sqlite;"

	'Set objDB = CreateObject("ADODB.Connection")
   ' objDB.Open "portal"
	    Set MySQLDBConnect = objDB
 End Function

Function AutoDeskVaultDBConnect(strVaultName)
strServer = "(local)\AUTODESKVAULT"
strDatabase = strVaultName
strPassword= "AutodeskVault"
strUsername="sa"


'objDB.Open "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & DBPath & ";"	'ppnar Accessdatabasen
'objDB.Open "DSN=" & strDatabase & ";UID=" & strUsername & ";PWD=" & strPassword & ";" 'ppnar ODBC kllan
		Set objDB = CreateObject("ADODB.Connection")


	CN_String = "Provider=SQLXMLOLEDB.3.0;" & _
		   "Data Provider=SQLOLEDB;" & _
		   "Data Source=" & strServer & ";" & _
		   "Initial Catalog=" & strDatabase & ";" & _
		   "User Id=" & strUsername & ";" & _
		   "Password=" & strPassword & ";"

	CN_String = "Provider=SQLOLEDB;" & _
		   "Data Source=" & strServer & ";" & _
		   "Initial Catalog=" & strDatabase & ";" & _
		   "User Id=" & strUsername & ";" & _
		   "Password=" & strPassword & ";"

		   objDB.Open CN_String
		   Set AutoDeskVaultDBConnect = objDB
End function
Function AutoDeskKnowledgeVaultMasterDBConnect()
strServer = "(local)\AUTODESKVAULT"
strDatabase = "KnowledgeVaultMaster"
strPassword= "AutodeskVault@26200"
strUsername="sa"


'objDB.Open "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & DBPath & ";"	'ppnar Accessdatabasen
'objDB.Open "DSN=" & strDatabase & ";UID=" & strUsername & ";PWD=" & strPassword & ";" 'ppnar ODBC kllan
		Set objDB = CreateObject("ADODB.Connection")


	CN_String = "Provider=SQLXMLOLEDB.3.0;" & _
		   "Data Provider=SQLOLEDB;" & _
		   "Data Source=" & strServer & ";" & _
		   "Initial Catalog=" & strDatabase & ";" & _
		   "User Id=" & strUsername & ";" & _
		   "Password=" & strPassword & ";"

	CN_String = "Provider=SQLOLEDB;" & _
		   "Data Source=" & strServer & ";" & _
		   "Initial Catalog=" & strDatabase & ";" & _
		   "User Id=" & strUsername & ";" & _
		   "Password=" & strPassword & ";"

		   objDB.Open CN_String
		   Set AutoDeskKnowledgeVaultMasterDBConnect = objDB
End function

Function AutoDeskVaultDBConnect(strVaultName)
strServer = "(local)\AUTODESKVAULT"
strDatabase = strVaultName
strPassword= "AutodeskVault"
strUsername="sa"


'objDB.Open "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & DBPath & ";"	'ppnar Accessdatabasen
'objDB.Open "DSN=" & strDatabase & ";UID=" & strUsername & ";PWD=" & strPassword & ";" 'ppnar ODBC kllan
		Set objDB = CreateObject("ADODB.Connection")


	CN_String = "Provider=SQLXMLOLEDB.3.0;" & _
		   "Data Provider=SQLOLEDB;" & _
		   "Data Source=" & strServer & ";" & _
		   "Initial Catalog=" & strDatabase & ";" & _
		   "User Id=" & strUsername & ";" & _
		   "Password=" & strPassword & ";"

	CN_String = "Provider=SQLOLEDB;" & _
		   "Data Source=" & strServer & ";" & _
		   "Initial Catalog=" & strDatabase & ";" & _
		   "User Id=" & strUsername & ";" & _
		   "Password=" & strPassword & ";"

		   objDB.Open CN_String
		   Set AutoDeskVaultDBConnect = objDB
End function

