on error resume next
Set WSHShell = WScript.CreateObject( "WScript.Shell" )
Set fso = CreateObject("Scripting.FileSystemObject")
Set WshSysEnv = WshShell.Environment("PROCESS")
Dim Scriptpath: Scriptpath = fso.GetParentFolderName(WScript.ScriptFullName)
Group = ""

' =====================================================================================
' Arguments
' =====================================================================================

If  WScript.Arguments.Count < 5 Then

	msgbox "not enought parameters"
 wscript.quit(1603)

else
'Dim objArgs : set objArgs = Wscript.Arguments
		LogFile = Wscript.Arguments(0)


'creplace(logfile, ".htm","_H.csv", vbtextcompare)

csvLogfileH = replace(logfile, ".htm",".csv",vbTextCompare)
csvLogFileV  = Left(logfile, InstrRev(logfile, "\")) & "Total_log.csv"

if LogFile = "" then Logfile = logfolder & "\" & WScript.ScriptName & "[" & Replace(Replace(date & " "  & time, ":", "."),"/","-") & "]_Log.CSV"
ArgField = Wscript.Arguments(1)
ArgValue = Wscript.Arguments(2)
Group = mid(Wscript.Arguments(3),len(fso.GetParentFolderName(WScript.ScriptFullName))+2)
strExportComment = Wscript.Arguments(4)

ArgValue = ReplaceTextForCSV(ArgValue)
logfile = csvLogfile
WriteCSVH  ArgField,  ArgValue
if not fso.fileexists(csvLogFileV) then WriteCSVV "Computername" & ";" & "Username" & ";" & "Group" & ";" & "Field" & ";" & "Value"  & ";" & "Timestamp" & ";" & "Export Comment" & ";" &  "Retries"
WriteCSVV WshSysEnv("Computername") & ";" & WshSysEnv("Username") & ";" & Group & ";" & ArgField & ";" & ArgValue  & ";" & DATE & " " & TIME & ";" & strExportComment

End if



Function ReplaceTextForCSV (strText)
strNewText =  Replace(strText, "&nbsp;", " ")
strNewText =  Replace(strNewText, ";", "",1,-1,1)
strNewText =  Replace(strNewText, vblf, "",1,-1,1)
strNewText =  Replace(strNewText, vbcr, "",1,-1,1)
strNewText =  Replace(strNewText, vbcrlf, "",1,-1,1)
strNewText =  Replace(strNewText, "<br>", "/",1,-1,1)
strNewText =  Replace(strNewText, "<BR>", "\",1,-1,1)
strNewText = removeHtml(strNewText)
ReplaceTextForCSV =  strNewText

End function

'-----------------------------------------------------------------------------------------------------------------------
' Remove HTML Tags from Text
'-----------------------------------------------------------------------------------------------------------------------
Function RemoveHTML( strText )
    Dim nPos1
    Dim nPos2

    nPos1 = InStr(strText, "<")
    Do While nPos1 > 0
        nPos2 = InStr(nPos1 + 1, strText, ">")
        If nPos2 > 0 Then
            strText = Left(strText, nPos1 - 1) & Mid(strText, nPos2 + 1)
        Else
            Exit Do
        End If
        nPos1 = InStr(strText, "<")
    Loop

    RemoveHTML = strText
End Function

' =====================================================================================
' Exit with error code
' =====================================================================================


If Err.Number <> 0 Then
  oIE_Document_write "Error in " & WScript.ScriptName & ":"  & Err.Description
  Err.Clear
  wscript.quit(err.number)
 else
  wscript.quit
End If



' =====================================================================================
' =====================================================================================
' =====================================================================================
' Function Definitions
' =====================================================================================
' =====================================================================================
' =====================================================================================


' =====================================================================================
' Saves data to log-file
' =====================================================================================

Function WriteCSVV (strInput2)
on error resume next
	 err.clear
	 iLoopCount = 0
	 Do
	 	 err.clear
		 iLoopCount = iLoopCount  +1
		 Set oSaveToFile = FSO.OpenTextFile(csvLogFileV, 8, true)
		 wscript.sleep 500
	 Loop While err.number <> 0 and iLoopCount < 30
	if err.number = 0 then
	 oSaveToFile.WriteLine(strInput2 & ";" & iLoopCount)
	 oSaveToFile.Close
	   else
	   	'msgbox "Failed accessing the file:" & csvLogFileV & vblf & err.description
	end if
	oSaveToFile.Close
End function


Function WriteCSVH (strField, strValue)

	Const ForReading = 1

	Const ForWriting = 2

	Set objFSO = CreateObject("Scripting.FileSystemObject")
	if fso.fileexists(csvLogFileH) then
	Set objFile = objFSO.OpenTextFile(csvLogFileH, ForReading)
	'if Not file.AtEndOfStream then  'objFile.ReadLine	'strText = objFile.ReadAll

	strFieldRow = objFile.ReadLine()
	strValueRow = objFile.ReadLine()
	objFile.Close

	end if
	Set objFile = objFSO.OpenTextFile(csvLogfileH, ForWriting, true)
	if strFieldRow <> "" then

		objFile.WriteLine strFieldRow & ";" & strField
		objFile.WriteLine strValueRow & ";" & strValue
		else

		objFile.WriteLine strField
		objFile.WriteLine strValue
	End if
	objFile.Close
End function


Function CheckFileAcess (strFilename)

Dim  fi                      ' object variable
Const ForAppending = 8          ' Append mode
Const ForWriting = 2           	' Writemode mode
Const ForReading = 1		' Reading mode
Dim Wshshell:   Set WSHShell = CreateObject( "WScript.Shell" )
Dim Fso:        Set fso = CreateObject("Scripting.FileSystemObject")
Dim Scriptpath  : scriptpath = fso.GetParentFolderName(ScriptFullName)


on error resume next
'strFilename = scriptpath  & "\test.htm"
'strFilename = "C:\hiberfil.sys"
Dim oFile
if fso.fileexists(strFilename) then

	set ofile = fso.getfile(strFilename)
	if ofile.attributes and 5 then
		CheckFileAcess=False
	else

		' open file, force create, if not exists
		Set fi = fso.OpenTextFile(strFilename, ForAppending, true)

		if err.number<> 0 then
		'msgbox err.number
		'msgbox err.description
		CheckFileAcess=False
		else
		CheckFileAcess = True
		end if
		Set fi = Nothing

	end if
else
	CheckFileAcess = False
end if
end function
