on error resume next
Set WSHShell = WScript.CreateObject( "WScript.Shell" )
Set fso = CreateObject("Scripting.FileSystemObject")
Set WshSysEnv = WshShell.Environment("PROCESS")
Dim Scriptpath: Scriptpath = fso.GetParentFolderName(WScript.ScriptFullName)
'Arguments:Logfolder/Logfile, Comment:
'Reports:Computername, Computer Model
'Exports: Computername, Computer Model
'Returns: 0
' =====================================================================================
' Arguments
' =====================================================================================
If WScript.Arguments.Count >= 1   Then
Dim objArgs : set objArgs = Wscript.Arguments
Dim Logfolder

For iParam = 0 To WScript.Arguments.Count -1
 Select Case ucase(objArgs(iParam))
      Case "/SILENT", "SILENT", "/S"
            SilentMode = True
      Case "/SUPERSILENT", "SUPERSILENT", "/QB-"
            SuperSilentMode = True
            SilentMode = True
      Case "/SHOW"
      			SuperSilentMode = False
      Case "UAC"
      		AdminMode = True
      Case Else

		IF fso.folderexists(objArgs(iParam)) then
			LogFolder =  objArgs(iParam)
			SuperSilentMode = True
		elseIF fso.fileexists(objArgs(iParam)) then
			Logfile =  objArgs(iParam)
			SuperSilentMode = True
		ELSE

			if left(objArgs(iParam),8) = "COMMENT:" then strExportComment= mid(objArgs(iParam),9)
		end if
 End Select
 cmdarg = cmdarg & " " & chr(34) & objArgs(iParam) & chr(34)
Next
End if

' =====================================================================================
' Setting logfile if not set
' =====================================================================================

If Not fso.folderexists(logfolder) Then logfolder = WshSysEnv("Public") & "\Documents\Cadcraft_SystemLogs"
If Not fso.folderexists(logfolder) Then fso.createfolder(logfolder)
if LogFile = "" then Logfile = logfolder & "\" & WScript.ScriptName & "[" & Replace(Replace(date & " "  & time, ":", "."),"/","-") & "]_Log.htm"

' =====================================================================================
' =====================================================================================
' Programcode
' =====================================================================================
' =====================================================================================


oIE_Document_write GetOS(WshSysEnv("Computername"))


Private Function GetOS(strComputer)

	On Error Resume Next

	Dim objWMIService: Set objWMIService = GetObject("winmgmts:\\" & strComputer & "\root\cimv2")
	Dim colItems: Set colItems = objWMIService.ExecQuery("Select * from Win32_OperatingSystem")
	Dim strResult
	Dim objItem
	For Each objItem in colItems
		strResult = Trim(objItem.Caption)
	Next

	'Return Results
	If Err.Number <> 0 Then
		Err.Clear
		strResult = "!~ERROR~!"
	End If
	GetOS = strResult

	'Kill Objects
	Set objWMIService = Nothing

	On Error Goto 0

End Function


' =====================================================================================
' Creates a Excel Export file
' =====================================================================================
ExportVBS = fso.GetParentFolderName(fso.GetParentFolderName(WScript.ScriptFullName)) & "\Export_Log_result.vbs"


if fso.fileexists(ExportVBS) then

	strField = replace(wscript.scriptname, ".vbs", "")
	strValue = TemplateValue
	wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true

End if
' =====================================================================================
' Open logfile when finish unless running in SuperSilentMode
' =====================================================================================
if fso.fileexists(Logfile) and SuperSilentMode=False then wshshell.run chr(34) & Logfile & chr(34),1,false


' =====================================================================================
' Exit with error code
' =====================================================================================

if Exitcode <> "" then
  if SuperSilentMode = false then msgbox exitcode
  wscript.quit(exitcode)

elseIf Err.Number <> 0 Then

  oIE_Document_write "Error in " & WScript.ScriptName & ":"  & Err.Description
  Err.Clear
  wscript.quit(-1 * err.number)
 else
  wscript.quit
End If




' =====================================================================================
' =====================================================================================
' =====================================================================================
' Function Definitions
' =====================================================================================
' =====================================================================================
' =====================================================================================


' =====================================================================================
' Saves data to log-file
' =====================================================================================

Function oIE_Document_write (strInput2)
on error resume next
	 Set oSaveToFile = FSO.OpenTextFile(Logfile, 8, true)
	 oSaveToFile.WriteLine(strInput2)
	 oSaveToFile.Close
End function
