on error resume next
Set WSHShell = WScript.CreateObject( "WScript.Shell" )
Set fso = CreateObject("Scripting.FileSystemObject")
Set WshSysEnv = WshShell.Environment("PROCESS")
Dim Scriptpath: Scriptpath = fso.GetParentFolderName(WScript.ScriptFullName)
'Arguments:Logfolder/Logfile, Comment:
'Reports: Disksize and Free space for all local drives
'Exports: Free C-Space and Diskspace C-Drive
'Returns: Free Diskspace C-Drive
' =====================================================================================
' Arguments
' =====================================================================================
If WScript.Arguments.Count >= 1   Then
Dim objArgs : set objArgs = Wscript.Arguments
Dim Logfolder

For iParam = 0 To WScript.Arguments.Count -1
 Select Case ucase(objArgs(iParam))
      Case "/SILENT", "SILENT", "/S"
            SilentMode = True
      Case "/SUPERSILENT", "SUPERSILENT", "/QB-"
            SuperSilentMode = True
            SilentMode = True
      Case "/SHOW"
      			SuperSilentMode = False
      Case "UAC"
      		AdminMode = True
      Case Else

		IF fso.folderexists(objArgs(iParam)) then
			LogFolder =  objArgs(iParam)
			SuperSilentMode = True
		elseIF fso.fileexists(objArgs(iParam)) then
			Logfile =  objArgs(iParam)
			SuperSilentMode = True
		ELSE

			if left(objArgs(iParam),8) = "COMMENT:" then strExportComment= mid(objArgs(iParam),9)
		end if
 End Select
 cmdarg = cmdarg & " " & chr(34) & objArgs(iParam) & chr(34)
Next
End if

' =====================================================================================
' Setting logfile if not set
' =====================================================================================

If Not fso.folderexists(logfolder) Then logfolder = WshSysEnv("Public") & "\Documents\Cadcraft_SystemLogs"
If Not fso.folderexists(logfolder) Then fso.createfolder(logfolder)
if LogFile = "" then Logfile = logfolder & "\" & WScript.ScriptName & "[" & Replace(Replace(date & " "  & time, ":", "."),"/","-") & "]_Log.htm"

' =====================================================================================
' =====================================================================================
' Logfunction:
' =====================================================================================
' =====================================================================================



'============================================================================
'Generate Disk Table
'============================================================================
oIE_Document_write "<LEFT><Table border=1>"


'DIM objWMIService, objItem, colItems
'DIM strDriveType, strDiskSize, txt

SET objWMIService = GETOBJECT("winmgmts:\\" & "." & "\root\cimv2")
SET colItems = objWMIService.ExecQuery("Select * from Win32_LogicalDisk WHERE DriveType=3")
oIE_Document_write  "<B><TR>"

oIE_Document_write "<TD>Drive" & "</TD>"
oIE_Document_write  "<TD >" & vbtab & "Size" &  "</TD>"
oIE_Document_write  "<TD >" & vbtab & "Used" &  "</TD>"
oIE_Document_write  "<TD >" & vbtab & "Free" &  "</TD>"
oIE_Document_write  "<TD >" & vbtab & "Free(%)" &  "</TD>"
oIE_Document_write  "</TR></B>"

FOR EACH objItem in colItems
oIE_Document_write  "<TR>"
	DIM pctFreeSpace,strFreeSpace,strusedSpace

	if ucase(objItem.Name) = "C:" then
			iCFreeSpace  = Int(objItem.FreeSpace /1073741824)
			strCDiskSize = Int(objItem.Size /1073741824) & " Gb"
			strCFreeSpace = Int(objItem.FreeSpace /1073741824) & " Gb"
			ExitCode = iCFreeSpace
	End if
	pctFreeSpace = INT((objItem.FreeSpace / objItem.Size) * 1000)/10
	strDiskSize = Int(objItem.Size /1073741824) & " Gb"
	strFreeSpace = Int(objItem.FreeSpace /1073741824) & " Gb"
	strUsedSpace = Int((objItem.Size-objItem.FreeSpace)/1073741824) & " Gb"
oIE_Document_write  "<TD >"& objItem.Name & "</TD>"
oIE_Document_write  "<TD >" & strDiskSize & "</TD>"
oIE_Document_write  "<TD >" & strUsedSpace & "</TD>"
oIE_Document_write  "<TD >" & strFreeSpace & "</TD>"
oIE_Document_write  "<TD >" & pctFreeSpace &"</TD>"
oIE_Document_write  "</TR>"
NEXT

oIE_Document_write  "</TABLE>"

oIE_Document_write  "</LEFT>"
' =====================================================================================
' Creates a Excel Export file
' =====================================================================================
ExportVBS = fso.GetParentFolderName(fso.GetParentFolderName(WScript.ScriptFullName)) & "\Export_Log_result.vbs"


if fso.fileexists(ExportVBS) then


	strField = "Diskspace C-Drive"
	strValue = strCDiskSize & " of " & strCFreeSpace


	wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true


End if

' =====================================================================================
' Open logfile when finish unless running in SuperSilentMode
' =====================================================================================
if fso.fileexists(Logfile) and SuperSilentMode=False then wshshell.run chr(34) & Logfile & chr(34),1,false


' =====================================================================================
' Exit with error code
' =====================================================================================

if Exitcode <> "" then
  if SuperSilentMode = false then msgbox exitcode
  wscript.quit(exitcode)

elseIf Err.Number <> 0 Then

  oIE_Document_write "Error in " & WScript.ScriptName & ":"  & Err.Description
  Err.Clear
  wscript.quit(-1 * err.number)
 else
  wscript.quit
End If




' =====================================================================================
' =====================================================================================
' =====================================================================================
' Function Definitions
' =====================================================================================
' =====================================================================================
' =====================================================================================


' =====================================================================================
' Save2HTMLFile
' =====================================================================================

Function oIE_Document_write (strInput2)
on error resume next
	 Set oSaveToFile = FSO.OpenTextFile(Logfile, 8, true)
	 oSaveToFile.WriteLine(strInput2)
	 oSaveToFile.Close
End function