on error resume next
Set WSHShell = WScript.CreateObject( "WScript.Shell" )
Set fso = CreateObject("Scripting.FileSystemObject")
Set WshSysEnv = WshShell.Environment("PROCESS")
Dim Scriptpath: Scriptpath = fso.GetParentFolderName(WScript.ScriptFullName)
'Arguments:Logfolder/Logfile, Comment:
'Reports: The groups and users in Administrator group and if the user is a member of Administrators
'Exports: Username and level: ([Local Admin], [Power User], [Restricted User], [System Account])
'Returns: 1-4  ([Local Admin]=1, [Power User]=2, [Restricted User]=3, [System Account]=4)
' =====================================================================================
' Arguments
' =====================================================================================
If WScript.Arguments.Count >= 1   Then
Dim objArgs : set objArgs = Wscript.Arguments
Dim Logfolder

For iParam = 0 To WScript.Arguments.Count -1
 Select Case ucase(objArgs(iParam))
      Case "/SILENT", "SILENT", "/S"
            SilentMode = True
      Case "/SUPERSILENT", "SUPERSILENT", "/QB-"
            SuperSilentMode = True
            SilentMode = True
      Case "/SHOW"
      			SuperSilentMode = False
      Case "UAC"
      		AdminMode = True
      Case Else

		IF fso.folderexists(objArgs(iParam)) then
			LogFolder =  objArgs(iParam)
			SuperSilentMode = True
		elseIF fso.fileexists(objArgs(iParam)) then
			Logfile =  objArgs(iParam)
			SuperSilentMode = True
		ELSE

			if left(objArgs(iParam),8) = "COMMENT:" then strExportComment= mid(objArgs(iParam),9)
		end if
 End Select
 cmdarg = cmdarg & " " & chr(34) & objArgs(iParam) & chr(34)
Next
End if

' =====================================================================================
' Setting logfile if not set
' =====================================================================================

If Not fso.folderexists(logfolder) Then logfolder = WshSysEnv("Public") & "\Documents\Cadcraft_SystemLogs"
If Not fso.folderexists(logfolder) Then fso.createfolder(logfolder)
if LogFile = "" then Logfile = logfolder & "\" & WScript.ScriptName & "[" & Replace(Replace(date & " "  & time, ":", "."),"/","-") & "]_Log.htm"

' =====================================================================================
' =====================================================================================
' Programcode
' =====================================================================================
' =====================================================================================

' =====================================================================================
' Admin Membership
' =====================================================================================
Set dicLocalAdminGroups = CreateObject("scripting.dictionary")
Set dicDomainUserGroups = CreateObject("scripting.dictionary")


oIE_Document_write "<B>Checking membership in Local Administrator Group - for user: </B>" & wshSysEnv("USERDOMAIN") & "\" & wshSysEnv("Username")
  LocalAdminAccess = False
'oIE_Document_write  "&nbsp;&nbsp;&nbsp;Group:" & "Administratrer" & "<br>"
If CheckForUserInGroup( wshSysEnv("Username"),"WinNT://" & WshSysEnv("Computername") & "/" & "Administrators", "ALL",1) = true then
	  LocalAdminAccess=True
end if
if  CheckForUserInGroup( wshSysEnv("Username"),"WinNT://" & WshSysEnv("Computername") & "/" & "Administratrer", "ALL",1) = true then
		LocalAdminAccess=True
End if


	if right(wshSysEnv("Username"),1) = "$" then

				oIE_Document_write "<br><FONT color='blue' FACE='verdana,arial,helvetica' ><br>Note:</Font> User is running as 'SYSTEM' on this machine <br>"
				UserLevelTag = UserLevelTag & "[System Account]"
				ExitCode = 4
	elseif LocalAdminAccess = False then
		oIE_Document_write "<br><B>Checking membership in Power User Administrator Group -  </B>"
		 If CheckForUserInGroup( wshSysEnv("Username"),"WinNT://" & WshSysEnv("Computername") & "/" & "Power Users", "NONE",1) = true then
				oIE_Document_write "<br><FONT color='orange' FACE='verdana,arial,helvetica' ><br>Warning:</Font> User is only 'Power User' on this machine <br>"
				UserLevelTag = UserLevelTag & "[Power User]"
				ExitCode = 2
		else
				oIE_Document_write "<br><FONT color='orange' FACE='verdana,arial,helvetica' ><br>Warning:</Font> User is not local Administrator on this machine <br>"
				UserLevelTag = UserLevelTag & "[Restricted User]"
				ExitCode = 3
		 end if
		'oIE_Document_write  "&nbsp;&nbsp;&nbsp;Group:" & "Administratrer" & "<br>"
		'call CheckForUserInGroup("","WinNT://" & WshSysEnv("Computername") & "/" & "Administratrer", "FULL",1)

		'ErrorFound = True
	else
		oIE_Document_write "<br><FONT color='green'>Local Admin Access = OK<br></font>"
		LocalAdminAccess = True
		UserLevelTag = UserLevelTag & "[Local Admin]"
		ExitCode = 1
	end if

if LocalAdminAccess = False then
End if

' =====================================================================================
' Creates a Excel Export file
' =====================================================================================
oIE_Document_write "<BR><BR>"
ExportVBS = fso.GetParentFolderName(fso.GetParentFolderName(WScript.ScriptFullName)) & "\Export_Log_result.vbs"


if fso.fileexists(ExportVBS) then
	strField = "Username"
	strValue = wshSysEnv("Username")
	wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true
	strField = "Admin Level"
	strValue = UserLevelTag
	wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true
End if



' =====================================================================================
' Open logfile when finish unless running in SuperSilentMode
' =====================================================================================
if fso.fileexists(Logfile) and SuperSilentMode=False then wshshell.run chr(34) & Logfile & chr(34),1,false


' =====================================================================================
' Exit with error code
' =====================================================================================

if Exitcode <> "" then
  if SuperSilentMode = false then msgbox exitcode
  wscript.quit(exitcode)

elseIf Err.Number <> 0 Then

  oIE_Document_write "Error in " & WScript.ScriptName & ":"  & Err.Description
  Err.Clear
  wscript.quit(-1 * err.number)
 else
  wscript.quit
End If


' =====================================================================================
' =====================================================================================
' =====================================================================================
' Function Definitions
' =====================================================================================
' =====================================================================================
' =====================================================================================' =====================================================================================

Function CheckForUserInGroup(strUserName, strAdsPath, UIMODE, grouplevel)
On Error Resume Next
Dim Returnvalue

    Set oLocalGroup = GetObject(strAdsPath)
    oIE_Document_write "<br>"
    For iGroupCount = 0 To grouplevel
    oIE_Document_write "&nbsp;"
    Next
    oIE_Document_write "Searching in : " & strAdsPath
If IsObject(oLocalGroup) Then
    For Each objMember In oLocalGroup.Members

        If LCase(objMember.Class) <> "user" Then
        Else
            If LCase(strUserName) = LCase(objMember.Name) Then
                'if UIMODE <> "NONE" then
                oIE_Document_write "<B><FONT size=2>[" & objMember.Name & "]</FONT></B>"
                CheckForUserInGroup = True
            Else
                if UIMODE <> "NONE" then oIE_Document_write "<FONT size=2>[" & objMember.Name & "]</FONT>"
            End If
        End If
    Next

    For Each objMember In oLocalGroup.Members
    If IsObject(objMember) Then
        If LCase(objMember.Class) <> "user" Then
            'if UIMODE <> "NONE" then

            oIE_Document_write "<I>(" & objMember.Name & ")</I>"
            If CheckForUserInGroup(strUserName, objMember.AdsPath, UIMODE, grouplevel + 3) = True Then CheckForUserInGroup = True
        End If
        End If
    Next
Else
    oIE_Document_write " - Group not Found"
End If

End Function



Function oIE_Document_write (strInput2)
on error resume next
	 Set oSaveToFile = FSO.OpenTextFile(Logfile, 8, true)
	 oSaveToFile.WriteLine(strInput2)
	 oSaveToFile.Close
End function



