on error resume next
Set WSHShell = WScript.CreateObject( "WScript.Shell" )
Set fso = CreateObject("Scripting.FileSystemObject")
Set WshSysEnv = WshShell.Environment("PROCESS")
Dim Scriptpath: Scriptpath = fso.GetParentFolderName(WScript.ScriptFullName)
'Arguments:Logfolder/Logfile, Comment:
'Reports:
'Exports:
'Returns: 0
' =====================================================================================
' Arguments
' =====================================================================================
If WScript.Arguments.Count >= 1   Then
Dim objArgs : set objArgs = Wscript.Arguments
Dim Logfolder

For iParam = 0 To WScript.Arguments.Count -1
 Select Case ucase(objArgs(iParam))
      Case "/SILENT", "SILENT", "/S"
            SilentMode = True
      Case "/SUPERSILENT", "SUPERSILENT", "/QB-"
            SuperSilentMode = True
            SilentMode = True
      Case "/SHOW"
      			SuperSilentMode = False
      Case "UAC"
      		AdminMode = True
      Case Else

		IF fso.folderexists(objArgs(iParam)) then
			LogFolder =  objArgs(iParam)
			SuperSilentMode = True
		elseIF fso.fileexists(objArgs(iParam)) then
			Logfile =  objArgs(iParam)
			SuperSilentMode = True
		ELSE

			if left(objArgs(iParam),8) = "COMMENT:" then strExportComment= mid(objArgs(iParam),9)
		end if
 End Select
 cmdarg = cmdarg & " " & chr(34) & objArgs(iParam) & chr(34)
Next
End if

' =====================================================================================
' Setting logfile if not set
' =====================================================================================

If Not fso.folderexists(logfolder) Then logfolder = WshSysEnv("Public") & "\Documents\Cadcraft_SystemLogs"
If Not fso.folderexists(logfolder) Then fso.createfolder(logfolder)
if LogFile = "" then Logfile = logfolder & "\" & WScript.ScriptName & "[" & Replace(Replace(date & " "  & time, ":", "."),"/","-") & "]_Log.htm"

' =====================================================================================
' =====================================================================================
' Programcode
' =====================================================================================
' =====================================================================================


IIM_ClientPath = wshshell.regread("HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Cadcraft\iTools Install Manager Client\ClientPath")
if IIM_ClientPath = "" or not fso.FolderExists(IIM_ClientPath) then IIM_ClientPath =  fso.GetParentFolderName(fso.GetParentFolderName(Scriptpath)) & "\IIM_Server\Client2.1\"
'-----------------------------------------------------------------------------------------------------------------------
' Check for client-Path-to-Server-Settings
'-----------------------------------------------------------------------------------------------------------------------

IniFile = IIM_ClientPath & "Cadcraft_Deployment_Tool.ini"
'read values from ini-file

if fso.fileexists(IniFile) then
	Set file = fso.OpenTextFile(IniFile, 1)
		Do While Not file.AtEndOfStream
			strtext = file.ReadLine

			equalpos=instr(1,strText,"=",vbtextcompare)
			iniParam = mid(strText,1,equalpos-1)
			inivalue= mid(strText,equalpos +1)
			select Case   lcase(iniParam)
				Case "xmlroot"
					xmlroot = inivalue
				Case "exeroot"
					exeroot = inivalue
				Case "clientroot"
					clientroot = inivalue
				Case "dbfile"
					dbfile = inivalue
				Case "interval"
					interval = inivalue
				Case "password"
					password = inivalue
			end select
		Loop
	file.Close
End if

 IIM_Server = fso.GetParentFolderName(xmlroot)
 IIM_Root = fso.GetParentFolderName(IIM_Server)
 IIM_DbRoot = fso.GetParentFolderName(dbfile)

' =====================================================================================
' Folder Access
' =====================================================================================
if fso.fileexists(IniFile) then

oIE_Document_write "<B>Checking Folder Access -  </B>"
if fso.folderexists(IIM_DbRoot) = True then

	if CheckFolderAccess (IIM_DbRoot) = False then
		oIE_Document_write "<FONT color='red' FACE='verdana,arial,helvetica' >Error:</Font> User have not full access to the folder " & IIM_DbRoot  & "\DB<br>"
		ErrorFound = True
	else
		oIE_Document_write "<FONT color='green'>Folder Access [" & IIM_DbRoot &  "] = OK<br></font>"
	end if
End if

if fso.folderexists(fso.GetParentFolderName(Scriptpath) & "\IIM_Server\DB") = True then

	if CheckFolderAccess (fso.GetParentFolderName(Scriptpath) & "\IIM_Server\DB") = False then
		oIE_Document_write "<FONT color='red' FACE='verdana,arial,helvetica' >Error:</Font> User have not full access to the folder " & Scriptpath  & "\DB<br>"
		ErrorFound = True
	else
		oIE_Document_write "<FONT color='green'>Folder Access [" & fso.GetParentFolderName(Scriptpath) & "\IIM_Server\DB] = OK<br></font>"
	end if
End if
oIE_Document_write "<B>Checking Folder Access -  </B>"
if fso.folderexists(IIM_Server & "\Logfolder") = True then

	if CheckFolderAccess (IIM_Server & "\Logfolder") = False then
		oIE_Document_write "<FONT color='red' FACE='verdana,arial,helvetica' >Error:</Font> User have not full access to the folder " & IIM_Server & "\Logfolder<br>"
		ErrorFound = True
	else
		oIE_Document_write "<FONT color='green'>Folder Access [" & IIM_Server & "\Logfolder] = OK<br></font>"
	end if
End if

else

		oIE_Document_write "<FONT color='black'>iTools Install Manager Client or Server not Found<br></font>"

end if

' =====================================================================================
' File Access
' =====================================================================================

'oIE_Document_write "<B>Checking File Access -  </B>"
'
'	if fso.fileexists(fso.GetParentFolderName(Scriptpath) & "\IIM_Server\XML\Settings\StandardActionSettings.xml")  then
'		if CheckFileAcess (fso.GetParentFolderName(Scriptpath) & "\IIM_Server\XML\Settings\StandardActionSettings.xml") = False then
'			  oIE_Document_write "<FONT color='orange' FACE='verdana,arial,helvetica' >Error:</Font> User have not full access to the file " & Scriptpath  & "\XML\Settings\StandardActionSettings.xml" &  "<br>"
'			ErrorFound = False
'		else
'			oIE_Document_write "<FONT color='green'>File Access [" & fso.GetParentFolderName(Scriptpath) & "\IIM_Server\XML\Settings\StandardActionSettings.xml"& "]= OK<br></font>"
'		end if
'		Else
'				oIE_Document_write "<FONT color='orange'>File Missing [" & fso.GetParentFolderName(Scriptpath) & "\IIM_Server\XML\Settings\StandardActionSettings.xml"& "]= OK<br></font>"
'	End if


' =====================================================================================
' Creates a Excel Export file
' =====================================================================================
ExportVBS = fso.GetParentFolderName(fso.GetParentFolderName(WScript.ScriptFullName)) & "\Export_Log_result.vbs"


if fso.fileexists(ExportVBS) then

	strField = replace(wscript.scriptname, ".vbs", "")
	strValue = TemplateValue
	wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true

End if
' =====================================================================================
' Open logfile when finish unless running in SuperSilentMode
' =====================================================================================
if fso.fileexists(Logfile) and SuperSilentMode=False then wshshell.run chr(34) & Logfile & chr(34),1,false


' =====================================================================================
' Exit with error code
' =====================================================================================

if Exitcode <> "" then
  if SuperSilentMode = false then msgbox exitcode
  wscript.quit(exitcode)

elseIf Err.Number <> 0 Then

  oIE_Document_write "Error in " & WScript.ScriptName & ":"  & Err.Description
  Err.Clear
  wscript.quit(-1 * err.number)
 else
  wscript.quit
End If




' =====================================================================================
' =====================================================================================
' =====================================================================================
' Function Definitions
' =====================================================================================
' =====================================================================================
' =====================================================================================

Function CheckFolderAccess(Path)' As Boolean
    Dim fso 'As Scripting.FileSystemObject
    Dim Temp_Path 'As String

    Set fso = CreateObject("Scripting.FileSystemObject")

    Temp_Path = Path & "\" & fso.GetTempName() & ".tmp"

    On Error Resume Next
        fso.CreateTextFile Temp_Path
        CheckFolderAccess = Err.Number = 0
        fso.DeleteFile Temp_Path
'    On Error Goto 0

End Function



Function CheckFileAcess (strFilename)

Dim  fi                      ' object variable
Const ForAppending = 8          ' Append mode
Const ForWriting = 2           	' Writemode mode
Const ForReading = 1		' Reading mode
Dim Wshshell:   Set WSHShell = CreateObject( "WScript.Shell" )
Dim Fso:        Set fso = CreateObject("Scripting.FileSystemObject")
Dim Scriptpath  : scriptpath = fso.GetParentFolderName(ScriptFullName)


on error resume next
'strFilename = scriptpath  & "\test.htm"
'strFilename = "C:\hiberfil.sys"
Dim oFile
if fso.fileexists(strFilename) then

	set ofile = fso.getfile(strFilename)
	if ofile.attributes and 5 then
		CheckFileAcess=False
	else

		' open file, force create, if not exists
		Set fi = fso.OpenTextFile(strFilename, ForAppending, true)

		if err.number<> 0 then
		'msgbox err.number
		'msgbox err.description
		CheckFileAcess=False
		else
		CheckFileAcess = True
		end if
		Set fi = Nothing

	end if
else
	CheckFileAcess = False
end if
end function

Function oIE_Document_write (strInput2)
on error resume next
	 Set oSaveToFile = FSO.OpenTextFile(Logfile, 8, true)
	 oSaveToFile.WriteLine(strInput2)
	 oSaveToFile.Close
End function

