on error resume next
Set WSHShell = WScript.CreateObject( "WScript.Shell" )
Set fso = CreateObject("Scripting.FileSystemObject")
Set WshSysEnv = WshShell.Environment("PROCESS")
Dim Scriptpath: Scriptpath = fso.GetParentFolderName(WScript.ScriptFullName)
'Arguments:Logfolder/Logfile, Comment:
'Reports: Access to Windows Folder and Windows System Folder
'Exports: Access to Windows Folder
'Returns: Access to Windows Folder = 1  +  Windows System Folder = 2
' =====================================================================================
' Arguments
' =====================================================================================
If WScript.Arguments.Count >= 1   Then
Dim objArgs : set objArgs = Wscript.Arguments
Dim Logfolder

For iParam = 0 To WScript.Arguments.Count -1
 Select Case ucase(objArgs(iParam))
      Case "/SILENT", "SILENT", "/S"
            SilentMode = True
      Case "/SUPERSILENT", "SUPERSILENT", "/QB-"
            SuperSilentMode = True
            SilentMode = True
      Case "/SHOW"
      			SuperSilentMode = False
      Case "UAC"
      		AdminMode = True
      Case Else

		IF fso.folderexists(objArgs(iParam)) then
			LogFolder =  objArgs(iParam)
			SuperSilentMode = True
		elseIF fso.fileexists(objArgs(iParam)) then
			Logfile =  objArgs(iParam)
			SuperSilentMode = True
		ELSE

			if left(objArgs(iParam),8) = "COMMENT:" then strExportComment= mid(objArgs(iParam),9)
		end if
 End Select
 cmdarg = cmdarg & " " & chr(34) & objArgs(iParam) & chr(34)
Next
End if

' =====================================================================================
' Setting logfile if not set
' =====================================================================================

If Not fso.folderexists(logfolder) Then logfolder = WshSysEnv("Public") & "\Documents\Cadcraft_SystemLogs"
If Not fso.folderexists(logfolder) Then fso.createfolder(logfolder)
if LogFile = "" then Logfile = logfolder & "\" & WScript.ScriptName & "[" & Replace(Replace(date & " "  & time, ":", "."),"/","-") & "]_Log.htm"

' =====================================================================================
' =====================================================================================
' Programcode
' =====================================================================================
' =====================================================================================

' =====================================================================================
' Windows Access
' =====================================================================================
oIE_Document_write "<B>Checking Access  to Windows Folder -  </B>"
  if CheckFolderAccess (WshShell.ExpandEnvironmentStrings("%windir%")) = False then
  		oIE_Document_write "<FONT color='red' FACE='verdana,arial,helvetica' >Error:</Font> User have not full access to Windows<br>"
  		UserLevelTag = UserLevelTag & "[NoWin-Access]"
  			exitcode = exitcode + 1

  else
  	oIE_Document_write "<FONT color='green'>Windows Access = OK<br></font>"
  	UserLevelTag = UserLevelTag & "[FullWin-Access]"
  End if


oIE_Document_write "<B>Checking Sysfolder Access -  </B>"
	if CheckSysfolderAccess = False then
		oIE_Document_write "<FONT color='red' FACE='verdana,arial,helvetica' >Error:</Font> User have not full access to the windows system folder<br>"
		ErrorFound = True
		exitcode = exitcode + 2
	else
		oIE_Document_write "<FONT color='green'>Sysfolder Access = OK</FONT><BR>"
	end if

' =====================================================================================
' Creates a Excel Export file
' =====================================================================================
ExportVBS = fso.GetParentFolderName(fso.GetParentFolderName(WScript.ScriptFullName)) & "\Export_Log_result.vbs"


if fso.fileexists(ExportVBS) then


	strField = "Windows Folder Access"
	strValue = UserLevelTag
	wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true


End if


' =====================================================================================
' Open logfile when finish unless running in SuperSilentMode
' =====================================================================================
if fso.fileexists(Logfile) and SuperSilentMode=False then wshshell.run chr(34) & Logfile & chr(34),1,false


' =====================================================================================
' Exit with error code
' =====================================================================================

if Exitcode <> "" then
  if SuperSilentMode = false then msgbox exitcode
  wscript.quit(exitcode)

elseIf Err.Number <> 0 Then

  oIE_Document_write "Error in " & WScript.ScriptName & ":"  & Err.Description
  Err.Clear
  wscript.quit(-1 * err.number)
 else
  wscript.quit
End If




' =====================================================================================
' =====================================================================================
' =====================================================================================
' Function Definitions
' =====================================================================================
' =====================================================================================
' =====================================================================================

Function CheckFolderAccess(Path)' As Boolean
    Dim fso 'As Scripting.FileSystemObject
    Dim Temp_Path 'As String

    Set fso = CreateObject("Scripting.FileSystemObject")

    Temp_Path = Path & "\" & fso.GetTempName() & ".tmp"

    On Error Resume Next
        fso.CreateTextFile Temp_Path
        CheckFolderAccess = Err.Number = 0
        fso.DeleteFile Temp_Path
'    On Error Goto 0

End Function
' =====================================================================================
' CheckSysfolderAccess
' =====================================================================================

Function CheckSysfolderAccess ()
on error resume next
dim fso, strSysFolder, strFile, oFile
set fso = CreateObject("Scripting.FileSystemObject")
strSysFolder = fso.GetSpecialFolder(1) 'System Folder
strFile = strSysFolder & "\IsAdmin.txt"
set oFile = fso.CreateTextFile (strFile,True)
oFile.WriteLine "Delete Me"
oFile.Close
If Err.Number <> 0 Then
	CheckSysfolderAccess = False 'oIE_Document_write "Not an fileadmin"
Else
	CheckSysfolderAccess = True 'oIE_Document_write "Is an fileadmin"
	'Cleanup file
	fso.DeleteFile(strFile)
End If
End function

Function oIE_Document_write (strInput2)
on error resume next
	 Set oSaveToFile = FSO.OpenTextFile(Logfile, 8, true)
	 oSaveToFile.WriteLine(strInput2)
	 oSaveToFile.Close
End function

