'on error resume next
Set WSHShell = WScript.CreateObject( "WScript.Shell" )
Set fso = CreateObject("Scripting.FileSystemObject")
Set WshSysEnv = WshShell.Environment("PROCESS")
Dim Scriptpath: Scriptpath = fso.GetParentFolderName(WScript.ScriptFullName)
'Arguments:Logfolder/Logfile, Comment:
'Reports:Computername, Computer Model
'Exports: Computername, Computer Model
'Returns: 0
' =====================================================================================
' Arguments
' =====================================================================================
If WScript.Arguments.Count >= 1   Then
Dim objArgs : set objArgs = Wscript.Arguments
Dim Logfolder

For iParam = 0 To WScript.Arguments.Count -1
 Select Case ucase(objArgs(iParam))
      Case "/SILENT", "SILENT", "/S"
            SilentMode = True
      Case "/SUPERSILENT", "SUPERSILENT", "/QB-"
            SuperSilentMode = True
            SilentMode = True
      Case "/SHOW"
      			SuperSilentMode = False
      Case "UAC"
      		AdminMode = True
      Case Else

		IF fso.folderexists(objArgs(iParam)) then
			LogFolder =  objArgs(iParam)
			SuperSilentMode = True
		elseIF fso.fileexists(objArgs(iParam)) then
			Logfile =  objArgs(iParam)
			SuperSilentMode = True
		ELSE

			if left(objArgs(iParam),8) = "COMMENT:" then strExportComment= mid(objArgs(iParam),9)
		end if
 End Select
 cmdarg = cmdarg & " " & chr(34) & objArgs(iParam) & chr(34)
Next
End if

' =====================================================================================
' Setting logfile if not set
' =====================================================================================

If Not fso.folderexists(logfolder) Then logfolder = WshSysEnv("Public") & "\Documents\Cadcraft_SystemLogs"
If Not fso.folderexists(logfolder) Then fso.createfolder(logfolder)
if LogFile = "" then Logfile = logfolder & "\" & WScript.ScriptName & "[" & Replace(Replace(date & " "  & time, ":", "."),"/","-") & "]_Log.htm"

' =====================================================================================
' =====================================================================================
' Programcode
' =====================================================================================
' =====================================================================================
Dim iAntiVCount
'================================================================================================
' Antivirus
'================================================================================================

TotalAntivirusList = TotalAntivirusList & ListKillProcesses("F-Secure", False, False)
TotalAntivirusList = TotalAntivirusList & ListKillProcesses("McAfee", False, False)
TotalAntivirusList = TotalAntivirusList & ListKillProcesses("Trend Micro", False, False)
TotalAntivirusList = TotalAntivirusList & ListKillProcesses("Network Associates", False, False)
TotalAntivirusList = TotalAntivirusList & ListKillProcesses("Panda Antivirus", False, False)
TotalAntivirusList = TotalAntivirusList & ListKillProcesses("Panda Software", False, False)
TotalAntivirusList = TotalAntivirusList & ListKillProcesses("Panda Security", False, False)
TotalAntivirusList = TotalAntivirusList & ListKillProcesses("Avast", False, False)
TotalAntivirusList = TotalAntivirusList & ListKillProcesses("Command AntiVirus", False, False)
TotalAntivirusList = TotalAntivirusList & ListKillProcesses("Zone Labs", False, False)
TotalAntivirusList = TotalAntivirusList & ListKillProcesses("ZoneLabs", False, False)
TotalAntivirusList = TotalAntivirusList & ListKillProcesses("Microsoft AntiSpyware", False, False)
TotalAntivirusList = TotalAntivirusList & ListKillProcesses("NORMAN\nvc", False, False)
TotalAntivirusList = TotalAntivirusList & ListKillProcesses("NORMAN\", False, False)
TotalAntivirusList = TotalAntivirusList & ListKillProcesses("eTrustITM", False, False)
TotalAntivirusList = TotalAntivirusList & ListKillProcesses("eTrust AntiVirus", False, False)
TotalAntivirusList = TotalAntivirusList & ListKillProcesses("Symantec AntiVirus", False, False)
TotalAntivirusList = TotalAntivirusList & ListKillProcesses("SYMANT", False, False)
TotalAntivirusList = TotalAntivirusList & ListKillProcesses("kaspersky", False, False)
TotalAntivirusList = TotalAntivirusList & ListKillProcesses("bitdefender", False, False)
TotalAntivirusList = TotalAntivirusList & ListKillProcesses("Defender", False, False)
TotalAntivirusList = TotalAntivirusList & ListKillProcesses("MSMPENG", False, False)
TotalAntivirusList = TotalAntivirusList & ListKillProcesses("ESet", False, False)
TotalAntivirusList = TotalAntivirusList & ListKillProcesses("Quick Heal Antivirus", False, False)
TotalAntivirusList = TotalAntivirusList & ListKillProcesses("Online Protection", False, False)
TotalAntivirusList = TotalAntivirusList & ListKillProcesses("ONLINENT", False, False)

exitcode = iAntiVCount


' =====================================================================================
' Creates a Excel Export file
' =====================================================================================
ExportVBS = fso.GetParentFolderName(fso.GetParentFolderName(WScript.ScriptFullName)) & "\Export_Log_result.vbs"


if fso.fileexists(ExportVBS) then

	strField = "Antivirus Processes"
	strValue = TotalAntivirusList
	wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true

End if


' =====================================================================================
' Open logfile when finish unless running in SuperSilentMode
' =====================================================================================
if fso.fileexists(Logfile) and SuperSilentMode=False then wshshell.run chr(34) & Logfile & chr(34),1,false


' =====================================================================================
' Exit with error code
' =====================================================================================

if Exitcode <> "" then
  if SuperSilentMode = false then msgbox exitcode
  wscript.quit(exitcode)

elseIf Err.Number <> 0 Then

  oIE_Document_write "Error in " & WScript.ScriptName & ":"  & Err.Description
  Err.Clear
  wscript.quit(-1 * err.number)
 else
  wscript.quit
End If




' =====================================================================================
' =====================================================================================
' =====================================================================================
' Function Definitions
' =====================================================================================
' =====================================================================================
' =====================================================================================


'===========================================================
' List/Stop all processes with a given name
'===========================================================

Function ListKillProcesses (ProcessName, bolNameOnly,  bolKillProcess)
	strComputer = "."
	Set objWMI = GetObject("winmgmts:" & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")
	strWQL = "Select * from Win32_Process" ' "SELECT * FROM Win32_Process WHERE Name like '" & PROCESS_NAME & "'"



	   ProcessExist = False
	   Set colResults = objWMI.ExecQuery(strWQL)
	   ProcessList = ""
	   For Each objProcess In colResults

		if bolNameOnly = True then
			IF instr(1, objProcess.NAME, ProcessName, vbtextcompare) > 0  then

				ProcessExist = True
				if bolKillProcess = true then objProcess.Terminate
				ProcessList = objProcess.NAME & vblf
			End if
		else

			IF instr(1, objProcess.NAME, ProcessName, vbtextcompare) > 0 or instr(1, objProcess.ExecutablePath, ProcessName, vbtextcompare) > 0 then

				ProcessExist = True
				if bolKillProcess = true then objProcess.Terminate
				ProcessList = ProcessList & objProcess.ExecutablePath & "\" & objProcess.NAME & vblf
			End if
		end if
		'ServiceSearchResult = trim(ListStopService(objProcess.ProcessID, false))
		'if ServiceSearchResult <> "" then ProcessList = ProcessList & ServiceSearchResult & vblf

	   Next
			ServiceSearchResult = trim(ListApplicationService(ProcessName, false, false))
		if ServiceSearchResult <> "" then ProcessList = ProcessList & ServiceSearchResult & vblf
if ProcessList <> "" then
		iAntiVCount = iAntiVCount  + 1
		oIE_Document_write "Found: <A HREF='#' Title='" & ProcessList & "'>" & Processname & "</A><BR>"
		ListKillProcesses = Processname & " \ "
	End if



End Function
' ****************************************************************************
' This function lists all application service details of a computer
' ****************************************************************************
' Goto http://www.activxperts.com/activmonitor and click on WMI Samples
' for more samples
' ****************************************************************************

Function ListApplicationService(Processname, bolNameOnly,  bolKillProcess )
strComputer = "."
    Dim objWMIService, colItems

	Set objWMIService = GetObject("winmgmts:\\" & strComputer & "\root\cimv2")
	'Set colItems = objWMIService.ExecQuery("Select * from Win32_ApplicationService",,48)
	Set objWMIService = GetObject("winmgmts:" _
	    & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")

	Set colItems = objWMIService.ExecQuery _
	        ("Select * from Win32_Service")

	For Each objItem in colItems
	    'oIE_Document_write "Caption: " & objItem.Caption
	    'oIE_Document_write "CreationClassName: " & objItem.CreationClassName
	    'oIE_Document_write "Description: " & objItem.Description
	    'oIE_Document_write "InstallDate: " & objItem.InstallDate
	    'oIE_Document_write "Name: " & objItem.Name
	   ' oIE_Document_write "Path: " & objItem.Name
	    'oIE_Document_write "Started: " & objItem.Started
	    'oIE_Document_write "StartMode: " & objItem.StartMode
	    'oIE_Document_write "Status: " & objItem.Status
	    'oIE_Document_write "SystemCreationClassName: " & objItem.SystemCreationClassName
	    'oIE_Document_write "SystemName: " & objItem.SystemName
	    if bolNameOnly = True then
	    IF instr(1, objItem.Caption, ProcessName, vbtextcompare) > 0  then
	    ListApplicationService = ListApplicationService & objItem.Caption & ":[" & objItem.Status & "] - " & objItem.Description & vblf
	    oIE_Document_write "Name: " & objItem.Name
		Else
	    end if
	    IF instr(1, objItem.Caption, ProcessName, vbtextcompare) > 0  or instr(1, objItem.Pathname, ProcessName, vbtextcompare) > 0 then
	    ListApplicationService = ListApplicationService & objItem.Caption & ":[" & objItem.Status & "] - " & objItem.Description & vblf
	    oIE_Document_write "Name: " & objItem.Name
	    oIE_Document_write "Path: " & objItem.Pathname

	    end if
	    end if
	Next
End Function



Function ListStopService (ProcessID, bolKillNow)
	oIE_Document_write "searching for " & ProcessID
	strComputer = "."
	Set objWMI = GetObject("winmgmts:" & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")
	Set colItems = objWMI.ExecQuery("Select * from Win32_Service where ProcessId = " & ProcessID,,48)
	For Each objService In colItems
		if bolKillNow = true then
			objService.StopService
		End if
		ListStopService =  "Service: " &  objService.Name & " - " & objService.description

	Next

	'strService = "Network Associates McShield"
	'Set oService = GetObject("WinMgmts:{impersonationLevel=impersonate}!//" & strComputer & "/root/cimv2:Win32_Service.Name='" & strService & "'")

End Function

'-----------------------------------------------------------------------------------------------------------------------
' Function that replaces Dos Characters with Windows Characters
'-----------------------------------------------------------------------------------------------------------------------
Function ReplaceDOSChar( strText )
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,""," ")
	strText = Replace(strText,"  ","&nbsp;&nbsp;")
	ReplaceDOSChar = strText
End Function

'-----------------------------------------------------------------------------------------------------------------------
'Starting dos command and capture output
'-----------------------------------------------------------------------------------------------------------------------
Function CCGetCapuredDosValue (strDosCommand)
'WriteIEBold "Executing: " & strDosCommand
Dim objArguments
Set objShell = WScript.CreateObject("WScript.Shell")
Set objArguments = Wscript.Arguments
Set objShell = WScript.CreateObject("WScript.Shell")
Set objExecObject = objShell.Exec(strDosCommand)
Do While Not objExecObject.StdOut.AtEndOfStream
    strtext = replace(strtext,"          ", "  ")
    strText = objExecObject.StdOut.ReadLine()
    strText = ReplaceDOSChar(strText)
' Test or display strText

   CCGetCapuredDosValue = CCGetCapuredDosValue & "<BR>"  & strText

Loop


End Function



' =====================================================================================
' Write data to log-file
' =====================================================================================
Function oIE_Document_write (strInput2)
on error resume next
	 Set oSaveToFile = FSO.OpenTextFile(Logfile, 8, true)
	 oSaveToFile.WriteLine(strInput2)
	 oSaveToFile.Close
End function




'================================================================================================

wscript.quit

