on error resume next
Set WSHShell = WScript.CreateObject( "WScript.Shell" )
Set fso = CreateObject("Scripting.FileSystemObject")
Set WshSysEnv = WshShell.Environment("PROCESS")
Dim Scriptpath: Scriptpath = fso.GetParentFolderName(WScript.ScriptFullName)
'Arguments:Logfolder/Logfile, Comment:
'Reports: 	Event data for the last 168h - TotalErrorCount [ErrorsCount / Warningscount] and 200 last error/warning rows
'Exports:  	TotalErrorCount [ErrorsCount / Warningscount]
'Returns:  TotalErrorCount
' =====================================================================================
' Arguments
' =====================================================================================
If WScript.Arguments.Count >= 1   Then
Dim objArgs : set objArgs = Wscript.Arguments
Dim Logfolder

For iParam = 0 To WScript.Arguments.Count -1
 Select Case ucase(objArgs(iParam))
      Case "/SILENT", "SILENT", "/S"
            SilentMode = True
      Case "/SUPERSILENT", "SUPERSILENT", "/QB-"
            SuperSilentMode = True
            SilentMode = True
      Case "/SHOW"
      			SuperSilentMode = False
      Case "UAC"
      		AdminMode = True
      Case Else

		IF fso.folderexists(objArgs(iParam)) then
			LogFolder =  objArgs(iParam)
			SuperSilentMode = True
		elseIF fso.fileexists(objArgs(iParam)) then
			Logfile =  objArgs(iParam)
			SuperSilentMode = True
		ELSEif left(objArgs(iParam),8) = "COMMENT:" then
			strExportComment= mid(objArgs(iParam),9)
		Else
			hours2check = objArgs(iParam)
		end if
 End Select
 cmdarg = cmdarg & " " & chr(34) & objArgs(iParam) & chr(34)
Next
End if

' =====================================================================================
' Setting logfile if not set
' =====================================================================================

If Not fso.folderexists(logfolder) Then logfolder = WshSysEnv("Public") & "\Documents\Cadcraft_SystemLogs"
If Not fso.folderexists(logfolder) Then fso.createfolder(logfolder)
if LogFile = "" then Logfile = logfolder & "\" & WScript.ScriptName & "[" & Replace(Replace(date & " "  & time, ":", "."),"/","-") & "]_Log.htm"

' =====================================================================================
' =====================================================================================
' Programcode
' =====================================================================================
' =====================================================================================


if SuperSilentMode<>True and silentmode <> true and hours2check = "" then
	hours2check = cint(inputbox("Enter hours to check. 24=day, 168 = Week, 720=month", "Event Summary - Hours to Check", hours2check))
End if


IF hours2check = "" then hours2check = 168
hours2check = cint(hours2check)


If Not fso.folderexists(logfolder) Then logfolder = WshSysEnv("Temp")
strTempFile = logfolder & "\DosCapture_" &  Fso.GetTempName & ".log"
'-----------------------------------------------------------------------------------------------------------------------
'Starting IE Window
'-----------------------------------------------------------------------------------------------------------------------



           'oIE_Document_write "Running <B>'" & WScript.ScriptFullName & "'</B> at <B>'" & date & " "  & time  & "'</B><BR>"
           'oIE_Document_write "as user: <B>'" & WshSysEnv("Username") & "'</B> on computer <B>'" & WshSysEnv("Computername") & "'</B><BR>"


oIE_Document_write "<HTML>"
oIE_Document_write "<HEAD>"
oIE_Document_write "<style type='text/css'>"
oIE_Document_write " .row { vertical-align: top; height:auto !important; }"
oIE_Document_write " .list {display:none; }"
oIE_Document_write " .show {display: none; }"
oIE_Document_write " .hide:target + .show {display: inline; }"
oIE_Document_write " .hide:target {display: none; }"
oIE_Document_write " .hide:target ~ .list {display:inline; }"
oIE_Document_write " @media print { .hide, .show { display: none; } }"
oIE_Document_write " </style>"

oIE_Document_write "</HEAD>"
oIE_Document_write "<BODY>"

oIE_Document_write "<B>Checking eventlog for past " & hours2check & " hours</B>"

oIE_Document_write "<br>"


'----------------------------------------------------------------------------------------
' Skapar en lista ver events
'----------------------------------------------------------------------------------------
' EventTypeSummary
Set EventTypeSummary = CreateObject("scripting.dictionary")
Set EventSoureSummary = CreateObject("scripting.dictionary")
Set EventIDSummary = CreateObject("scripting.dictionary")
Set EventMsgSummary = CreateObject("scripting.dictionary")

Set EventLogonOffSummary = CreateObject("scripting.dictionary")
Set EventLogonOffCount = CreateObject("scripting.dictionary")

Set EventSoureErrorSummary = CreateObject("scripting.dictionary")
Set EventSoureWarningSummary = CreateObject("scripting.dictionary")

Set EventData = CreateObject("scripting.dictionary")
EventDataCount = 1000000
EventCode=1
strComputer = WshSysEnv("computername")
Dim TotalErrorCount
Dim TotalWarningCount

Set objWMIService = GetObject("winmgmts:"  & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")
'Set colLoggedEvents = objWMIService.ExecQuery  ("Select  * from Win32_NTLogEvent") ' Where EventCode = ' " & EventCode & "'")
Set colLoggedEvents = objWMIService.ExecQuery  ("Select  * from Win32_NTLogEvent  Where EventCode  = 6005 and Logfile = 'System'")

For Each objEvent in colLoggedEvents
TotalErrorCount = TotalErrorCount + 1
     EventDate = GetVBDate(objEvent.TimeGenerated)
If  DateDiff("h",EventDate, Now) <= hours2check Then
if  isObject(oIE) then oIE.StatusText = "Checking Logon " & EventDate & " Hour count: " & DateDiff("h",EventDate, Now) -1 & "/" & hours2check
if  isObject(oIE) then oIE.document.all.Item("status").InnerText= "Checking Logon " &  EventDate & " Hour count: " & DateDiff("h",EventDate, Now) -1 & "/" & hours2check


		if  EventLogonOffSummary.Exists(objEvent.Logfile & "-" & objEvent.SourceName) Then
			EventLogonOffSummary(objEvent.Logfile & "-" & objEvent.SourceName)=EventLogonOffSummary(objEvent.Logfile & "-" & objEvent.SourceName)+1
		else
			EventLogonOffSummary.Add objEvent.Logfile & "-" & objEvent.SourceName, 10001
		End if
		EventLogonOffCount.add EventDate, EventDate

	EventMessage = objEvent.Logfile & "-" & objEvent.SourceName & "-" & left(StripHTMLTags(objEvent.Message), 40)
	if  EventMsgSummary.Exists(EventMessage) Then
		EventMsgSummary(EventMessage)=EventMsgSummary(EventMessage)+1
	else
		EventMsgSummary.Add EventMessage, 10001
	End if

            if  objEvent.EventType = 1 then
            	EventDataString =   "  <TR>   <TD nowrap>" & EventDate  & "</TD><TD>" & "Error" & "</TD>"
            elseif  objEvent.EventType = 2 then
            	EventDataString =   "    <TR>  <TD nowrap>" & EventDate  & "</TD><TD>" & "Warning" & "</TD>"
            Else
            	EventDataString =   "    <TR>  <TD nowrap>" & EventDate  & "</TD><TD>" & "Information" & "</TD>"
            End if
            EventDataString = EventDataString & "    <TD nowrap><A href='http://www.eventid.net/display.asp?eventid=" & objEvent.EventCode & " &source=" & objEvent.SourceName & "' target=_blank>" & objEvent.EventCode  & "</A></TD>"
            EventDataString = EventDataString & "    <TD nowrap>" & objEvent.SourceName & "</TD>"
            EventDataString = EventDataString & "    <TD nowrap>" & objEvent.Logfile & "</TD>"
            EventDataString = EventDataString & "    <TD>" & StripHTMLTags(objEvent.Message)   & "</TD></TR>"

	EventData.Add EventDataCount, EventDataString
	EventDataCount = EventDataCount + 1


'       if  objEvent.EventType = 1 then oIE_Document_write  "    <TD>" & "Error" & "</TD>"
'       if  objEvent.EventType = 2 then oIE_Document_write  "    <TD>" & "Warning" & "</TD>"
           ' oIE_Document_write  "    <TR><TD nowrap><A href='http://www.eventid.net/display.asp?eventid=" & objEvent.EventCode & " &source=" & objEvent.SourceName & "' target=_blank>" & objEvent.EventCode  & "</A></TD>"
           ' oIE_Document_write  "    <TD nowrap>" & objEvent.SourceName & "</TD>"
           ' oIE_Document_write  "    <TD>" & StripHTMLTags(objEvent.Message)   & "</TD></TR>"
else
	exit for
End if





Next


Set objWMIService = GetObject("winmgmts:"  & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")
'Set colLoggedEvents = objWMIService.ExecQuery  ("Select  * from Win32_NTLogEvent") ' Where EventCode = ' " & EventCode & "'")
Set colLoggedEvents = objWMIService.ExecQuery  ("Select  * from Win32_NTLogEvent  Where (EventType  = 1 or EventType  = 2) and Logfile = 'Application'")

For Each objEvent in colLoggedEvents
TotalErrorCount = TotalErrorCount + 1
     EventDate = GetVBDate(objEvent.TimeGenerated)
If  DateDiff("h",EventDate, Now) <= hours2check Then
if  isObject(oIE) then oIE.StatusText = "Checking Application" & EventDate & " Hour count: " & DateDiff("h",EventDate, Now) -1 & "/" & hours2check
if  isObject(oIE) then oIE.document.all.Item("status").InnerText= "Checking Application " &  EventDate & " Hour count: " & DateDiff("h",EventDate, Now) -1 & "/" & hours2check


	if  EventTypeSummary.Exists(objEvent.EventType) Then
		EventTypeSummary(objEvent.EventType)=EventTypeSummary(objEvent.EventType)+1

	else
		EventTypeSummary.Add objEvent.EventType, 10001
	End if
'	if  EventSoureSummary.Exists(objEvent.SourceName) Then
'		EventSoureSummary(objEvent.SourceName)=EventSoureSummary(objEvent.SourceName)+1
'	else
'		EventSoureSummary.Add objEvent.SourceName, 10001
'	End if
	if  objEvent.EventType = 1 then
		if  EventSoureErrorSummary.Exists(objEvent.Logfile & "-" & objEvent.SourceName) Then
			EventSoureErrorSummary(objEvent.Logfile & "-" & objEvent.SourceName)=EventSoureErrorSummary(objEvent.Logfile & "-" & objEvent.SourceName)+1
		else
			EventSoureErrorSummary.Add objEvent.Logfile & "-" & objEvent.SourceName, 10001
		End if
	End if
	if  objEvent.EventType = 2 then

		if  EventSoureWarningSummary.Exists(objEvent.Logfile & "-" & objEvent.SourceName) Then
			EventSoureWarningSummary(objEvent.Logfile & "-" & objEvent.SourceName)=EventSoureWarningSummary(objEvent.Logfile & "-" & objEvent.SourceName)+1
		else
			EventSoureWarningSummary.Add objEvent.Logfile & "-" & objEvent.SourceName, 10001
		End if
	End if
'	if  EventIDSummary.Exists(objEvent.EventCode + 1000000 ) Then
'		EventIDSummary(objEvent.EventCode + 1000000)=EventIDSummary(objEvent.EventCode + 1000000)+1
'	else
'		EventIDSummary.Add objEvent.EventCode + 1000000, 10001
'	End if
	EventMessage = objEvent.Logfile & "-" & objEvent.SourceName & "-" & left(StripHTMLTags(objEvent.Message), 40)
	if  EventMsgSummary.Exists(EventMessage) Then
		EventMsgSummary(EventMessage)=EventMsgSummary(EventMessage)+1
	else
		EventMsgSummary.Add EventMessage, 10001
	End if
            if  objEvent.EventType = 1 then EventDataString =   "  <TR>   <TD nowrap>" & EventDate  & "</TD><TD>" & "Error" & "</TD>"
            if  objEvent.EventType = 2 then EventDataString =   "    <TR>  <TD nowrap>" & EventDate  & "</TD><TD>" & "Warning" & "</TD>"
            EventDataString = EventDataString & "    <TD nowrap><A href='http://www.eventid.net/display.asp?eventid=" & objEvent.EventCode & " &source=" & objEvent.SourceName & "' target=_blank>" & objEvent.EventCode  & "</A></TD>"
            EventDataString = EventDataString & "    <TD nowrap>" & objEvent.SourceName & "</TD>"
            EventDataString = EventDataString & "    <TD nowrap>" & objEvent.Logfile & "</TD>"
            EventDataString = EventDataString & "    <TD>" & StripHTMLTags(objEvent.Message)   & "</TD></TR>"

	EventData.Add EventDataCount, EventDataString
	EventDataCount = EventDataCount + 1


'       if  objEvent.EventType = 1 then oIE_Document_write  "    <TD>" & "Error" & "</TD>"
'       if  objEvent.EventType = 2 then oIE_Document_write  "    <TD>" & "Warning" & "</TD>"
           ' oIE_Document_write  "    <TR><TD nowrap><A href='http://www.eventid.net/display.asp?eventid=" & objEvent.EventCode & " &source=" & objEvent.SourceName & "' target=_blank>" & objEvent.EventCode  & "</A></TD>"
           ' oIE_Document_write  "    <TD nowrap>" & objEvent.SourceName & "</TD>"
           ' oIE_Document_write  "    <TD>" & StripHTMLTags(objEvent.Message)   & "</TD></TR>"
else
	exit for
End if





Next

Set objWMIService = GetObject("winmgmts:"  & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")
'Set colLoggedEvents = objWMIService.ExecQuery  ("Select  * from Win32_NTLogEvent") ' Where EventCode = ' " & EventCode & "'")
Set colLoggedEvents = objWMIService.ExecQuery  ("Select  * from Win32_NTLogEvent  Where (EventType  = 1 or EventType  = 2) and Logfile = 'System'")

For Each objEvent in colLoggedEvents
TotalErrorCount = TotalErrorCount + 1
     EventDate = GetVBDate(objEvent.TimeGenerated)
If  DateDiff("h",EventDate, Now) <= hours2check Then
if  isObject(oIE) then oIE.StatusText = "Checking System " & EventDate & " Hour count: " & DateDiff("h",EventDate, Now) -1 & "/" & hours2check
if  isObject(oIE) then oIE.document.all.Item("status").InnerText= "Checking System " &  EventDate & " Hour count: " & DateDiff("h",EventDate, Now) -1 & "/" & hours2check


	if  EventTypeSummary.Exists(objEvent.EventType) Then
		EventTypeSummary(objEvent.EventType)=EventTypeSummary(objEvent.EventType)+1

	else
		EventTypeSummary.Add objEvent.EventType, 10001
	End if
'	if  EventSoureSummary.Exists(objEvent.SourceName) Then
'		EventSoureSummary(objEvent.SourceName)=EventSoureSummary(objEvent.SourceName)+1
'	else
'		EventSoureSummary.Add objEvent.SourceName, 10001
'	End if
	if  objEvent.EventType = 1 then
		if  EventSoureErrorSummary.Exists(objEvent.Logfile & "-" & objEvent.SourceName) Then
			EventSoureErrorSummary(objEvent.Logfile & "-" & objEvent.SourceName)=EventSoureErrorSummary(objEvent.Logfile & "-" & objEvent.SourceName)+1
		else
			EventSoureErrorSummary.Add objEvent.Logfile & "-" & objEvent.SourceName, 10001
		End if
	End if
	if  objEvent.EventType = 2 then

		if  EventSoureWarningSummary.Exists(objEvent.Logfile & "-" & objEvent.SourceName) Then
			EventSoureWarningSummary(objEvent.Logfile & "-" & objEvent.SourceName)=EventSoureWarningSummary(objEvent.Logfile & "-" & objEvent.SourceName)+1
		else
			EventSoureWarningSummary.Add objEvent.Logfile & "-" & objEvent.SourceName, 10001
		End if
	End if
'	if  EventIDSummary.Exists(objEvent.EventCode + 1000000 ) Then
'		EventIDSummary(objEvent.EventCode + 1000000)=EventIDSummary(objEvent.EventCode + 1000000)+1
'	else
'		EventIDSummary.Add objEvent.EventCode + 1000000, 10001
'	End if
	EventMessage = objEvent.Logfile & "-" & objEvent.SourceName & "-" & left(StripHTMLTags(objEvent.Message), 40)
	if  EventMsgSummary.Exists(EventMessage) Then
		EventMsgSummary(EventMessage)=EventMsgSummary(EventMessage)+1
	else
		EventMsgSummary.Add EventMessage, 10001
	End if
            if  objEvent.EventType = 1 then EventDataString =   "  <TR>   <TD nowrap>" & EventDate  & "</TD><TD>" & "Error" & "</TD>"
            if  objEvent.EventType = 2 then EventDataString =   "    <TR>  <TD nowrap>" & EventDate  & "</TD><TD>" & "Warning" & "</TD>"
            EventDataString = EventDataString & "    <TD nowrap><A href='http://www.eventid.net/display.asp?eventid=" & objEvent.EventCode & " &source=" & objEvent.SourceName & "' target=_blank>" & objEvent.EventCode  & "</A></TD>"
            EventDataString = EventDataString & "    <TD nowrap>" & objEvent.SourceName & "</TD>"
            EventDataString = EventDataString & "    <TD nowrap>" & objEvent.Logfile & "</TD>"
            EventDataString = EventDataString & "    <TD>" & StripHTMLTags(objEvent.Message)   & "</TD></TR>"

	EventData.Add EventDataCount, EventDataString
	EventDataCount = EventDataCount + 1


'       if  objEvent.EventType = 1 then oIE_Document_write  "    <TD>" & "Error" & "</TD>"
'       if  objEvent.EventType = 2 then oIE_Document_write  "    <TD>" & "Warning" & "</TD>"
           ' oIE_Document_write  "    <TR><TD nowrap><A href='http://www.eventid.net/display.asp?eventid=" & objEvent.EventCode & " &source=" & objEvent.SourceName & "' target=_blank>" & objEvent.EventCode  & "</A></TD>"
           ' oIE_Document_write  "    <TD nowrap>" & objEvent.SourceName & "</TD>"
           ' oIE_Document_write  "    <TD>" & StripHTMLTags(objEvent.Message)   & "</TD></TR>"
else
	exit for
End if





Next

Set objWMIService = GetObject("winmgmts:"  & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")
'Set colLoggedEvents = objWMIService.ExecQuery  ("Select  * from Win32_NTLogEvent") ' Where EventCode = ' " & EventCode & "'")
Set colLoggedEvents = objWMIService.ExecQuery  ("Select  * from Win32_NTLogEvent  Where EventCode  = 7001 and Logfile = 'System'")

For Each objEvent in colLoggedEvents
TotalErrorCount = TotalErrorCount + 1
     EventDate = GetVBDate(objEvent.TimeGenerated)
If  DateDiff("h",EventDate, Now) <= hours2check Then
if  isObject(oIE) then oIE.StatusText = "Checking Logon " & EventDate & " Hour count: " & DateDiff("h",EventDate, Now) -1 & "/" & hours2check
if  isObject(oIE) then oIE.document.all.Item("status").InnerText= "Checking " &  EventDate & " Hour count: " & DateDiff("h",EventDate, Now) -1 & "/" & hours2check


		if  EventLogonOffSummary.Exists(objEvent.Logfile & "-" & objEvent.SourceName) Then
			EventLogonOffSummary(objEvent.Logfile & "-" & objEvent.SourceName)=EventLogonOffSummary(objEvent.Logfile & "-" & objEvent.SourceName)+1
		else
			EventLogonOffSummary.Add objEvent.Logfile & "-" & objEvent.SourceName, 10001
		End if

	EventMessage = objEvent.Logfile & "-" & objEvent.SourceName & "-" & left(StripHTMLTags(objEvent.Message), 40)
	if  EventMsgSummary.Exists(EventMessage) Then
		EventMsgSummary(EventMessage)=EventMsgSummary(EventMessage)+1
	else
		EventMsgSummary.Add EventMessage, 10001
	End if

            if  objEvent.EventType = 1 then
            	EventDataString =   "  <TR>   <TD nowrap>" & EventDate  & "</TD><TD>" & "Error" & "</TD>"
            elseif  objEvent.EventType = 2 then
            	EventDataString =   "    <TR>  <TD nowrap>" & EventDate  & "</TD><TD>" & "Warning" & "</TD>"
            Else
            	EventDataString =   "    <TR>  <TD nowrap>" & EventDate  & "</TD><TD>" & "Information" & "</TD>"
            End if
            EventDataString = EventDataString & "    <TD nowrap><A href='http://www.eventid.net/display.asp?eventid=" & objEvent.EventCode & " &source=" & objEvent.SourceName & "' target=_blank>" & objEvent.EventCode  & "</A></TD>"
            EventDataString = EventDataString & "    <TD nowrap>" & objEvent.SourceName & "</TD>"
            EventDataString = EventDataString & "    <TD nowrap>" & objEvent.Logfile & "</TD>"
            EventDataString = EventDataString & "    <TD>" & StripHTMLTags(objEvent.Message)   & "</TD></TR>"

	EventData.Add EventDataCount, EventDataString
	EventDataCount = EventDataCount + 1


'       if  objEvent.EventType = 1 then oIE_Document_write  "    <TD>" & "Error" & "</TD>"
'       if  objEvent.EventType = 2 then oIE_Document_write  "    <TD>" & "Warning" & "</TD>"
           ' oIE_Document_write  "    <TR><TD nowrap><A href='http://www.eventid.net/display.asp?eventid=" & objEvent.EventCode & " &source=" & objEvent.SourceName & "' target=_blank>" & objEvent.EventCode  & "</A></TD>"
           ' oIE_Document_write  "    <TD nowrap>" & objEvent.SourceName & "</TD>"
           ' oIE_Document_write  "    <TD>" & StripHTMLTags(objEvent.Message)   & "</TD></TR>"
else
	exit for
End if





Next
' ========================================================================================================
'oIE_Document_write  "<b>EventSoureErrorSummary</B><BR>"
SortDictionary EventSoureErrorSummary, 2

colKeys = EventSoureErrorSummary.Keys
For Each strKey in colKeys
        EventSoureErrorSummaryString = EventSoureErrorSummaryString &   EventSoureErrorSummary.Item(strKey) - 10000  & " = " & strKey &  vblf
Next
' ========================================================================================================
'oIE_Document_write  "<b>EventSoureWarningSummary</B><BR>"
SortDictionary EventSoureWarningSummary, 2

colKeys = EventSoureWarningSummary.Keys
For Each strKey in colKeys
        EventSoureWarningSummaryString = EventSoureWarningSummaryString &   EventSoureWarningSummary.Item(strKey) - 10000 & " = " & strKey & vblf
Next
' ========================================================================================================
if EventLogonOffCount.Count > 0 then
	SortDictionary EventLogonOffCount, 1

	colKeys = EventLogonOffCount.Keys
	For Each strKey in colKeys
			LogonDateList =LogonDateList &  strKey  & vblf
	Next
	oIE_Document_write  "<b><A HREF='#' Title='" & LogonDateList  & "'>EventLogonCount</B> = " & EventLogonOffCount.Count & "</A>" & " <BR>"
End if
' ========================================================================================================
' ========================================================================================================
'oIE_Document_write  "<b>EventTypeSummary</B><BR>"
SortDictionary EventTypeSummary, 1
colKeys = EventTypeSummary.Keys
For Each strKey in colKeys
		if strKey = 1 then
			oIE_Document_write  "<A HREF='#' Title='" & EventSoureErrorSummaryString  & "'>Errors</A>" & " = " & EventTypeSummary.Item(strKey) - 10000 & "<BR>"
			ErrorsCount = EventTypeSummary.Item(strKey) - 10000
		elseif strKey = 2 then
			oIE_Document_write  "<A HREF='#' Title='" & EventSoureWarningSummaryString  & "'>Warnings</A>" & " = " & EventTypeSummary.Item(strKey) - 10000 & "<BR>"
			WarningsCount = EventTypeSummary.Item(strKey) - 10000
		else

		oIE_Document_write  strKey & " = " & EventTypeSummary.Item(strKey) - 10000 & "<BR>"

		end if

Next




oIE_Document_write "<br>"
oIE_Document_write "<br>"

'if EventData.Count < 6000 then

oIE_Document_write " <div class='row'>"
oIE_Document_write "  <a href='#hide4' class='hide' id='hide4'>Show Last 200 Rows of Event Data</a>"
oIE_Document_write "  <a href='#show4' class='show' id='show4'>Hide Last 200 Rows of Event Data</a>"
oIE_Document_write "  <div class='list'>"
oIE_Document_write "  <ul>"
oIE_Document_write "  <li>"

oIE_Document_write  "<b>EventData</B><BR>"
               oIE_Document_write "<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=0 WIDTH='100%'>"
               oIE_Document_write "<TR ALIGN='left' VALIGN='middle'><TH>Datum</TH><TH>Typ</TH><TH>ID</TH><TH>Klla</TH><TH>Beskrivning</TH></TR>"


'SortDictionary EventData, 2

colKeys = EventData.Keys
iEventRowCount = 0
For Each strKey in colKeys
        oIE_Document_write   EventData.Item(strKey)

iEventRowCount = iEventRowCount + 1
if 	 iEventRowCount > 200 then exit for
Next
               oIE_Document_write "</TABLE>"



oIE_Document_write "  </li>"
oIE_Document_write "  </ul>"
oIE_Document_write "  </div>"
oIE_Document_write " </div>"
oIE_Document_write "</BODY>"
oIE_Document_write "</HTML>"
oIE_Document_write "<br>"
'End if

'
' ========================================================================================================
'oIE_Document_write  "<b>EventSoureSummary</B><BR>"
'SortDictionary EventSoureSummary, 2
'
'colKeys = EventSoureSummary.Keys
'For Each strKey in colKeys
'        oIE_Document_write  strKey & " = " & EventSoureSummary.Item(strKey) - 10000 & "<BR>"
'Next
' ========================================================================================================
'SortDictionary EventIDSummary, 1

'oIE_Document_write  "<b>EventIDSummary</B><BR>"
'colKeys = EventIDSummary.Keys
'For Each strKey in colKeys
'	'oIE_Document_write   strKey & "<br>"
'        oIE_Document_write  strKey - 1000000 & " = " & EventIDSummary.Item(strKey) - 10000 & "<BR>"
'Next
if  isObject(oIE) then oIE.document.all.Item("status").InnerText= "Done"

if  isObject(oIE) then oIE_Document_write "done"


oIE_Document_write  "<B>Total errors in EventLog: </B>" & TotalErrorCount

'-----------------------------------------------------------------------------------------------------------------------
' Adding info to Database
'-----------------------------------------------------------------------------------------------------------------------
strDBFile = fso.GetParentFolderName(scriptpath) & "\IIM_Server\DB\InstallManagerDB.sqlite"
strSQLiteExe = scriptpath & "\sqlite3.exe"
strQuery = "Update Computers set Eventlog  = '" & TotalErrorCount & "' where MachineName = '" & wshSysEnv("Computername") & "'"

if fso.fileexists(strDBFile) and  fso.fileexists(strSQLiteExe) then
	WriteIE "Updating Database with Query: " & strQuery
	strDosCommand = chr(34) & strSQLiteExe & chr(34) & " " &  chr(34) & strDBFile & chr(34) & " " & chr(34) & strQuery & chr(34)
	wshshell.run strDosCommand,0,true
End if

ExitCode = TotalErrorCount
' =====================================================================================
' Creates a Excel Export file
' =====================================================================================
ExportVBS = fso.GetParentFolderName(fso.GetParentFolderName(WScript.ScriptFullName)) & "\Export_Log_result.vbs"


if fso.fileexists(ExportVBS) then

	strField = "Eventlog"
	strValue = cstr(TotalErrorCount) & " [" & cstr(ErrorsCount) & " / " & cstr(Warningscount) & "]"
	wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true

End if




' =====================================================================================
' Open logfile when finish unless running in SuperSilentMode
' =====================================================================================
if fso.fileexists(Logfile) and SuperSilentMode=False then wshshell.run chr(34) & Logfile & chr(34),1,false


' =====================================================================================
' Exit with error code
' =====================================================================================

if Exitcode <> "" then
  if SuperSilentMode = false then msgbox exitcode
  wscript.quit(exitcode)

elseIf Err.Number <> 0 Then

  oIE_Document_write "Error in " & WScript.ScriptName & ":"  & Err.Description
  Err.Clear
  wscript.quit(-1 * err.number)
 else
  wscript.quit
End If




' =====================================================================================
' =====================================================================================
' =====================================================================================
' Function Definitions
' =====================================================================================
' =====================================================================================
' =====================================================================================





 '-----------------------------------------------------------------------------------------------------------------------
 ' Saving and closing window
 '-----------------------------------------------------------------------------------------------------------------------
If Not fso.folderexists(logfolder) Then logfolder = WshSysEnv("Temp")
strTempFile = logfolder & "\" & WScript.ScriptName & "_" &  Fso.GetTempName & ".log"

 if SuperSilentMode <> true then
	 TimeStamp=YEAR(now) & "-" & Right("00" & MONTH(now), 2) & "-" & DAY(NOW) & "_" & replace(TIME,":",".")
    'Call SaveToFile(logfolder & "\" & WScript.ScriptName & "_" & WshSysEnv("Computername") & "_Log_[" & TimeStamp & "].htm", oIE.Document.documentElement.OuterHTML, False)
   ' Call SaveToFile(logfolder & "\" & WScript.ScriptName & "_" & WshSysEnv("Computername") & "_Log_[" & TimeStamp & "].txt", oIE.Document.documentElement.innerText, False)
 end if
' =====================================================================================
' Open logfile when finish unless running in SuperSilentMode
' =====================================================================================
if fso.fileexists(Logfile) and SuperSilentMode=False then wshshell.run chr(34) & Logfile & chr(34),1,false

wscript.quit(cint(TotalErrorCount))


 if 		ErrorFound = True then
 	oIE_Document_write "<br><br><FONT color='red'>Check compleated - Errors or Warnings found</font>"
 '	if logfolder <> WshSysEnv("Temp") then oie.quit
 	wscript.quit(1603)

 else
 	oIE_Document_write "<br><br><FONT color='darkgreen'>Check compleated successfully</font>"
 	wscript.sleep 5000
 	'oie.quit
 	'if logfolder <> WshSysEnv("Temp") then oie.quit
 	if SuperSilentMode <> True AND logfolder <> WshSysEnv("Temp") then
 		if objArgs.Count <> 0 then oie.quit
 	end if
 	wscript.quit(cint(TotalErrorCount))
 end if


Sub UpdateSQLDataComputers (strDBFile,strField, strSQLValue )

ExecuteSQLQuery strDBFile, "Update Computers set " & strField & " = '" & strSQLValue & "' where MachineName = '" & wshSysEnv("Computername") & "'"


End Sub

Sub ExecuteSQLQuery (strDBFile, strQuery  )
strSQLiteExe = fso.GetParentFolderName(scriptpath) & "\IIM_Server\DB\Tools\sqlite3.exe"
if fso.fileexists(strDBFile) then
 if fso.fileexists(strSQLiteExe) then

	WriteIE "Executing: " & strQuery
	strDosCommand = 	chr(34) & strSQLiteExe & chr(34) & " " &  _
						chr(34) & strDBFile & chr(34) & " " &  _
						chr(34) & strQuery & chr(34)
	WriteIE strDosCommand
	Set objShell = WScript.CreateObject("WScript.Shell")
	Set objExecObject = objShell.Exec(strDosCommand)
	Do While Not objExecObject.StdOut.AtEndOfStream
	    strText = objExecObject.StdOut.ReadLine()
	   Update_Status_Field strText
	   WriteIE strText


	Loop

   Else
     WriteIE "Database not updated, SQL Engine File not found" & strSQLiteExe
 End if

  Else
    WriteIE "Database not updated, SQL Database not found" & strDBFile
  End if


End Sub

'=================== Functions ================================
Function GetVBDate(wd)
  GetVBDate = DateSerial(left(wd,4),mid(wd,5,2),mid(wd,7,2))+ TimeSerial(mid(wd,9,2),mid(wd,11,2),mid(wd,13,2))
End Function

Public Sub Send_Email
Set objMessage = CreateObject("CDO.Message")
objMessage.Subject = WScript.Arguments(0) & " - Event Log Monitor - Pull And Email - Past 24 Hours"
objMessage.From = "some_from_address@nowhere.com"
objMessage.AddAttachment = FileName
objMessage.To = EmailAddress
objMessage.TextBody = "Events For " & WScript.Arguments(0) & " Within The Last 24 Hours"

'==This section provides the configuration information for the remote SMTP server.
'==Normally you will only change the server name or IP.
objMessage.Configuration.Fields.Item _
("http://schemas.microsoft.com/cdo/configuration/sendusing") = 2
'Name or IP of Remote SMTP Server
objMessage.Configuration.Fields.Item _
("http://schemas.microsoft.com/cdo/configuration/smtpserver") = SMTPServer
'Server port (typically 25)
objMessage.Configuration.Fields.Item _
("http://schemas.microsoft.com/cdo/configuration/smtpserverport") = 25
objMessage.Configuration.Fields.Update
'==End remote SMTP server configuration section==
objMessage.Send

End Sub

Public Function StripHTMLTags(strContent)
    On Error Resume Next
    Dim mStartPos, mEndPos
    Dim i, j

       ' Start process
    mStartPos = InStr(strContent, "<")
    mEndPos = InStr(strContent, ">")
    Do While mStartPos <> 0 And mEndPos <> 0 And mEndPos > mStartPos
          mString = Mid(strContent, mStartPos, mEndPos - mStartPos + 1)
          strContent = Replace(strContent, mString, "")
          mStartPos = InStr(strContent, "<")
          mEndPos = InStr(strContent, ">")
    Loop
       ' Translate common escape sequence chars
    strContent = Replace(strContent, "&nbsp;", " ")
    strContent = Replace(strContent, "&amp;", "&")
    strContent = Replace(strContent, "&quot;", "'")
    strContent = Replace(strContent, "&#", "#")
    strContent = Replace(strContent, "&lt;", "<")
    strContent = Replace(strContent, "&gt;", ">")
    strContent = Replace(strContent, "%20", " ")
    strContent = LTrim(Trim(strContent))
    Do While Left(strContent, 1) = Chr(13) Or Left(strContent, 1) = Chr(10)
          strContent = Mid(strContent, 2)
    Loop
    Text1.Text = strContent
       ' If any angle brackets still exist, highlight the first one
    i = InStr(Text1.Text, "<")
    j = InStr(Text1.Text, ">")
    If j < i And j > 0 Then i = j
    If i > 0 Then
          Text1.SelStart = i - 1
          Text1.SelLength = 1
    ElseIf j > 0 Then
          Text1.SelStart = j - 1
          Text1.SelLength = 1
    End If
    StripHTMLTags = strContent
End Function



Function SortDictionary(objDict, intSort)
 ' Description:
 '   Sorts a dictionary by either key or item
 ' Parameters:
 '   objDict - the dictionary to sort
 '   intSort - the field to sort (1=key, 2=item)
 ' Returns:
 '   A dictionary sorted by intSort
 '
   ' declare constants
   Const dictKey  = 1
   Const dictItem = 2

   ' declare our variables
   Dim strDict()
   Dim objKey
   Dim strKey,strItem
   Dim X,Y,Z

   ' get the dictionary count
   Z = objDict.Count

   ' we need more than one item to warrant sorting
   If Z > 1 Then
     ' create an array to store dictionary information
     ReDim strDict(Z,2)
     X = 0
     ' populate the string array
     For Each objKey In objDict
         strDict(X,dictKey)  = CStr(objKey)
         strDict(X,dictItem) = CStr(objDict(objKey))
         X = X + 1
     Next

     ' perform a a shell sort of the string array
     For X = 0 To (Z - 2)
       For Y = X To (Z - 1)
         If StrComp(strDict(X,intSort),strDict(Y,intSort),vbTextCompare) > 0 Then
             strKey  = strDict(X,dictKey)
             strItem = strDict(X,dictItem)
             strDict(X,dictKey)  = strDict(Y,dictKey)
             strDict(X,dictItem) = strDict(Y,dictItem)
             strDict(Y,dictKey)  = strKey
             strDict(Y,dictItem) = strItem
         End If
       Next
     Next

     ' erase the contents of the dictionary object
     objDict.RemoveAll

     ' repopulate the dictionary with the sorted information
     For X = 0 To (Z - 1)
       objDict.Add strDict(X,dictKey), strDict(X,dictItem)
     Next

   End If

 End Function




' =====================================================================================
' Function to write Info to Log-file
' =====================================================================================
Function oIE_Document_write (strInput2)
on error resume next
	 Set oSaveToFile = FSO.OpenTextFile(Logfile, 8, true)
	 oSaveToFile.WriteLine(strInput2)
	 oSaveToFile.Close
End function

If Err.Number <> 0 Then
  oIE_Document_write "Error in " & WScript.ScriptName & ":"  & Err.Description
  Err.Clear
  wscript.quit(-1 * err.number)
End If