on error resume next
Set WSHShell = WScript.CreateObject( "WScript.Shell" )
Set fso = CreateObject("Scripting.FileSystemObject")
Set WshSysEnv = WshShell.Environment("PROCESS")
Dim Scriptpath: Scriptpath = fso.GetParentFolderName(WScript.ScriptFullName)
'Arguments:Logfolder/Logfile, Comment:
'Reports:Computername, Computer Model
'Exports: Computername, Computer Model
'Returns: 0
' =====================================================================================
' Arguments
' =====================================================================================
If WScript.Arguments.Count >= 1   Then
Dim objArgs : set objArgs = Wscript.Arguments
Dim Logfolder

For iParam = 0 To WScript.Arguments.Count -1
 Select Case ucase(objArgs(iParam))
      Case "/SILENT", "SILENT", "/S"
            SilentMode = True
      Case "/SUPERSILENT", "SUPERSILENT", "/QB-"
            SuperSilentMode = True
            SilentMode = True
      Case "/SHOW"
      			SuperSilentMode = False
      Case "UAC"
      		AdminMode = True
      Case Else

		IF fso.folderexists(objArgs(iParam)) then
			LogFolder =  objArgs(iParam)
			SuperSilentMode = True
		elseIF fso.fileexists(objArgs(iParam)) then
			Logfile =  objArgs(iParam)
			SuperSilentMode = True
		ELSE

			if left(objArgs(iParam),8) = "COMMENT:" then strExportComment= mid(objArgs(iParam),9)
		end if
 End Select
 cmdarg = cmdarg & " " & chr(34) & objArgs(iParam) & chr(34)
Next
End if

' =====================================================================================
' Setting logfile if not set
' =====================================================================================

If Not fso.folderexists(logfolder) Then logfolder = WshSysEnv("Public") & "\Documents\Cadcraft_SystemLogs"
If Not fso.folderexists(logfolder) Then fso.createfolder(logfolder)
if LogFile = "" then Logfile = logfolder & "\" & WScript.ScriptName & "[" & Replace(Replace(date & " "  & time, ":", "."),"/","-") & "]_Log.htm"

' =====================================================================================
' =====================================================================================
' Programcode
' =====================================================================================
' =====================================================================================

'const HKLM = &H80000002
Const HKEY_CLASSES_ROOT = &H80000000
Const HKEY_CURRENT_USER = &H80000001
Const HKEY_LOCAL_MACHINE = &H80000002
Dim TotalFolderCount
TotalFolderCount = 0
' =====================================================================================
' Folder redirection
' =====================================================================================
oIE_Document_write "<b>Checking Redirected folders in registry -  <br>" & "</B>"
if CheckShellFolderRedirection(HKEY_LOCAL_MACHINE, "Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders") or _
	CheckShellFolderRedirection(HKEY_LOCAL_MACHINE, "Software\Microsoft\Windows\CurrentVersion\Explorer\User Shell Folders")  or _
	CheckShellFolderRedirection(HKEY_CURRENT_USER, "Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders")  or _
	CheckShellFolderRedirection(HKEY_CURRENT_USER, "Software\Microsoft\Windows\CurrentVersion\Explorer\User Shell Folders")  = True then
	oIE_Document_write "<FONT color='orange' FACE='verdana,arial,helvetica' >Warning:</Font>Computer/User has redirected folders<br>"
else
		oIE_Document_write "<FONT color='green'>Folder Redirection = OK<br></font>"

End if

ExitCode = TotalFolderCount

' =====================================================================================
' Creates a Excel Export file
' =====================================================================================
ExportVBS = fso.GetParentFolderName(fso.GetParentFolderName(WScript.ScriptFullName)) & "\Export_Log_result.vbs"


if fso.fileexists(ExportVBS) then

	strField = "Folder_Redirection"
	strValue = TotalFolderCount
	wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true

End if
' =====================================================================================
' Open logfile when finish unless running in SuperSilentMode
' =====================================================================================
if fso.fileexists(Logfile) and SuperSilentMode=False then wshshell.run chr(34) & Logfile & chr(34),1,false


' =====================================================================================
' Exit with error code
' =====================================================================================

if Exitcode <> "" then
  if SuperSilentMode = false then msgbox exitcode
  wscript.quit(exitcode)

elseIf Err.Number <> 0 Then

  oIE_Document_write "Error in " & WScript.ScriptName & ":"  & Err.Description
  Err.Clear
  wscript.quit(-1 * err.number)
 else
  wscript.quit
End If


' =====================================================================================
' =====================================================================================
' =====================================================================================
' Function Definitions
' =====================================================================================
' =====================================================================================
' =====================================================================================


' =====================================================================================
' CheckShellFolderRedirection
' =====================================================================================

Function CheckShellFolderRedirection(RegRoot, keypath)
'dim keyPath
'keyPath = "Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders"

'const HKLM = X
'Const HKEY_CLASSES_ROOT = &H80000000
'Const HKEY_CURRENT_USER = &H80000001
'Const HKEY_LOCAL_MACHINE = &H80000002
IF RegRoot =  &H80000000 then
	RegRootString  =  "HKEY_CLASSES_ROOT"
elseIF RegRoot =  &H80000001 then
	RegRootString  =  "HKEY_CURRENT_USER"
elseIF RegRoot =  &H80000002 then
	RegRootString  =  "HKEY_LOCAL_MACHINE"
end if
oIE_Document_write "&nbsp;&nbsp;Checking Redirected folders in regpath: " & RegRootString & "\" & keypath & "<br>"

dim reg

dim valueNames, types
dim value
dim i

  set reg = getObject( "Winmgmts:root\default:StdRegProv" )

  if reg.enumValues( RegRoot, keyPath, valueNames, types ) = 0 then
    if isArray( valueNames ) then

      for i = 0 to UBound( valueNames )
        reg.getStringValue RegRoot, keyPath, valueNames(i), value
 	if UIMODE="SHOWALL" then oIE_Document_write( valueNames(i) & "=" & value ) & "<br>"
        if ucase(left(value,2)) = "C:" or ucase(left(value,2)) = "%U" or left(valueNames(i),1) = "!" then

        else
		TotalFolderCount = TotalFolderCount + 1
	CheckShellFolderRedirection = True
        oIE_Document_write( valueNames(i) & "=" & value ) & "<br>"

        End if
      next
    end if
  end if

 End function


' =====================================================================================
' Save2HTMLFile
' =====================================================================================

Function oIE_Document_write (strInput2)
on error resume next
	 Set oSaveToFile = FSO.OpenTextFile(Logfile, 8, true)
	 oSaveToFile.WriteLine(strInput2)
	 oSaveToFile.Close
End function

If Err.Number <> 0 Then
  oIE_Document_write "Error in " & WScript.ScriptName & ":"  & Err.Description
  Err.Clear
  wscript.quit(-1 * err.number)
End If