'on error resume next
Set WSHShell = WScript.CreateObject( "WScript.Shell" )
Set fso = CreateObject("Scripting.FileSystemObject")
Set WshSysEnv = WshShell.Environment("PROCESS")
Dim Scriptpath: Scriptpath = fso.GetParentFolderName(WScript.ScriptFullName)
'Arguments:Logfolder/Logfile, Comment:
'Reports: All services and services matchin criteria CAD or  VAULT
'Exports: number of All services and number services matchin criteria CAD or  VAULT
'Returns: number services matchin criteria CAD or  VAULT
' =====================================================================================
' Arguments
' =====================================================================================
If WScript.Arguments.Count >= 1   Then
Dim objArgs : set objArgs = Wscript.Arguments
Dim Logfolder

For iParam = 0 To WScript.Arguments.Count -1
 Select Case ucase(objArgs(iParam))
      Case "/SILENT", "SILENT", "/S"
            SilentMode = True
      Case "/SUPERSILENT", "SUPERSILENT", "/QB-"
            SuperSilentMode = True
            SilentMode = True
      Case "/SHOW"
      			SuperSilentMode = False
      Case "UAC"
      		AdminMode = True
      Case Else

		IF fso.folderexists(objArgs(iParam)) then
			LogFolder =  objArgs(iParam)
			SuperSilentMode = True
		elseIF fso.fileexists(objArgs(iParam)) then
			Logfile =  objArgs(iParam)
			SuperSilentMode = True
		ELSE

			if left(objArgs(iParam),8) = "COMMENT:" then strExportComment= mid(objArgs(iParam),9)
		end if
 End Select
 cmdarg = cmdarg & " " & chr(34) & objArgs(iParam) & chr(34)
Next
End if

' =====================================================================================
' Setting logfile if not set
' =====================================================================================

If Not fso.folderexists(logfolder) Then logfolder = WshSysEnv("Public") & "\Documents\Cadcraft_SystemLogs"
If Not fso.folderexists(logfolder) Then fso.createfolder(logfolder)
if LogFile = "" then Logfile = logfolder & "\" & WScript.ScriptName & "[" & Replace(Replace(date & " "  & time, ":", "."),"/","-") & "]_Log.htm"

' =====================================================================================
' =====================================================================================
' Programcode
' =====================================================================================
' =====================================================================================
Dim TotalProcessList
Dim TotalServiceList
iAntiVCount = 0
iTotalServiceADSKCADCount = 0
iTotalService = 0
bolTotalLogDone = False

'================================================================================================
' Antivirus
'================================================================================================
	oIE_Document_write "<HTML>"
		oIE_Document_write "<HEAD>"
		oIE_Document_write "<style type='text/css'>"
		oIE_Document_write " .row { vertical-align: top; height:auto !important; }"
		oIE_Document_write " .list {display:none; }"
		oIE_Document_write " .show {display: none; }"
		oIE_Document_write " .hide:target + .show {display: inline; }"
		oIE_Document_write " .hide:target {display: none; }"
		oIE_Document_write " .hide:target ~ .list {display:inline; }"
		oIE_Document_write " @media print { .hide, .show { display: none; } }"
		oIE_Document_write " </style>"

		oIE_Document_write "</HEAD>"
		oIE_Document_write "<BODY>"

TotalMatchServiceList = TotalMatchServiceList & ListApplicationService("CAD", Ture, False) &  "<br>"
TotalMatchServiceList = TotalMatchServiceList & ListApplicationService("CADRAFT", True, False) &  "<br>"
TotalMatchServiceList = TotalMatchServiceList & ListApplicationService("AUTODESK", True, False) &  "<br>"

oIE_Document_write "Total Number of Servicees: "  & cstr(iTotalService) & "<br>"
oIE_Document_write "Total Matched Servicees: "  & cstr(iTotalServiceADSKCADCount)
		strlicFileID = replace(replace(replace(wscript.scriptname, ":" , ""), "\" , ""), "." , "") & "1"
		oIE_Document_write " <div class='row'>"
		oIE_Document_write "  <a href='#hide" & strlicFileID &"' class='hide' id='hide" & strlicFileID &"'>Show  " & "All Service" & "</a>"
		oIE_Document_write "  <a href='#show" & strlicFileID &"' class='show' id='show" & strlicFileID &"'>Hide " & "All Service" & "</a>"
		oIE_Document_write "  <div class='list'>"
		oIE_Document_write "  <ul>"
		oIE_Document_write "  <li>"
			'Inputbox "", "",  TotalServiceList

				oIE_Document_write replace(TotalServiceList, vbcr, "<br>")

		oIE_Document_write "  </li>"
		oIE_Document_write "  </ul>"
		oIE_Document_write "  </div>"
		oIE_Document_write " </div>"
		oIE_Document_write "</BODY>"
		oIE_Document_write "</HTML>"


	strlicFileID = replace(replace(replace(wscript.scriptname, ":" , ""), "\" , ""), "." , "") & "3"

		oIE_Document_write " <div class='row'>"
		oIE_Document_write "  <a href='#hide" & strlicFileID &"' class='hide' id='hide" & strlicFileID &"'>Show  " & "All Matches" & "</a>"
		oIE_Document_write "  <a href='#show" & strlicFileID &"' class='show' id='show" & strlicFileID &"'>Hide " & "All Matches" & "</a>"
		oIE_Document_write "  <div class='list'>"
		oIE_Document_write "  <ul>"
		oIE_Document_write "  <li>"
				oIE_Document_write replace(TotalMatchServiceList, vbcr , "<br>")
		oIE_Document_write "  </li>"
		oIE_Document_write "  </ul>"
		oIE_Document_write "  </div>"
		oIE_Document_write " </div>"
		oIE_Document_write "</BODY>"
		oIE_Document_write "</HTML>"


ExitCode = iTotalServiceADSKCADCount
' =====================================================================================
' Creates a Excel Export file
' =====================================================================================
ExportVBS = fso.GetParentFolderName(fso.GetParentFolderName(WScript.ScriptFullName)) & "\Export_Log_result.vbs"


if fso.fileexists(ExportVBS) then

	strField = "Running_Servicees"
	strValue = cstr(iTotalService)  & " (" & cstr(iTotalServiceADSKCADCount) & ")"
	wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true

End if

' =====================================================================================
' Open logfile when finish unless running in SuperSilentMode
' =====================================================================================
if fso.fileexists(Logfile) and SuperSilentMode=False then wshshell.run chr(34) & Logfile & chr(34),1,false


' =====================================================================================
' Exit with error code
' =====================================================================================

if Exitcode <> "" then
  if SuperSilentMode = false then msgbox exitcode
  wscript.quit(exitcode)

elseIf Err.Number <> 0 Then

  oIE_Document_write "Error in " & WScript.ScriptName & ":"  & Err.Description
  Err.Clear
  wscript.quit(-1 * err.number)
 else
  wscript.quit
End If




' =====================================================================================
' =====================================================================================
' =====================================================================================
' Function Definitions
' =====================================================================================
' =====================================================================================
' =====================================================================================



Function GetOwner(ProcessName)
strComputer = "."
Set objWMIService = GetObject("winmgmts:" _
& "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")

Set colProcessList = objWMIService.ExecQuery("Select * from Win32_Process")

For Each objProcess in colProcessList
colProperties = objProcess.GetOwner(strNameOfUser,strUserDomain)
Wscript.Echo "Process " & objProcess.Name & " is owned by " _
& strUserDomain & "\" & strNameOfUser & "."
Next

End Function

' ****************************************************************************
' This function lists all application service details of a computer
' ****************************************************************************
' Goto http://www.activxperts.com/activmonitor and click on WMI Samples
' for more samples
' ****************************************************************************

Function ListApplicationService(Processname, bolNameOnly,  bolKillProcess )
on error goto 0
strComputer = "."
    Dim objWMIService, colItems

	Set objWMIService = GetObject("winmgmts:\\" & strComputer & "\root\cimv2")
	'Set colItems = objWMIService.ExecQuery("Select * from Win32_ApplicationService",,48)
	Set objWMIService = GetObject("winmgmts:" _
	    & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")

	Set colItems = objWMIService.ExecQuery _
	        ("Select * from Win32_Service")


	For Each objItem in colItems
	    'oIE_Document_write "Caption: " & objItem.Caption
	    'oIE_Document_write "CreationClassName: " & objItem.CreationClaspsName
	    'oIE_Document_write "Description: " & objItem.Description
	    'oIE_Document_write "InstallDate: " & objItem.InstallDate
	    'oIE_Document_write "Name: " & objItem.Name
	   ' oIE_Document_write "Path: " & objItem.Name
	    'oIE_Document_write "Started: " & objItem.Started
	    'oIE_Document_write "StartMode: " & objItem.StartMode
	    'oIE_Document_write "Status: " & objItem.Status
	    'oIE_Document_write "SystemCreationClassName: " & objItem.SystemCreationClassName
	    'oIE_Document_write "SystemName: " & objItem.SystemName
	    if bolNameOnly = True then
			IF ProcessName = "" or instr(1, ucase(objItem.Caption), ProcessName, vbtextcompare) > 0  then
			iTotalServiceADSKCADCount = iTotalServiceADSKCADCount + 1
			ListApplicationService = "[" & objItem.Started & "] " & ListApplicationService & objItem.Caption & ":- "  & "<br>" 'objItem.Description
			'oIE_Document_write "Name: " & objItem.Name
			end if
		Else


			IF ProcessName = "" or instr(1, objItem.Caption, ProcessName, vbtextcompare) > 0  or instr(1, objItem.Pathname, ProcessName, vbtextcompare) > 0 then
				iTotalServiceADSKCADCount = iTotalServiceADSKCADCount + 1
				ListApplicationService = "[" & objItem.Started & "] " & ListApplicationService & objItem.Caption & ":- " & objItem.Description & "<br>"
				'oIE_Document_write "Name: " & objItem.Name &  "<br>"
				'oIE_Document_write "Path: " & objItem.Pathname &  "<br>"
			end if
	    end if


		if 	bolTotalLogDone = False then
			iTotalService = iTotalService +1
			TotalServiceList = TotalServiceList & "[" & objItem.Started & "]" & "[" & objItem.StartMode & "]" &  objItem.Caption & "<br>" '  & "- " & objItem.Description & "<br>"
		End if


	Next
End Function



Function ListStopService (ProcessID, bolKillNow)
	oIE_Document_write "searching for " & ProcessID
	strComputer = "."
	Set objWMI = GetObject("winmgmts:" & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")
	Set colItems = objWMI.ExecQuery("Select * from Win32_Service where ProcessId = " & ProcessID,,48)
	For Each objService In colItems
		if bolKillNow = true then
			objService.StopService
		End if
		ListStopService =  "Service: " &  objService.Name & " - " & objService.description

	Next

	'strService = "Network Associates McShield"
	'Set oService = GetObject("WinMgmts:{impersonationLevel=impersonate}!//" & strComputer & "/root/cimv2:Win32_Service.Name='" & strService & "'")

End Function

'-----------------------------------------------------------------------------------------------------------------------
' Function that replaces Dos Characters with Windows Characters
'-----------------------------------------------------------------------------------------------------------------------
Function ReplaceDOSChar( strText )
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,""," ")
	strText = Replace(strText,"  ","&nbsp;&nbsp;")
	ReplaceDOSChar = strText
End Function

'-----------------------------------------------------------------------------------------------------------------------
'Starting dos command and capture output
'-----------------------------------------------------------------------------------------------------------------------
Function CCGetCapuredDosValue (strDosCommand)
'WriteIEBold "Executing: " & strDosCommand
Dim objArguments
Set objShell = WScript.CreateObject("WScript.Shell")
Set objArguments = Wscript.Arguments
Set objShell = WScript.CreateObject("WScript.Shell")
Set objExecObject = objShell.Exec(strDosCommand)
Do While Not objExecObject.StdOut.AtEndOfStream
    strtext = replace(strtext,"          ", "  ")
    strText = objExecObject.StdOut.ReadLine()
    strText = ReplaceDOSChar(strText)
' Test or display strText

   CCGetCapuredDosValue = CCGetCapuredDosValue & "<BR>"  & strText

Loop


End Function



' =====================================================================================
' Write data to log-file
' =====================================================================================
Function oIE_Document_write (strInput2)
on error resume next
	 Set oSaveToFile = FSO.OpenTextFile(Logfile, 8, true)
	 oSaveToFile.WriteLine(strInput2)
	 oSaveToFile.Close
End function




'================================================================================================

wscript.quit

