on error resume next
Set WSHShell = WScript.CreateObject( "WScript.Shell" )
Set fso = CreateObject("Scripting.FileSystemObject")
Set WshSysEnv = WshShell.Environment("PROCESS")
Dim Scriptpath: Scriptpath = fso.GetParentFolderName(WScript.ScriptFullName)
'Arguments:Logfolder/Logfile, Comment:
'Reports: if Offline sync is Active,  Enabled and its Location and files and Size in CSC folder
'Exports: if Offline sync is Active,  Enabled and its Location and files and Size in CSC folder
'Returns: Active = 1, Enabled = 2
' =====================================================================================
' Arguments
' =====================================================================================
If WScript.Arguments.Count >= 1   Then
Dim objArgs : set objArgs = Wscript.Arguments
Dim Logfolder

For iParam = 0 To WScript.Arguments.Count -1
 Select Case ucase(objArgs(iParam))
      Case "/SILENT", "SILENT", "/S"
            SilentMode = True
      Case "/SUPERSILENT", "SUPERSILENT", "/QB-"
            SuperSilentMode = True
            SilentMode = True
      Case "/SHOW"
      			SuperSilentMode = False
      Case "UAC"
      		AdminMode = True
      Case Else

		IF fso.folderexists(objArgs(iParam)) then
			LogFolder =  objArgs(iParam)
			SuperSilentMode = True
		elseIF fso.fileexists(objArgs(iParam)) then
			Logfile =  objArgs(iParam)
			SuperSilentMode = True
		ELSE

			if left(objArgs(iParam),8) = "COMMENT:" then strExportComment= mid(objArgs(iParam),9)
		end if
 End Select
 cmdarg = cmdarg & " " & chr(34) & objArgs(iParam) & chr(34)
Next
End if

' =====================================================================================
' Setting logfile if not set
' =====================================================================================

If Not fso.folderexists(logfolder) Then logfolder = WshSysEnv("Public") & "\Documents\Cadcraft_SystemLogs"
If Not fso.folderexists(logfolder) Then fso.createfolder(logfolder)
if LogFile = "" then Logfile = logfolder & "\" & WScript.ScriptName & "[" & Replace(Replace(date & " "  & time, ":", "."),"/","-") & "]_Log.htm"

' =====================================================================================
' =====================================================================================
' Programcode
' =====================================================================================
' =====================================================================================

'================================================================================================
' Get offline Sync Settings
'================================================================================================
OfflineSyncSettings = CCGetCapuredPlainDosValue("wmic path win32_offlinefilescache")

'msgbox OfflineSyncSetting

oIE_Document_write  " <B>Offline Sync Settings</B><Font Size=3 Face='Courier New', Courier, monospace>" &  CCGetCapuredDosValue("wmic path win32_offlinefilescache")  & "</FONT><BR>"

 GoOfflineOnSlowLink = wshshell.regread("HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\NetCache\GoOfflineOnSlowLink")
 GoOfflineOnSlowLink = wshshell.regread("HKEY_CURRENT_USER\Software\Policies\Microsoft\Windows\NetCache\DisableFRAdminPin")



' =====================================================================================
' Get list of offline files and size
' =====================================================================================
'	Const cWMINamespace = "root\cimv2"
'	Const cWMIComputerName = "LocalHost"
'	Const cWMIUserName = ""
'	Const cWMIPassword = ""
'	Dim objWMILocator : Set objWMILocator  = WScript.CreateObject("WbemScripting.SWbemLocator")
'	Dim objWMIServices : Set objWMIServices = objWMILocator.ConnectServer(cWMIComputerName, cWMINameSpace, cWMIUserName, cWMIPassword)
'	Dim objCache : Set objCache = objWMIServices.Get("Win32_OfflineFilesCache=@")
''	Dim objItemInstances : Set objItemInstances = objWMIServices.InstancesOf("Win32_OfflineFilesItem")
'
'	' Constants for cache item types
'	'
'	const cFile      = 0
'	const cDirectory = 1
'	Const cShare     = 2
'	const cServer    = 3
'
'	Dim CSCHomeDirStr
'	Dim objItem
'	For Each objItem in objItemInstances
'	    If cFile = objItem.ItemType Then
'	        oIE_Document_write  objItem.ItemPath & ": " & objItem.FileSysInfo.LocalSize & "<br>"
''	    End If
'	Next
Dim intFolderCount
Dim intFileCount
Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")

Set colItems = objWMIService.ExecQuery("SELECT ItemPath, FileSysInfo FROM Win32_OfflineFilesItem WHERE ItemType = 0")

for each objItem in colItems
	'oIE_Document_write objItem.ItemPath & ": " & objItem.FileSysInfo.LocalSize & "<br>"
	totalsize = totalsize + cint(objItem.FileSysInfo.LocalSize)
	intFileCount= intFileCount + 1
next


 if intFileCount > 0 then

	oIE_Document_write "Files in CSC folder: " & intFileCount & "<br>"
	oIE_Document_write "Size in CSC folder: " & totalsize / 1024  & " Mb" & "<br>"
End if

' CountFiles(WshSysEnv("C:\Windows\CSC"))
' if intFileCount > 0 then
'	oIE_Document_write "Folders in CSC folder: " & intFolderCount & "<br>"
'	oIE_Document_write "Files in CSC folder: " & intFileCount & "<br>"
'End if


' =====================================================================================
' Creates a Excel Export file
' =====================================================================================
ExportVBS = fso.GetParentFolderName(fso.GetParentFolderName(WScript.ScriptFullName)) & "\Export_Log_result.vbs"


if fso.fileexists(ExportVBS) then
	strField = "Offline_Sync"

	arrOfflineSyncSettings = split(OfflineSyncSettings,vbcr)
	arrRow1 = split(arrOfflineSyncSettings(0),"  ")
	arrRow2 = split(arrOfflineSyncSettings(2),"  ")
	if arrRow2(0) = "TRUE" then exitcode = exitcode + 1
	strValue = strValue  & arrRow1(0) & ": " & arrRow2(0) & " / "
	if arrRow2(1) = "TRUE" then exitcode = exitcode + 2
	strValue = strValue  & arrRow1(1) & ": " & arrRow2(1) & " / "
	strValue = strValue  & arrRow1(2) & ": " & arrRow2(2) & " / "


	strValue = strValue  & "Files: " &  intFileCount & " / Size: " & totalsize / 1024  & " Mb"
	wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true

End if
' =====================================================================================
' Open logfile when finish unless running in SuperSilentMode
' =====================================================================================
if fso.fileexists(Logfile) and SuperSilentMode=False then wshshell.run chr(34) & Logfile & chr(34),1,false


' =====================================================================================
' Exit with error code
' =====================================================================================

if Exitcode <> "" then
  if SuperSilentMode = false then msgbox exitcode
  wscript.quit(exitcode)

elseIf Err.Number <> 0 Then

  oIE_Document_write "Error in " & WScript.ScriptName & ":"  & Err.Description
  Err.Clear
  wscript.quit(-1 * err.number)
 else
  wscript.quit
End If


' =====================================================================================
' =====================================================================================
' =====================================================================================
' Function Definitions
' =====================================================================================
' =====================================================================================
' =====================================================================================


'-----------------------------------------------------------------------------------------------------------------------
' Function that replaces Dos Characters with Windows Characters
'-----------------------------------------------------------------------------------------------------------------------
Function ReplaceDOSChar( strText )
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,""," ")
	ReplaceDOSChar = strText
End Function

Function ReplaceDOSHTMLChar( strText )
	strText = Replace(strText,"  ","&nbsp;&nbsp;")
	ReplaceDOSHTMLChar = strText
End Function

'-----------------------------------------------------------------------------------------------------------------------
'Starting dos command and capture output
'-----------------------------------------------------------------------------------------------------------------------
Function CCGetCapuredDosValue (strDosCommand)
'WriteIEBold "Executing: " & strDosCommand
Dim objArguments
Set objShell = WScript.CreateObject("WScript.Shell")
Set objArguments = Wscript.Arguments
Set objShell = WScript.CreateObject("WScript.Shell")
Set objExecObject = objShell.Exec(strDosCommand)
Do While Not objExecObject.StdOut.AtEndOfStream
    strtext = replace(strtext,"          ", "  ")
    strText = objExecObject.StdOut.ReadLine()
    strText = ReplaceDOSChar(strText)
' Test or display strText

   CCGetCapuredDosValue = CCGetCapuredDosValue & "<BR>"  & strText

Loop


End Function
'-----------------------------------------------------------------------------------------------------------------------
'Starting dos command and capture output
'-----------------------------------------------------------------------------------------------------------------------
Function CCGetCapuredPlainDosValue (strDosCommand)
'Update_Status_Field "Executing: " & strDosCommand
Set objShell = WScript.CreateObject("WScript.Shell")
Set objExecObject = objShell.Exec(strDosCommand)
CCGetCapuredPlainDosValue = ""
Do While Not objExecObject.StdOut.AtEndOfStream
    strtext = replace(strtext,"          ", "  ")
    strText = objExecObject.StdOut.ReadLine()
    strText = ReplaceDOSChar(strText)


' Test or display strText
   'Update_Status_Field strText
if trim(strText) <> "" then
   if CCGetCapuredPlainDosValue = "" then
   CCGetCapuredPlainDosValue =  strText
   else
   CCGetCapuredPlainDosValue = CCGetCapuredPlainDosValue & vbcr  & strText
	End if
end if
Loop

End Function
'-----------------------------------------------------------------------------------------------------------------------
'Starting dos command and capture output
'-----------------------------------------------------------------------------------------------------------------------

Function CCGetCapuredDosValueHTML (strDosCommand)
'Update_Status_Field "Executing: " & strDosCommand
Set objShell = WScript.CreateObject("WScript.Shell")
Set objExecObject = objShell.Exec(strDosCommand)
Do While Not objExecObject.StdOut.AtEndOfStream
    strtext = replace(strtext,"          ", "  ")
    strText = objExecObject.StdOut.ReadLine()
    strText = ReplaceDOSChar(strText)
     strText = ReplaceDOSHTMLChar(strText)
' Test or display strText
   'Update_Status_Field strText
   CCGetCapuredDosValueHTML = CCGetCapuredDosValueHTML & "<BR>"  & strText

Loop

End Function
 Sub CountFiles(strFolder)
 '     On Error Resume Next
'oIE_Document_write strFolder & "<br>"
    Dim objFolder, objFiles, subfolder

    Set objFolder = fso.GetFolder(strFolder)
    Set objFiles = objFolder.Files
    intFileCount = intFileCount + objFiles.Count

    For Each subfolder In objFolder.SubFolders
    intFolderCount = intFolderCount + 1

    	CountFiles(subfolder.Path)
    Next
 End Sub




' =====================================================================================
' Save2HTMLFile
' =====================================================================================

Function oIE_Document_write (strInput2)
on error resume next
	 Set oSaveToFile = FSO.OpenTextFile(Logfile, 8, true)
	 oSaveToFile.WriteLine(strInput2)
	 oSaveToFile.Close
End function
