on error resume next
Set WSHShell = WScript.CreateObject( "WScript.Shell" )
Set fso = CreateObject("Scripting.FileSystemObject")
Set WshSysEnv = WshShell.Environment("PROCESS")
Dim Scriptpath: Scriptpath = fso.GetParentFolderName(WScript.ScriptFullName)
'Arguments:Logfolder/Logfile, Comment:
'Reports:Pending Window Updates
'Exports: Number of Pending Window Updates
'Returns: Number of Pending Window Updates
' =====================================================================================
' Arguments
' =====================================================================================
If WScript.Arguments.Count >= 1   Then
Dim objArgs : set objArgs = Wscript.Arguments
Dim Logfolder

For iParam = 0 To WScript.Arguments.Count -1
 Select Case ucase(objArgs(iParam))
      Case "/SILENT", "SILENT", "/S"
            SilentMode = True
      Case "/SUPERSILENT", "SUPERSILENT", "/QB-"
            SuperSilentMode = True
            SilentMode = True
      Case "/SHOW"
      			SuperSilentMode = False
      Case "UAC"
      		AdminMode = True
      Case Else

		IF fso.folderexists(objArgs(iParam)) then
			LogFolder =  objArgs(iParam)
			SuperSilentMode = True
		elseIF fso.fileexists(objArgs(iParam)) then
			Logfile =  objArgs(iParam)
			SuperSilentMode = True
		ELSE

			if left(objArgs(iParam),8) = "COMMENT:" then strExportComment= mid(objArgs(iParam),9)
		end if
 End Select
 cmdarg = cmdarg & " " & chr(34) & objArgs(iParam) & chr(34)
Next
End if

' =====================================================================================
' Setting logfile if not set
' =====================================================================================

If Not fso.folderexists(logfolder) Then logfolder = WshSysEnv("Public") & "\Documents\Cadcraft_SystemLogs"
If Not fso.folderexists(logfolder) Then fso.createfolder(logfolder)
if LogFile = "" then Logfile = logfolder & "\" & WScript.ScriptName & "[" & Replace(Replace(date & " "  & time, ":", "."),"/","-") & "]_Log.htm"

' =====================================================================================
' =====================================================================================
' Programcode
' =====================================================================================
' =====================================================================================



strTimestamp = date & " "  & time
'strTimestamp = Replace(timestamp, ":", ".")



Set updateSession = CreateObject("Microsoft.Update.Session")
Set updateSearcher = updateSession.CreateupdateSearcher()

'oIE_Document_write   "<br><br>Searching for updates..." & "<br><br><br>"


'Set searchResult =  updateSearcher.Search("IsInstalled=0 and Type='Software'")
Set searchResult = updateSearcher.Search("IsInstalled=0")
If searchResult.Updates.Count > 0 Then

          oIE_Document_write "<CENTER><Table width=100% border=1><tr><td><FONT color='Black' FACE='verdana,arial,helvetica' Style='font-size: 8pt'>"
oIE_Document_write  "<TR>"
oIE_Document_write  "<TD COLSPAN=3>"
oIE_Document_write  "<CENTER><FONT color='Blue' FACE='verdana,arial,helvetica' Style='font-size: 12pt'>"
oIE_Document_write   "List of applicable items on the machine:" & WshSysEnv("ComputerName") & " ["   & Date & " " & Time & "]"
oIE_Document_write  "</CENTER>"
oIE_Document_write  "</TD>"
oIE_Document_write  "</TR>"
oIE_Document_write  "<TR>"
oIE_Document_write  "<FONT color='Blue' FACE='verdana,arial,helvetica' Style='font-size: 7pt'>"
oIE_Document_write  "<td><FONT color='Black' FACE='verdana,arial,helvetica' Style='font-size: 8pt'>"
oIE_Document_write  ""
oIE_Document_write  "<TR>"
oIE_Document_write  "<TD>ID</TD>" & "<TD>Name</TD>" &   "<TD>Type</TD>" & "<TD>Mandatory</TD>" & "<TD>Date</TD>"
oIE_Document_write  "</TR>"

For I = 0 To searchResult.Updates.Count-1
    Set update = searchResult.Updates.Item(I)
    update_Description = replace(update.Description, "'", "")
    update_Description = replace(update_Description, chr(34), "")
    update_Description = replace(update_Description, "<", "[")
    update_Description = replace(update_Description, ">", "]")

oIE_Document_write  "<TR>"
   oIE_Document_write   "<TD>" & I + 1 & "</TD>"
   oIE_Document_write   "<TD><A Href='#' Title='" & update_Description & "'>" & update.Title & "</A></TD>"

   'oIE_Document_write   "<TD>" & update.Description & "</TD>"
   oIE_Document_write   "<TD>" & update.Type & "</TD>"
   oIE_Document_write   "<TD>" & update.isMandatory & "</TD>"
   oIE_Document_write   "<TD>" & update.LastDeploymentChangeTime & "</TD>"
oIE_Document_write  "</TR>"

Next
oIE_Document_write  "</FONT></CENTER></TR></TABLE>"
oIE_Document_write  "<BR><BR>"
oIE_Document_write  ""
oIE_Document_write  "</CENTER>"
else


oIE_Document_write   "There are no applicable updates - " & Date & " " & Time
'wscript.quit
End If


if 		ErrorFound = True then
	oIE_Document_write "<br><br><FONT color='red'>Check compleated - Errors or Warnings found</font>"
	if logfolder <> WshSysEnv("Temp") then oie.quit
	exitcode = 1603

else
	oIE_Document_write "<br><br><FONT color='darkgreen'>Check compleated successfully</font>"
	wscript.sleep 3000


	exitcode = searchResult.Updates.Count
end if
'-----------------------------------------------------------------------------------------------------------------------
' Adding info to Database
'-----------------------------------------------------------------------------------------------------------------------
strDBFile = fso.GetParentFolderName(scriptpath) & "\IIM_Server\DB\InstallManagerDB.sqlite"
strSQLiteExe = scriptpath & "\sqlite3.exe"
strQuery = "Update Computers set WinUpdate = '" & searchResult.Updates.Count & "' where MachineName = '" & wshSysEnv("Computername") & "'"

if fso.fileexists(strDBFile) and  fso.fileexists(strSQLiteExe) then
	WriteIE "Updating Database with Query: " & strQuery
	strDosCommand = chr(34) & strSQLiteExe & chr(34) & " " &  chr(34) & strDBFile & chr(34) & " " & chr(34) & strQuery & chr(34)
	wshshell.run strDosCommand,0,true
End if

	ExitCode = searchResult.Updates.Count

' =====================================================================================
' Creates a Excel Export file
' =====================================================================================
ExportVBS = fso.GetParentFolderName(fso.GetParentFolderName(WScript.ScriptFullName)) & "\Export_Log_result.vbs"


if fso.fileexists(ExportVBS) then

	strField = "Windows_Updates"
	strValue = cstr(searchResult.Updates.Count)
	wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true

End if


' =====================================================================================
' Open logfile when finish unless running in SuperSilentMode
' =====================================================================================
if fso.fileexists(Logfile) and SuperSilentMode=False then wshshell.run chr(34) & Logfile & chr(34),1,false


' =====================================================================================
' Exit with error code
' =====================================================================================

if Exitcode <> "" then
  if SuperSilentMode = false then msgbox exitcode
  wscript.quit(exitcode)

elseIf Err.Number <> 0 Then

  oIE_Document_write "Error in " & WScript.ScriptName & ":"  & Err.Description
  Err.Clear
  wscript.quit(-1 * err.number)
 else
  wscript.quit
End If




' =====================================================================================
' =====================================================================================
' =====================================================================================
' Function Definitions
' =====================================================================================
' =====================================================================================
' =====================================================================================







' =====================================================================================
' Save2HTMLFile
' =====================================================================================

Function oIE_Document_write (strInput2)
on error resume next
	 Set oSaveToFile = FSO.OpenTextFile(Logfile, 8, true)
	 oSaveToFile.WriteLine(strInput2)
	 oSaveToFile.Close
End function

If Err.Number <> 0 Then
  oIE_Document_write "Error in " & WScript.ScriptName & ":"  & Err.Description
  Err.Clear
  wscript.quit(-1 * err.number)
End If