on error resume next
Set WSHShell = WScript.CreateObject( "WScript.Shell" )
Set fso = CreateObject("Scripting.FileSystemObject")
Set WshSysEnv = WshShell.Environment("PROCESS")
Dim Scriptpath: Scriptpath = fso.GetParentFolderName(WScript.ScriptFullName)
'Arguments:Logfolder/Logfile, Comment:
'Reports:Computername, Computer Model
'Exports: Computername, Computer Model
'Returns: 0
' =====================================================================================
' Arguments
' =====================================================================================
If WScript.Arguments.Count >= 1   Then
Dim objArgs : set objArgs = Wscript.Arguments
Dim Logfolder

For iParam = 0 To WScript.Arguments.Count -1
 Select Case ucase(objArgs(iParam))
      Case "/SILENT", "SILENT", "/S"
            SilentMode = True
      Case "/SUPERSILENT", "SUPERSILENT", "/QB-"
            SuperSilentMode = True
            SilentMode = True
      Case "/SHOW"
      			SuperSilentMode = False
      Case "UAC"
      		AdminMode = True
      Case Else

		IF fso.folderexists(objArgs(iParam)) then
			LogFolder =  objArgs(iParam)
			SuperSilentMode = True
		elseIF fso.fileexists(objArgs(iParam)) then
			Logfile =  objArgs(iParam)
			SuperSilentMode = True
		ELSE

			if left(objArgs(iParam),8) = "COMMENT:" then strExportComment= mid(objArgs(iParam),9)
		end if
 End Select
 cmdarg = cmdarg & " " & chr(34) & objArgs(iParam) & chr(34)
Next
End if

' =====================================================================================
' Setting logfile if not set
' =====================================================================================

If Not fso.folderexists(logfolder) Then logfolder = WshSysEnv("Public") & "\Documents\Cadcraft_SystemLogs"
If Not fso.folderexists(logfolder) Then fso.createfolder(logfolder)
if LogFile = "" then Logfile = logfolder & "\" & WScript.ScriptName & "[" & Replace(Replace(date & " "  & time, ":", "."),"/","-") & "]_Log.htm"

' =====================================================================================
' =====================================================================================
' Programcode
' =====================================================================================
' =====================================================================================



'  This VBScript file includes sample code that enumerates
'  Windows Firewall rules using the Microsoft Windows Firewall APIs.
Set lstInComming = CreateObject("scripting.dictionary")
Set lstOutGoing = CreateObject("scripting.dictionary")


'Option Explicit

Dim CurrentProfiles
Dim InterfaceArray
Dim LowerBound
Dim UpperBound
Dim iterate
Dim rule

' Profile Type
Const NET_FW_PROFILE2_DOMAIN = 1
Const NET_FW_PROFILE2_PRIVATE = 2
Const NET_FW_PROFILE2_PUBLIC = 4

' Protocol
Const NET_FW_IP_PROTOCOL_TCP = 6
Const NET_FW_IP_PROTOCOL_UDP = 17
Const NET_FW_IP_PROTOCOL_ICMPv4 = 1
Const NET_FW_IP_PROTOCOL_ICMPv6 = 58

' Direction
Const NET_FW_RULE_DIR_IN = 1
Const NET_FW_RULE_DIR_OUT = 2

' Action
Const NET_FW_ACTION_BLOCK = 0
Const NET_FW_ACTION_ALLOW = 1


' Create the FwPolicy2 object.
Dim fwPolicy2
Set fwPolicy2 = CreateObject("HNetCfg.FwPolicy2")

CurrentProfiles = fwPolicy2.CurrentProfileTypes

'// The returned 'CurrentProfiles' bitmask can have more than 1 bit set if multiple profiles
'//   are active or current at the same time

if ( CurrentProfiles AND NET_FW_PROFILE2_DOMAIN ) then
   WriteIE("Domain Firewall Profile is active")
end if

if ( CurrentProfiles AND NET_FW_PROFILE2_PRIVATE ) then
   WriteIE("Private Firewall Profile is active")
end if

if ( CurrentProfiles AND NET_FW_PROFILE2_PUBLIC ) then
   WriteIE("Public Firewall Profile is active")
end if

' Get the Rules object
Dim RulesObject
Set RulesObject = fwPolicy2.Rules

' Print all the rules in currently active firewall profiles.
'WriteIE("Rules:")

For Each rule In Rulesobject
    if rule.Profiles And CurrentProfiles then
        'WriteIE("  Rule Name:          " & rule.Name)
        'WriteIE("   ----------------------------------------------")
        'WriteIE("  Description:        " & rule.Description)
        'WriteIE("  Application Name:   " & rule.ApplicationName)
        'WriteIE("  Service Name:       " & rule.ServiceName)
        Select Case rule.Protocol
            Case NET_FW_IP_PROTOCOL_TCP    'WriteIE("  IP Protocol:        TCP.")
            Case NET_FW_IP_PROTOCOL_UDP    'WriteIE("  IP Protocol:        UDP.")
            Case NET_FW_IP_PROTOCOL_ICMPv4 'WriteIE("  IP Protocol:        UDP.")
            Case NET_FW_IP_PROTOCOL_ICMPv6 'WriteIE("  IP Protocol:        UDP.")
            Case Else                      'WriteIE("  IP Protocol:        " & rule.Protocol)
        End Select
        if rule.Protocol = NET_FW_IP_PROTOCOL_TCP or rule.Protocol = NET_FW_IP_PROTOCOL_UDP then
            'WriteIE("  Local Ports:        " & rule.LocalPorts)
            'WriteIE("  Remote Ports:       " & rule.RemotePorts)
            'WriteIE("  LocalAddresses:     " & rule.LocalAddresses)
            'WriteIE("  RemoteAddresses:    " & rule.RemoteAddresses)
        end if
        if rule.Protocol = NET_FW_IP_PROTOCOL_ICMPv4 or rule.Protocol = NET_FW_IP_PROTOCOL_ICMPv6 then
            'WriteIE("  ICMP Type and Code:    " & rule.IcmpTypesAndCodes)
        end if
        Select Case rule.Direction
            Case NET_FW_RULE_DIR_IN
            	''WriteIE("  Direction:          In")
            	if  lstInComming.Exists(rule.Name) Then
				lstInComming(rule.Name)=lstInComming(rule.Name)+1
			else
				lstInComming.Add rule.Name, 10001
		End if
            	'lstInComming = lstInComming  & rule.Name & vblf
            	cntInComming = cntInComming + 1
            Case NET_FW_RULE_DIR_OUT
            	''WriteIE("  Direction:          Out")

		'lstOutGoing = lstOutGoing  & rule.Name & vblf
            	if  lstOutGoing.Exists(rule.Name) Then
				lstOutGoing(rule.Name)=lstOutGoing(rule.Name)+1
			else
				lstOutGoing.Add rule.Name, 10001
		End if

		cntOutGoing = cntOutGoing + 1

        End Select
        'WriteIE("  Enabled:            " & rule.Enabled)
        'WriteIE("  Edge:               " & rule.EdgeTraversal)
        Select Case rule.Action
            Case NET_FW_ACTION_ALLOW  'WriteIE("  Action:             Allow")
            Case NET_FW_ACTION_BLOCk  'WriteIE("  Action:             Block")
        End Select
        'WriteIE("  Grouping:           " & rule.Grouping)
        'WriteIE("  Edge:               " & rule.EdgeTraversal)
        'WriteIE("  Interface Types:    " & rule.InterfaceTypes)
        InterfaceArray = rule.Interfaces
        if IsEmpty(InterfaceArray) then
            'WriteIE("  Interfaces:         All")
        else
            LowerBound = LBound(InterfaceArray)
            UpperBound = UBound(InterfaceArray)
            'WriteIE("  Interfaces:     ")
            for iterate = LowerBound To UpperBound
                'WriteIE("       " & InterfaceArray(iterate))
            Next
        end if

        'WriteIE("")
    end if
Next
colKeys = lstInComming.Keys
For Each strKey in colKeys
        lstInCommingString = lstInCommingString &   lstInComming.Item(strKey) - 10000  & " = " & strKey &  vblf
Next
colKeys = lstOutGoing.Keys
For Each strKey in colKeys
        lstOutGoingString = lstOutGoingString &   lstOutGoing.Item(strKey) - 10000  & " = " & strKey &  vblf
Next

WriteIE "<A HREF='#' Title='" & lstInCommingString & "'>Incomming Rules:" & cntInComming & "</A>"
WriteIE "<A HREF='#' Title='" & lstOutGoingString & "'>OutGoing Rules:" & cntOutGoing & "</A>"


' =====================================================================================
' Creates a Excel Export file
' =====================================================================================
ExportVBS = fso.GetParentFolderName(fso.GetParentFolderName(WScript.ScriptFullName)) & "\Export_Log_result.vbs"


if fso.fileexists(ExportVBS) then

	strField = replace(wscript.scriptname, ".vbs", "")
	strValue = TemplateValue
	wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true

End if
' =====================================================================================
' Open logfile when finish unless running in SuperSilentMode
' =====================================================================================
if fso.fileexists(Logfile) and SuperSilentMode=False then wshshell.run chr(34) & Logfile & chr(34),1,false


' =====================================================================================
' Exit with error code
' =====================================================================================

if Exitcode <> "" then
  if SuperSilentMode = false then msgbox exitcode
  wscript.quit(exitcode)

elseIf Err.Number <> 0 Then

  oIE_Document_write "Error in " & WScript.ScriptName & ":"  & Err.Description
  Err.Clear
  wscript.quit(-1 * err.number)
 else
  wscript.quit
End If




' =====================================================================================
' =====================================================================================
' =====================================================================================
' Function Definitions
' =====================================================================================
' =====================================================================================
' =====================================================================================


' =====================================================================================
' Saves data to log-file
' =====================================================================================
Function WriteIE (strInput)
oIE_Document_write strInput & "<br>"
End Function

Function oIE_Document_write (strInput2)
on error resume next
	 Set oSaveToFile = FSO.OpenTextFile(Logfile, 8, true)
	 oSaveToFile.WriteLine(strInput2)
	 oSaveToFile.Close
End function

Function GetRegValue (strRegKey)
on error resume next
GetRegValue = wshshell.regread(strRegKey)
End function


