on error resume next
Set WSHShell = WScript.CreateObject( "WScript.Shell" )
Set fso = CreateObject("Scripting.FileSystemObject")
Set WshSysEnv = WshShell.Environment("PROCESS")
Dim Scriptpath: Scriptpath = fso.GetParentFolderName(WScript.ScriptFullName)
'Arguments:Logfolder/Logfile, Comment:
'Reports:Computername, Computer Model
'Exports: Computername, Computer Model
'Returns: 0
' =====================================================================================
' Arguments
' =====================================================================================
If WScript.Arguments.Count >= 1   Then
Dim objArgs : set objArgs = Wscript.Arguments
Dim Logfolder

For iParam = 0 To WScript.Arguments.Count -1
 Select Case ucase(objArgs(iParam))
      Case "/SILENT", "SILENT", "/S"
            SilentMode = True
      Case "/SUPERSILENT", "SUPERSILENT", "/QB-"
            SuperSilentMode = True
            SilentMode = True
      Case "/SHOW"
      			SuperSilentMode = False
      Case "UAC"
      		AdminMode = True
      Case Else

		IF fso.folderexists(objArgs(iParam)) then
			LogFolder =  objArgs(iParam)
			SuperSilentMode = True
		elseIF fso.fileexists(objArgs(iParam)) then
			Logfile =  objArgs(iParam)
			SuperSilentMode = True
		ELSE

			if left(objArgs(iParam),8) = "COMMENT:" then strExportComment= mid(objArgs(iParam),9)
		end if
 End Select
 cmdarg = cmdarg & " " & chr(34) & objArgs(iParam) & chr(34)
Next
End if

' =====================================================================================
' Setting logfile if not set
' =====================================================================================

If Not fso.folderexists(logfolder) Then logfolder = WshSysEnv("Public") & "\Documents\Cadcraft_SystemLogs"
If Not fso.folderexists(logfolder) Then fso.createfolder(logfolder)
if LogFile = "" then Logfile = logfolder & "\" & WScript.ScriptName & "[" & Replace(Replace(date & " "  & time, ":", "."),"/","-") & "]_Log.htm"

' =====================================================================================
' =====================================================================================
' Programcode
' =====================================================================================
' =====================================================================================



	 oIE_Document_write ccGetCapureDosValueIncludeFilter("schtasks.exe /Query ","Vault") &  ccGetCapureDosValueIncludeFilter("schtasks.exe /Query ","Cadcraft") &  ccGetCapureDosValueIncludeFilter("schtasks.exe /Query ","Backup")



' =====================================================================================
' Creates a Excel Export file
' =====================================================================================
ExportVBS = fso.GetParentFolderName(fso.GetParentFolderName(WScript.ScriptFullName)) & "\Export_Log_result.vbs"


if fso.fileexists(ExportVBS) then

	strField = replace(wscript.scriptname, ".vbs", "")
	strValue = TemplateValue
	wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true

End if
' =====================================================================================
' Open logfile when finish unless running in SuperSilentMode
' =====================================================================================
if fso.fileexists(Logfile) and SuperSilentMode=False then wshshell.run chr(34) & Logfile & chr(34),1,false


' =====================================================================================
' Exit with error code
' =====================================================================================

if Exitcode <> "" then
  if SuperSilentMode = false then msgbox exitcode
  wscript.quit(exitcode)

elseIf Err.Number <> 0 Then

  oIE_Document_write "Error in " & WScript.ScriptName & ":"  & Err.Description
  Err.Clear
  wscript.quit(-1 * err.number)
 else
  wscript.quit
End If




' =====================================================================================
' =====================================================================================
' =====================================================================================
' Function Definitions
' =====================================================================================
' =====================================================================================
' =====================================================================================


'=============================================================================
' Saves data to log-file
' =====================================================================================

Function oIE_Document_write (strInput2)
on error resume next
	 Set oSaveToFile = FSO.OpenTextFile(Logfile, 8, true)
	 oSaveToFile.WriteLine(strInput2)
	 oSaveToFile.Close
End function


Function CCGetScheduleTaskTable(strFilter)
on error goto 0
strComputer = "."
Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")

Set colScheduledJobs = objWMIService.ExecQuery _
    ("Select * from Win32_ScheduledJob")
CCGetScheduleTaskTable =   "<LEFT><Table border=0 width=100%>"

     CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & "Caption: " & "</TD>"
     CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & "Command: " & "</TD>"
     CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & "Days of Month: " & "</TD>"
     CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & "Days of Week: " & "</TD>"
     CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & "Description: " & "</TD>"
     CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & "Elapsed Time: " & "</TD>"
     CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & "Install Date: " & "</TD>"
     CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & "Interact with Desktop: " & "</TD>"
     CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & "Job ID: " & "</TD>"
     CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & "Job Status: " & "</TD>"
     CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & "Name: " & "</TD>"
     CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & "Notify: " & "</TD>"
     CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & "Owner: " & "</TD>"
     CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & "Priority: " & "</TD>"
     CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & "Run Repeatedly: " & "</TD>"
     CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & "Start Time: " & "</TD>"
     CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & "Status: " & "</TD>"
     CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & "Time Submitted: " & "</TD>"
     CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & "Until Time: " & "</TD>"
    CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "</TR >"
For Each objJob in colScheduledJobs

    CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & objJob.Caption & "</TD>"
    CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & objJob.Command & "</TD>"
    CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & objJob.DaysOfMonth & "</TD>"
    CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & objJob.DaysOfWeek & "</TD>"
    CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & objJob.Description & "</TD>"
    CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & objJob.ElapsedTime & "</TD>"
    CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & objJob.InstallDate & "</TD>"
    CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & objJob.InteractWithDesktop & "</TD>"
    CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & objJob.JobID & "</TD>"
    CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & objJob.JobStatus & "</TD>"
    CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & objJob.Name & "</TD>"
    CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & objJob.Notify & "</TD>"
    CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & objJob.Owner & "</TD>"
    CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & objJob.Priority & "</TD>"
    CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & objJob.RunRepeatedly & "</TD>"
    CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & objJob.StartTime & "</TD>"
    CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & objJob.Status & "</TD>"
    CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & objJob.TimeSubmitted & "</TD>"
    CCGetScheduleTaskTable = CCGetScheduleTaskTable &   "<TD >" & objJob.UntilTime & "</TD>"
    CCGetScheduleTaskTable = CCGetScheduleTaskTable &  "</FONT></TR>"
Next
    CCGetScheduleTaskTable = CCGetScheduleTaskTable &  "</TABLE>"

End Function

Function ccGetCapureDosValueIncludeFilter (strDosCommand, strFilter)
'WriteIEBold "Executing: " & strDosCommand & " | findstr " & strFilter
Dim objArguments
Set objShell = WScript.CreateObject("WScript.Shell")
Set objArguments = Wscript.Arguments
Set objShell = WScript.CreateObject("WScript.Shell")
Set objExecObject = objShell.Exec(strDosCommand)
Do While Not objExecObject.StdOut.AtEndOfStream
    strText = objExecObject.StdOut.ReadLine()
    strText = ReplaceDOSChar(strText)

' Test or display strText
  if instr(1,strText, strFilter, vbtextcompare) > 0 then
  	strtext = replace(strtext,"          ", "  ")

  	ccGetCapureDosValueIncludeFilter = ccGetCapureDosValueIncludeFilter & "<BR>"  & strText
  	else
  	'WriteIE strText

  end if
Loop
End Function

Function ReplaceDOSChar( strText )
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,"","")
	strText = Replace(strText,""," ")
	strText = Replace(strText,"  ","&nbsp;&nbsp;")
	ReplaceDOSChar = strText
End Function
