on error resume next
Set WSHShell = WScript.CreateObject( "WScript.Shell" )
Set fso = CreateObject("Scripting.FileSystemObject")
Set WshSysEnv = WshShell.Environment("PROCESS")
Dim Scriptpath: Scriptpath = fso.GetParentFolderName(WScript.ScriptFullName)
'Arguments:Logfolder/Logfile, Comment:
'Reports:Computername, Computer Model
'Exports: Computername, Computer Model
'Returns: 0
' =====================================================================================
' Arguments
' =====================================================================================
If WScript.Arguments.Count >= 1   Then
Dim objArgs : set objArgs = Wscript.Arguments
Dim Logfolder

For iParam = 0 To WScript.Arguments.Count -1
 Select Case ucase(objArgs(iParam))
      Case "/SILENT", "SILENT", "/S"
            SilentMode = True
      Case "/SUPERSILENT", "SUPERSILENT", "/QB-"
            SuperSilentMode = True
            SilentMode = True
      Case "/SHOW"
      			SuperSilentMode = False
      Case "UAC"
      		AdminMode = True
      Case Else

		IF fso.folderexists(objArgs(iParam)) then
			LogFolder =  objArgs(iParam)
			SuperSilentMode = True
		elseIF fso.fileexists(objArgs(iParam)) then
			Logfile =  objArgs(iParam)
			SuperSilentMode = True
		ELSE

			if left(objArgs(iParam),8) = "COMMENT:" then strExportComment= mid(objArgs(iParam),9)
		end if
 End Select
 cmdarg = cmdarg & " " & chr(34) & objArgs(iParam) & chr(34)
Next
End if

' =====================================================================================
' Setting logfile if not set
' =====================================================================================

If Not fso.folderexists(logfolder) Then logfolder = WshSysEnv("Public") & "\Documents\Cadcraft_SystemLogs"
If Not fso.folderexists(logfolder) Then fso.createfolder(logfolder)
if LogFile = "" then Logfile = logfolder & "\" & WScript.ScriptName & "[" & Replace(Replace(date & " "  & time, ":", "."),"/","-") & "]_Log.htm"

' =====================================================================================
' =====================================================================================
' Programcode
' =====================================================================================
' =====================================================================================




strComputer = "."
'********************************
'Enter Product Code Of The Application Here That You Want To Uninstall within the Bracket

'********************************
const HKEY_CURRENT_USER = &H80000001
const HKEY_LOCAL_MACHINE = &H80000002
const REG_SZ = 1
const REG_EXPAND_SZ = 2
const REG_BINARY = 3
const REG_DWORD = 4
const REG_MULTI_SZ = 7


'**************************
ADMSRegKey = "HKEY_LOCAL_MACHINE\SOFTWARE\Autodesk\PLM"
ADMSVersion = GetRegValue(ADMSRegKey & "\CurVersion")
strComputer = "."

if ADMSVersion <> "" then
Set oReg=GetObject("winmgmts:{impersonationLevel=impersonate}!\\" &_
strComputer & "\root\default:StdRegProv")

ADMSVersionRegKey = "SOFTWARE\Autodesk\PLM\" & ADMSVersion & "\Install"
oReg.EnumValues HKEY_LOCAL_MACHINE, ADMSVersionRegKey, arrValueNames, arrValueTypes
	For i=0 To UBound(arrValueNames)
		if arrValueTypes(i) = REG_SZ then

				RegValue =  WshShell.RegRead("HKEY_LOCAL_MACHINE\" & ADMSVersionRegKey & "\" & arrValueNames(i))

				oIE_Document_write arrValueNames(i) & " = " & RegValue & "<BR>"
		End if
	Next
ADMSVersionRegKey = "SOFTWARE\Autodesk\PLM\" & ADMSVersion & "\Common"
oReg.EnumValues HKEY_LOCAL_MACHINE, ADMSVersionRegKey, arrValueNames, arrValueTypes
	For i=0 To UBound(arrValueNames)
		if arrValueTypes(i) = REG_SZ then

				RegValue =  WshShell.RegRead("HKEY_LOCAL_MACHINE\" & ADMSVersionRegKey & "\" & arrValueNames(i))

				oIE_Document_write arrValueNames(i) & " = " & RegValue & "<BR>"
		End if
	Next


end if



if ADMSVersion  <> "" then

ADMSProduktverNo = mid(ADMSVersion, 33)



	strComputer  = "."
	Set oReg=GetObject("winmgmts:{impersonationLevel=impersonate}!\\" &_
	strComputer & "\root\default:StdRegProv")

	strKeyPath = "SOFTWARE\Autodesk\Autodesk Data Management Server Console\" & ADMSProduktverNo
	oReg.EnumKey HKEY_LOCAL_MACHINE, strKeyPath, arrSubKeys

	For Each subkey In arrSubKeys

			if left(subkey, 4) = "ADMS" then
					ADMSVersionRegKey = strKeyPath & "\" & Subkey
					oReg.EnumValues HKEY_LOCAL_MACHINE, ADMSVersionRegKey, arrValueNames, arrValueTypes
						For i=0 To UBound(arrValueNames)
							if arrValueTypes(i) = REG_SZ then

									RegValue =  WshShell.RegRead("HKEY_LOCAL_MACHINE\" & ADMSVersionRegKey & "\" & arrValueNames(i))

									oIE_Document_write arrValueNames(i) & " = " & RegValue & "<BR>"
							End if
						Next


			end if

			regkey = "HKEY_LOCAL_MACHINE\" & strKeyPath & "\" & subkey & "\"
			DisplayName =  GetRegValue(regkey)
			oIE_Document_write subkey
	Next

End if




' =====================================================================================
' Creates a Excel Export file
' =====================================================================================
ExportVBS = fso.GetParentFolderName(fso.GetParentFolderName(WScript.ScriptFullName)) & "\Export_Log_result.vbs"


if fso.fileexists(ExportVBS) then

	strField = replace(wscript.scriptname, ".vbs", "")
	strValue = TemplateValue
	wshshell.run chr(34) & ExportVBS & chr(34) &  " " & chr(34) & Logfile & chr(34) &  " " & chr(34) & strField & chr(34) &  " " & chr(34) & strValue & chr(34) &  " " & chr(34) & fso.GetParentFolderName(WScript.ScriptFullName) & chr(34)  & " " & chr(34) &  strExportComment & chr(34) , 1, true

End if
' =====================================================================================
' Open logfile when finish unless running in SuperSilentMode
' =====================================================================================
if fso.fileexists(Logfile) and SuperSilentMode=False then wshshell.run chr(34) & Logfile & chr(34),1,false


' =====================================================================================
' Exit with error code
' =====================================================================================

if Exitcode <> "" then
  if SuperSilentMode = false then msgbox exitcode
  wscript.quit(exitcode)

elseIf Err.Number <> 0 Then

  oIE_Document_write "Error in " & WScript.ScriptName & ":"  & Err.Description
  Err.Clear
  wscript.quit(-1 * err.number)
 else
  wscript.quit
End If




' =====================================================================================
' =====================================================================================
' =====================================================================================
' Function Definitions
' =====================================================================================
' =====================================================================================
' =====================================================================================

Function GetRegValue (strRegKey)
on error resume next
GetRegValue = wshshell.regread(strRegKey)
End function


' =====================================================================================
' Saves data to log-file
' =====================================================================================

Function oIE_Document_write (strInput2)
on error resume next
	 Set oSaveToFile = FSO.OpenTextFile(Logfile, 8, true)
	 oSaveToFile.WriteLine(strInput2)
	 oSaveToFile.Close
End function
